﻿Imports System.Reflection
Imports System.IO
Imports System.Windows.Forms
Imports NCDEnterprise

Partial Class NCDLib
    Public Class Enterprise
        Public Class System

            Public Class Alarm
                Public Shared Function State(ByRef ncdObj As NCDEnterprise.NCDController, Alarm As Byte)

                    If Alarm > 0 Then
                        Alarm = 1
                    End If
                    Dim aI(1) As Byte

                    aI(0) = 194         'Alarm Control
                    aI(1) = Alarm       'Control Alarm

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                    Return rData

                End Function
            End Class

            Public Class NumberCounters
                Public Shared Function IncreaseCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Control
                    aI(2) = 0           'Increase Counter Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
                Public Shared Function DecreaseCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Control
                    aI(2) = 1           'Decrease Counter Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
                Public Shared Function SetCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte, UInt As UInteger) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(6) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Control
                    aI(2) = 2           'Set Counter Value Function
                    aI(3) = NCDLib.Math.GetMSB32_LSW_LSB(UInt)   'Set Value LSW_LSB = Least Significant Word, Least Significant Byte
                    aI(4) = NCDLib.Math.GetMSB32_LSW_MSB(UInt)   'Set Value LSW_MSB = Least Significant Word, Most Significant Byte
                    aI(5) = NCDLib.Math.GetMSB32_MSW_LSB(UInt)   'Set Value MSW_LSB = Most Significant Word, Least Significant Byte
                    aI(6) = NCDLib.Math.GetMSB32_MSW_MSB(UInt)   'Set Value MSW_MSB = Most Significant Word, Most Significant Byte
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function

                Public Shared Function ReadCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Read
                    aI(2) = 3           'Get Counter Value Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
                Public Shared Function ResetCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Read
                    aI(2) = 4           'Clear Counter Value Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
            End Class
            Public Class Diagnostics

                Public Shared Function Read(ByRef ncdObj As NCDEnterprise.NCDController) As Byte()

                    Dim I(1) As Byte

                    I(0) = 189                'Byte 0
                    I(1) = 0                  'Byte 1

                    NCDLib.WriteBytesAPI(ncdObj, True, I)

                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    'If (Not (rData Is Nothing)) Then

                    Return rData

                    'End If

                End Function

                Public Shared Function ClearI2CPorts(ByRef ncdObj As NCDEnterprise.NCDController) As Byte()
                    Dim I(2) As Byte

                    I(0) = 189                'Byte 0
                    I(1) = 0                  'Byte 1
                    I(2) = 85                 'Reset I2C Ports Command

                    NCDLib.WriteBytesAPI(ncdObj, True, I)

                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    'If (Not (rData Is Nothing)) Then

                    Return rData

                    'End If
                End Function

                Public Shared Function InitI2CPorts(ByRef ncdObj As NCDEnterprise.NCDController) As Byte()
                    Dim I(2) As Byte

                    I(0) = 189                'Byte 0
                    I(1) = 0                  'Byte 1
                    I(2) = 86                 'Reset I2C Ports Command

                    NCDLib.WriteBytesAPI(ncdObj, True, I)

                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    'If (Not (rData Is Nothing)) Then

                    Return rData

                    'End If
                End Function

            End Class
        End Class

        Public Class E3C
            Public Shared Sub EnableAllDevices(ByRef ncdObj As NCDEnterprise.NCDController)
                Dim aI(1) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 248         'Enable All Devices
                NCDLib.WriteBytesAPI(ncdObj, True, aI)
            End Sub
            Public Shared Sub DisableAllDevices(ByRef ncdObj As NCDEnterprise.NCDController)
                Dim aI(1) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 249         'Disable All Devices
                NCDLib.WriteBytesAPI(ncdObj, True, aI)
            End Sub
            Public Shared Function EnableSelectedDevice(ByRef ncdObj As NCDEnterprise.NCDController, Device As Byte)
                Dim aI(2) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 252         'Enable a Specific Device Command
                aI(2) = Device      'Device to Enable
                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)      'Device will E3C Device Number
                Return rData
            End Function
        End Class

        Public Class Setup
            ' Public Class Process
            '     Public Shared Function Change_to_Baud(ByRef ncdobj As NCD.NCDComponent, Port As Integer, Baud As Array)
            '
            '         Change_to_Baud = False
            '         'Go into Configuration Mode
            '         NCDLib.Enterprise.Setup.ConfigurationMode(ncdobj, 10)
            '         NCDLib.Enterprise.Setup.Change.Baud_Rate(ncdobj, Port, Baud)
            '         NCDLib.Enterprise.Setup.ConfigurationMode(ncdobj, 0)
            '         NCDLib.Enterprise.Setup.Reboot_Soft(ncdobj)
            '         Change_to_Baud = True
            '         Return Change_to_Baud
            '
            '     End Function
            ' End Class
            Public Class Change
                Public Shared Function BaudChipValueToText(Setting As Integer)

                    Debug.Print("CHIP TO UI: " + Setting.ToString)

                    Select Case Setting
                        Case 0
                            BaudChipValueToText = "9600 Baud -0.08% Timing Error"
                        Case 1
                            BaudChipValueToText = "19.2K Baud +0.16% Timing Error"
                        Case 2
                            BaudChipValueToText = "38.4K Baud +0.16% Timing Error"
                        Case 3
                            BaudChipValueToText = "57.6K Baud -0.79% Timing Error"
                        Case 4
                            BaudChipValueToText = "115.2K Baud -0.79% Timing Error (Default)"
                        Case 5
                            BaudChipValueToText = "230.4K Baud +2.12% Timing Error"
                        Case 6
                            BaudChipValueToText = "250,000 Baud 0.00% Timing Error (USB Only)"
                        Case 7
                            BaudChipValueToText = "266,660 Baud 0.00% Timing Error (USB Only)"
                        Case 8
                            BaudChipValueToText = "285,710 Baud 0.00% Timing Error (USB Only)"
                        Case 9
                            BaudChipValueToText = "307,700 Baud 0.00% Timing Error (USB Only)"
                        Case 10
                            BaudChipValueToText = "333,330 Baud 0.00% Timing Error (USB Only)"
                        Case 11
                            BaudChipValueToText = "363,620 Baud 0.00% Timing Error (USB Only)"
                        Case 12
                            BaudChipValueToText = "400,000 Baud 0.00% Timing Error (USB Only)"
                        Case 13
                            BaudChipValueToText = "500,000 Baud 0.00% Timing Error (USB Only)"
                        Case 14
                            BaudChipValueToText = "571,410 Baud 0.00% Timing Error (USB Only)"
                        Case 15
                            BaudChipValueToText = "666,660 Baud 0.00% Timing Error (USB Only)"
                        Case 16
                            BaudChipValueToText = "800,000 Baud 0.00% Timing Error (USB Only)"
                        Case 17
                            BaudChipValueToText = "1,000,000 Baud 0.00% Timing Error (USB Only)"
                        Case Else
                            BaudChipValueToText = "115.2K Baud -0.79% Timing Error (Default)"
                    End Select

                End Function
                Public Shared Function BaudTextToChipValue(Setting As String)

                    Select Case Setting
                        Case "9600 Baud -0.08% Timing Error"
                            BaudTextToChipValue = 0
                        Case "19.2K Baud +0.16% Timing Error"
                            BaudTextToChipValue = 1
                        Case "38.4K Baud +0.16% Timing Error"
                            BaudTextToChipValue = 2
                        Case "57.6K Baud -0.79% Timing Error"
                            BaudTextToChipValue = 3
                        Case "115.2K Baud -0.79% Timing Error (Default)"
                            BaudTextToChipValue = 4
                        Case "230.4K Baud +2.12% Timing Error"
                            BaudTextToChipValue = 5
                        Case "250,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 6
                        Case "266,660 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 7
                        Case "285,710 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 8
                        Case "307,700 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 9
                        Case "333,330 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 10
                        Case "363,620 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 11
                        Case "400,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 12
                        Case "500,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 13
                        Case "571,410 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 14
                        Case "666,660 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 15
                        Case "800,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 16
                        Case "1,000,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 17
                        Case Else
                            BaudTextToChipValue = 4
                    End Select

                End Function
                Public Shared Function Baud_Rate(ByRef ncdObj As NCDEnterprise.NCDController, Port As Integer, NewBaudRate As Array)
                    Debug.Print("Changing Baud Rate - Port: " + Port.ToString + "  Baud:" + NewBaudRate.ToString)
                    If NewBaudRate(0) > 17 Then
                        NewBaudRate(0) = 4
                    End If
                    If Port = 1 Then
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 831, NewBaudRate)
                    Else
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 829, NewBaudRate)
                    End If
                    'NCDLib.WriteBytesAPI(ncdObj, True, command)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
                Public Shared Function Communication_Technology(ByRef ncdObj As NCDEnterprise.NCDController, NewTechnology As Array)
                    Debug.Print("Changing Baud Rate - Technology:" + NewTechnology.ToString)
                    If NewTechnology(0) > 6 Then
                        NewTechnology(0) = 6
                    End If
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 828, NewTechnology)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function

                Public Shared Function E3C_Device_Number(ByRef ncdObj As NCDEnterprise.NCDController, Data As Array)
                    Debug.Print("Changing E3C Device Number:" + Data.ToString)
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 827, Data)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function

                Public Shared Function NodeID(ByRef ncdObj As NCDEnterprise.NCDController, Data As Array)
                    Debug.Print("Changing NodeID:" + Data.ToString)
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 826, Data)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
                Public Shared Function EncryptionOnOff(ByRef ncdObj As NCDEnterprise.NCDController, Data As Array)
                    If Data(0) = 0 Then
                        Debug.Print("Changing Encryption to Off:" + Data.ToString)
                    Else
                        Debug.Print("Changing Encryption to On:" + Data.ToString)
                    End If
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 825, Data)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
                Public Shared Function EncryptionKey(ByRef ncdObj As NCDEnterprise.NCDController, Key As Array)
                    Debug.Print("Changing Encryption Key:" + Key.ToString)
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 896, Key)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
            End Class
            Public Shared Function Identify(ByRef ncdobj As NCDController) As String
                Try
                    Dim Result As Array = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, False, 832, 31)
                    Dim Identity As String = "Unknown"
                    If Result.Length = 32 Then
                        Identity = ""
                        'Expand Parcer to Identify Devices by their Function
                        If Result(1) > 0 Then
                            Identity = Identity + "ASM" + Result(1).ToString + "-" + Result(2).ToString + Chr(13) + Chr(10)
                        End If
                        If Result(3) > 0 Then
                            Identity = Identity + "PR" + Result(3).ToString + "-" + Result(4).ToString + " "
                        End If
                        If Result(5) > 0 Then
                            Identity = Identity + "PR" + Result(5).ToString + "-" + Result(6).ToString + " "
                        End If
                        If Result(7) > 0 Then
                            Identity = Identity + "PR" + Result(7).ToString + "-" + Result(8).ToString + " "
                        End If
                        If Result(9) > 0 Then
                            Identity = Identity + "PR" + Result(9).ToString + "-" + Result(10).ToString + " "
                        End If
                        If Result(11) > 0 Then
                            Identity = Identity + "PR" + Result(11).ToString + "-" + Result(12).ToString + " "
                        End If
                        If Result(13) > 0 Then
                            Identity = Identity + "PR" + Result(13).ToString + "-" + Result(14).ToString + " "
                        End If
                        If Result(15) > 0 Then
                            Identity = Identity + "PR" + Result(15).ToString + "-" + Result(16).ToString + " " + Chr(13) + Chr(10)
                        End If
                        If Result(17) > 0 Then
                            Identity = Identity + "PR" + Result(17).ToString + "-" + Result(18).ToString + " "
                        End If
                        If Result(19) > 0 Then
                            Identity = Identity + "PR" + Result(19).ToString + "-" + Result(20).ToString + " "
                        End If
                        If Result(21) > 0 Then
                            Identity = Identity + "PR" + Result(21).ToString + "-" + Result(22).ToString + " "
                        End If
                        If Result(23) > 0 Then
                            Identity = Identity + "PR" + Result(23).ToString + "-" + Result(24).ToString + " "
                        End If
                        If Result(25) > 0 Then
                            Identity = Identity + "PR" + Result(25).ToString + "-" + Result(26).ToString + " "
                        End If
                        If Result(27) > 0 Then
                            Identity = Identity + "PR" + Result(27).ToString + "-" + Result(28).ToString + " "
                        End If
                        Identity = Identity + Chr(13) + Chr(10)
                        'Calculate Version Display
                        Identity = Identity + "Version " + Result(29).ToString + "." + Result(30).ToString + " 20" + Result(31).ToString
                    End If
                    Return Identity
                Catch
                    'MsgBox("Unable to Open Selected Communications Port.")
                    'End
                    Return "None"
                End Try
                'Return True
            End Function

            Public Shared Function FirmwareVersion(ByRef ncdobj As NCDController) As Integer
                FirmwareVersion = 0
                Try
                    Dim Result As Array = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, False, 832, 31)
                    Dim Identity As String = "Unknown"
                    If Result.Length = 32 Then
                        Identity = ""
                        'Expand Parcer to Identify Devices by their Function
                        If Result(1) > 0 Then
                            Identity = Identity + "ASM" + Result(1).ToString + "-" + Result(2).ToString + Chr(13) + Chr(10)
                        End If
                        If Result(3) > 0 Then
                            Identity = Identity + "PR" + Result(3).ToString + "-" + Result(4).ToString + " "
                        End If
                        If Result(5) > 0 Then
                            Identity = Identity + "PR" + Result(5).ToString + "-" + Result(6).ToString + " "
                        End If
                        If Result(7) > 0 Then
                            Identity = Identity + "PR" + Result(7).ToString + "-" + Result(8).ToString + " "
                        End If
                        If Result(9) > 0 Then
                            Identity = Identity + "PR" + Result(9).ToString + "-" + Result(10).ToString + " "
                        End If
                        If Result(11) > 0 Then
                            Identity = Identity + "PR" + Result(11).ToString + "-" + Result(12).ToString + " "
                        End If
                        If Result(13) > 0 Then
                            Identity = Identity + "PR" + Result(13).ToString + "-" + Result(14).ToString + " "
                        End If
                        If Result(15) > 0 Then
                            Identity = Identity + "PR" + Result(15).ToString + "-" + Result(16).ToString + " " + Chr(13) + Chr(10)
                        End If
                        If Result(17) > 0 Then
                            Identity = Identity + "PR" + Result(17).ToString + "-" + Result(18).ToString + " "
                        End If
                        If Result(19) > 0 Then
                            Identity = Identity + "PR" + Result(19).ToString + "-" + Result(20).ToString + " "
                        End If
                        If Result(21) > 0 Then
                            Identity = Identity + "PR" + Result(21).ToString + "-" + Result(22).ToString + " "
                        End If
                        If Result(23) > 0 Then
                            Identity = Identity + "PR" + Result(23).ToString + "-" + Result(24).ToString + " "
                        End If
                        If Result(25) > 0 Then
                            Identity = Identity + "PR" + Result(25).ToString + "-" + Result(26).ToString + " "
                        End If
                        If Result(27) > 0 Then
                            Identity = Identity + "PR" + Result(27).ToString + "-" + Result(28).ToString + " "
                        End If
                        Identity = Identity + Chr(13) + Chr(10)
                        'Calculate Version Display
                        Identity = Identity + "Version " + Result(29).ToString + "." + Result(30).ToString + " 20" + Result(31).ToString
                        FirmwareVersion = (Result(29) * 256) + Result(30)
                    End If
                    Return FirmwareVersion
                Catch
                    'MsgBox("Unable to Open Selected Communications Port.")
                    'End
                    Return FirmwareVersion
                End Try
                'Return True
            End Function


            Public Shared Function LookupI2CSpeed(Speed As Integer) As String
                LookupI2CSpeed = "XXXKHz"
                Select Case Speed
                    Case <= 0 : Return "60KHz"
                    Case <= 1 : Return "100KHz"
                    Case <= 2 : Return "200KHz"
                    Case <= 3 : Return "300KHz"
                    Case <= 4 : Return "400KHz"
                    Case <= 5 : Return "506KHz"
                    Case <= 6 : Return "602KHz"
                    Case <= 7 : Return "708KHz"
                    Case <= 8 : Return "708KHz"
                    Case <= 9 : Return "708KHz"
                    Case <= 10 : Return "708KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 11 : Return "679KHz"
                    Case <= 12 : Return "651KHz"
                    Case <= 13 : Return "629KHz"
                    Case <= 14 : Return "602KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 15 : Return "583KHz"
                    Case <= 18 : Return "526KHz"
                    Case <= 19 : Return "506KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 20 : Return "492KHz"
                    Case <= 25 : Return "427KHz"
                    Case <= 27 : Return "403KHz"
                    Case <= 28 : Return "400KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 30 : Return "375KHz"
                    Case <= 35 : Return "336KHz"
                    Case <= 40 : Return "305KHz"
                    Case <= 41 : Return "300KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 45 : Return "279KHz"
                    Case <= 55 : Return "238KHz"
                    Case <= 65 : Return "206KHz"
                    Case <= 66 : Return "204KHz"
                    Case <= 67 : Return "200KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 68 : Return "198KHz"
                    Case <= 70 : Return "194KHz"
                    Case <= 75 : Return "184KHz"
                    Case <= 85 : Return "164KHz"
                    Case <= 95 : Return "149KHz"
                    Case <= 105 : Return "136KHz"
                    Case <= 115 : Return "125KHz"
                    Case <= 125 : Return "116KHz"
                    Case <= 135 : Return "108KHz"
                    Case <= 145 : Return "102KHz"
                    Case <= 147 : Return "100KHz" '''''''''''''''''''''''''''''''''''
                    Case <= 155 : Return "96KHz"
                    Case <= 165 : Return "90KHz"
                    Case <= 175 : Return "85KHz"
                    Case <= 185 : Return "81KHz"
                    Case <= 195 : Return "77KHz"
                    Case <= 205 : Return "74KHz"
                    Case <= 215 : Return "70KHz"
                    Case <= 225 : Return "67KHz"
                    Case <= 235 : Return "65KHz"
                    Case <= 245 : Return "62KHz"
                    Case <= 253 : Return "60KHz"
                    Case <= 255 : Return "60KHz"
                End Select



            End Function

            Public Shared Function GetConfiguration(ByRef ncdobj As NCDController)
                'Dim Configuration As Array = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, False, 768, 63)

                Dim ConfigurationLo As Array = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, False, 768, 31)
                Dim ConfigurationHi As Array = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, False, 800, 31)

                If ConfigurationLo.Length = 32 And ConfigurationHi.Length = 32 Then
                    Dim Configuration(63) As Byte
                    Dim Temp As Byte
                    For Temp = 0 To 31
                        Configuration(Temp) = ConfigurationLo(Temp)
                        Configuration(Temp + 32) = ConfigurationHi(Temp)
                    Next
                    Return Configuration
                End If

            End Function

            Public Shared Function DeviceActivated(ByRef ncdobj As NCDController) As Boolean

                'Address 7728 I(0)  = "32-Bit System Minutes Counter 1 Byte 0 LSWord LSByte"
                'Address 7729 I(1)  = "32-Bit System Minutes Counter 1 Byte 1 LSWord MSByte"
                'Address 7730 I(2)  = "32-Bit System Minutes Counter 1 Byte 2 MSWord LSByte"
                'Address 7731 I(3)  = "32-Bit System Minutes Counter 1 Byte 3 MSWord MSByte"
                'Address 7732 I(4)  = "32-Bit NCD Online Invoice Number 1 Byte 0 LSWord LSByte"
                'Address 7733 I(5)  = "32-Bit NCD Online Invoice Number 1 Byte 1 LSWord MSByte"
                'Address 7734 I(6)  = "32-Bit NCD Online Invoice Number 1 Byte 2 MSWord LSByte"
                'Address 7735 I(7)  = "32-Bit NCD Online Invoice Number 1 Byte 3 MSWord MSByte"
                'Address 7736 I(8)  = "Activation Month"
                'Address 7737 I(9)  = "Activation Day"
                'Address 7738 I(10) = "Activation Year"
                'Address 7739 I(11) = "Activation Hours"
                'Address 7740 I(12) = "Activation Minutes"
                'Address 7741 I(13) = "Activation Seconds"
                'Address 7742 I(14) = "Activation Engineer"
                'Address 7743 I(15) = "Reserved Activation"

Retry:
                Debug.Print("Device Activated Function Call")
                Try
                    DeviceActivated = True
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, True, 7728, 16)
                    If I IsNot Nothing Then
                        If I.Length = 15 Then
                            If I(15) = 0 Then
                                DeviceActivated = False
                            End If
                        End If
                    Else
                        ' GoTo Retry
                    End If
                Catch
                    '  GoTo Retry
                End Try

            End Function


            Public Shared Function ActivateDevice(ByRef ncdobj As NCDController, Invoice As UInteger) As Boolean

                ActivateDevice = False

                'Address 7728 I(0)  = "32-Bit System Minutes Counter 1 Byte 0 LSWord LSByte"
                'Address 7729 I(1)  = "32-Bit System Minutes Counter 1 Byte 1 LSWord MSByte"
                'Address 7730 I(2)  = "32-Bit System Minutes Counter 1 Byte 2 MSWord LSByte"
                'Address 7731 I(3)  = "32-Bit System Minutes Counter 1 Byte 3 MSWord MSByte"
                'Address 7732 I(4)  = "32-Bit NCD Online Invoice Number 1 Byte 0 LSWord LSByte"
                'Address 7733 I(5)  = "32-Bit NCD Online Invoice Number 1 Byte 1 LSWord MSByte"
                'Address 7734 I(6)  = "32-Bit NCD Online Invoice Number 1 Byte 2 MSWord LSByte"
                'Address 7735 I(7)  = "32-Bit NCD Online Invoice Number 1 Byte 3 MSWord MSByte"
                'Address 7736 I(8)  = "Activation Month"
                'Address 7737 I(9)  = "Activation Day"
                'Address 7738 I(10) = "Activation Year"
                'Address 7739 I(11) = "Activation Hours"
                'Address 7740 I(12) = "Activation Minutes"
                'Address 7741 I(13) = "Activation Seconds"
                'Address 7742 I(14) = "Reserved Activation"
                'Address 7743 I(15) = "Reserved Activation"

                If NCDLib.Enterprise.Setup.DeviceActivated(ncdobj) = True Then
                    MsgBox("Device has Already been Activated and Cannot be Activated Again.")
                    Return ActivateDevice
                End If


                Dim aI(15) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 33          'Test 2-Way Command
                aI(2) = 188         'Special Command Mode
                aI(3) = 199         'Special Command Mode
                aI(4) = 222         'Special Command Mode for Device Activation
                aI(5) = NCDLib.Math.GetMSB32_LSW_LSB(Invoice)   'Set Value LSW_LSB = Least Significant Word, Least Significant Byte
                aI(6) = NCDLib.Math.GetMSB32_LSW_MSB(Invoice)   'Set Value LSW_MSB = Least Significant Word, Most Significant Byte
                aI(7) = NCDLib.Math.GetMSB32_MSW_LSB(Invoice)   'Set Value MSW_LSB = Most Significant Word, Least Significant Byte
                aI(8) = NCDLib.Math.GetMSB32_MSW_MSB(Invoice)   'Set Value MSW_MSB = Most Significant Word, Most Significant Byte
                aI(9) = Date.Today.Month 'Month
                aI(10) = Date.Today.Day 'Day
                aI(11) = (Date.Today.Year - 2000)    'Year
                aI(12) = TimeOfDay.Hour              'Hours
                aI(13) = TimeOfDay.Minute            'Minutes
                aI(14) = TimeOfDay.Second           'Seconds
                aI(15) = 0  'Engineer

                NCDLib.WriteBytesAPI(ncdobj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdobj, True, 2)      'Device will E3C Device Number

                If rData(0) = 0 Then
                    ActivateDevice = True
                End If

                Return ActivateDevice

            End Function

            Public Shared Function PutConfiguration(ByRef ncdobj As NCDController, Configuration As Array)

                Debug.Print("Storing Configuration...")
                Dim Data(63) As Byte
                For N As Integer = 0 To (Configuration.Length - 1)
                    Data(N) = Configuration(N)
                    Debug.Print(Data(N).ToString)
                Next
                Debug.Print("End Debug Data")

                Dim ConfigurationLo(31) As Byte
                Dim ConfigurationHi(31) As Byte
                Dim Temp As Byte
                For Temp = 0 To 31
                    ConfigurationLo(Temp) = Configuration(Temp)
                    ConfigurationHi(Temp) = Configuration(Temp + 32)
                Next

                'NCDLib.Enterprise.Setup.EEPROM_Write(ncdobj, False, 768, Data) 'Original Stores 64 Bytes

                NCDLib.Enterprise.Setup.EEPROM_Write(ncdobj, False, 768, ConfigurationLo) 'Store Lower 32 Bytes
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdobj, True)
                Debug.Print(Result)
                NCDLib.Enterprise.Setup.EEPROM_Write(ncdobj, False, 800, ConfigurationHi) 'Store Upper 32 Bytes
                Dim Result2 As Integer = NCDLib.ReadByteAPI(ncdobj, True)
                Debug.Print(Result2)
                Return Result2

            End Function

            Public Shared Function PutEncryption(ByRef ncdobj As NCDController, Key As Array)

                'Debug.Print("Storing Configuration...")
                Dim Data(Key.Length - 1) As Byte
                Data(0) = Key.Length - 1
                For N As Integer = 1 To (Key.Length - 1)
                    Data(N) = Key(N)
                    Debug.Print(Data(N).ToString)
                Next
                'Debug.Print("End Debug Data")
                NCDLib.Enterprise.Setup.EEPROM_Write(ncdobj, False, 896, Data)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdobj, True)
                'Debug.Print(Result)
                Return Result

            End Function

            Public Shared Sub Reboot_Soft(ByRef ncdObj As NCDController)
                'Issue Soft Reboot Command
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 140, 99)
            End Sub
            Public Shared Sub Reboot_Hard(ByRef ncdObj As NCDController)
                'Issure Hard Reboot Command
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 140, 199)
            End Sub
            Public Shared Function Test2Way(ByRef ncdObj As NCDController)
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function
            Public Shared Function ConfigurationMode(ByRef ncdObj As NCDController, Duration As Integer)
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 140, 86, Duration)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function
            Public Shared Function RecoverDefaultSettings(ByRef ncdObj As NCDController) As Integer
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 188, 199, 244)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function
            Public Shared Function EEPROM_Write(ByRef ncdObj As NCDController, External As Boolean, Location As Integer, ByVal Data As Array)

                'External = False (On-Board CPU EEPROM)
                'External = True (Off-Board External EEPROM)
                'Location = Memory Location
                'Data = Byte Array to Write to Memory

                Dim _Data As New ArrayList

                _Data.Add(254)
                If External = False Then
                    _Data.Add(51)
                Else
                    _Data.Add(53)
                End If

                _Data.Add(NCDLib.Math.GetMSB(Location))
                _Data.Add(NCDLib.Math.GetLSB(Location))
                _Data.AddRange(Data)

                'Send API Frame to Device
                'im d As Byte() = CType(API.ToArray(GetType(Byte)), Byte())
                Dim d(_Data.Count - 1) As Byte
                For i = 0 To _Data.Count - 1
                    d(i) = _Data(i)
                Next


                ''''
                '''
                'Debug.Print("------------COMMAND DUMP-----")
                'For I = 0 To _Data.Count
                ' Debug.Print(I.ToString + " ---->" + _Data(I).ToString)
                ' Next
                'Debug.Print("------------END COMMAND DUMP-----")

                NCDLib.WriteBytesAPI(ncdObj, True, d)

                ' NCDLib.WriteBytesAPI(ncdObj, True, 254, 50, NCDLib.Math.GetMSB(Location), NCDLib.Math.GetLSB(Location), d)

                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function

            Public Shared Function EEPROM_Read(ByRef ncdObj As NCDController, External As Boolean, Location As Integer, Bytes As Integer) As Array

                'External = False (On-Board CPU EEPROM)
                'External = True (Off-Board External EEPROM)
                'Location = Memory Location
                'Data = Byte Array to Write to Memory

                Dim _Command As New ArrayList

                _Command.Add(254)
                If External = False Then
                    _Command.Add(50)
                Else
                    _Command.Add(52)
                End If
                _Command.Add(NCDLib.Math.GetMSB(Location))
                _Command.Add(NCDLib.Math.GetLSB(Location))
                _Command.Add(Bytes)

                'Send API Frame to Device
                'im d As Byte() = CType(API.ToArray(GetType(Byte)), Byte())

                Debug.Print("Reading EEPROM:")
                Dim d(_Command.Count - 1) As Byte
                For i = 0 To (_Command.Count - 1)
                    d(i) = _Command(i)
                    Debug.Print(d(i).ToString)
                Next
                Debug.Print("End Reading EEPROM")

                NCDLib.WriteBytesAPI(ncdObj, True, d)

                ' NCDLib.WriteBytesAPI(ncdObj, True, 254, 50, NCDLib.Math.GetMSB(Location), NCDLib.Math.GetLSB(Location), d)

                Dim Result As Array = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)

                'Debug.Print(Result)
                Return Result
            End Function
        End Class


        Public Class Device
            Public Class PR53_25
                Public Shared Function StorePowerUpDefaultOptions(ByRef ncdObj As NCDEnterprise.NCDController, RecoveryMethod As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7600, 16)
                    If I IsNot Nothing Then
                        Dim Menu As Byte = RecoveryMethod << 6      'Or Data Into I(8) so MSB Can be Used
                        Dim Value As Byte = (I(8) And 63)
                        I(8) = Menu Or Value 'Merge Menu and Values Together in I(8)
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7600, I)
                    End If
                End Function
                Public Shared Function StorePowerUpDefaultState(ByRef ncdObj As NCDEnterprise.NCDController, DAC1 As Integer, DAC2 As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7600, 16)
                    If I IsNot Nothing Then
                        Dim Menu As Byte = 2 << 6      'Or Data Into I(8) so MSB Can be Used
                        Dim Value As Byte = NCDLib.Math.GetMSB(DAC1)
                        I(8) = Menu Or Value 'Merge Menu and Values Together in I(8)
                        I(9) = NCDLib.Math.GetLSB(DAC1)
                        I(10) = NCDLib.Math.GetMSB(DAC2)
                        I(11) = NCDLib.Math.GetLSB(DAC2)
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7600, I)
                    End If
                End Function
                Public Shared Function SetOutputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Value As Integer)
                    Dim Options As Byte = 128 'Write Option
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 2 Then StartChannel = 2
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 2 Then StopChannel = 2
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 25, StartChannel, StopChannel, Options, NCDLib.Math.GetMSB(Value), NCDLib.Math.GetLSB(Value))
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 2 Then StartChannel = 2
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 2 Then StopChannel = 2
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 25, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Decimal = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Scale = 0 Then
                        Calculation = RealWord * 0.0014015416958655
                    Else
                        Calculation = RealWord * (0.0014015416958655 / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " mA"
                End Function
            End Class
            Public Class PR53_6
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 6, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Integer = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Scale = 0 Then
                        Calculation = RealWord * 0.0013568521031208
                    Else
                        Calculation = RealWord * (0.0013568521031208 / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " mA"
                End Function
            End Class
            Public Class PR53_7
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 7, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer, Calibration As Integer) As String
                    'Notice: A Calibration Value of 6184 is typically a good starting place for a Calibration Value
                    Dim RealWord As Integer = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Calibration < 6000 Or Calibration > 7000 Then Calibration = 6184
                    Dim ActualCalibration As Decimal = Calibration / 10000000
                    If Scale = 0 Then
                        Calculation = RealWord * ActualCalibration
                    Else
                        Calculation = RealWord * (ActualCalibration / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " mA"
                End Function
            End Class
            Public Class PR53_9
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 9, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Integer = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Scale = 0 Then
                        Calculation = RealWord * 0.000345
                    Else
                        Calculation = RealWord * (0.000345 / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " VDC"
                End Function
            End Class
            Public Class PR53_14
                Public Shared Function StorePowerUpDefaultOptions(ByRef ncdObj As NCDEnterprise.NCDController, RecoveryMethod As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7633, 16)
                    If I IsNot Nothing Then
                        Dim Menu As Byte = RecoveryMethod
                        I(0) = Menu
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7633, I)
                    End If
                End Function
                Public Shared Function StorePowerUpDefaultState(ByRef ncdObj As NCDEnterprise.NCDController, DAC1 As Integer, DAC2 As Integer, DAC3 As Integer, DAC4 As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7600, 16)
                    If I IsNot Nothing Then
                        I(8) = NCDLib.Math.GetMSB(DAC1)
                        I(9) = NCDLib.Math.GetLSB(DAC1)
                        I(10) = NCDLib.Math.GetMSB(DAC2)
                        I(11) = NCDLib.Math.GetLSB(DAC2)
                        I(12) = NCDLib.Math.GetMSB(DAC3)
                        I(13) = NCDLib.Math.GetLSB(DAC3)
                        I(14) = NCDLib.Math.GetMSB(DAC4)
                        I(15) = NCDLib.Math.GetLSB(DAC4)
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7600, I)
                    End If
                End Function
                Public Shared Function SetOutputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Value As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 14, StartChannel, StopChannel, NCDLib.Math.GetMSB(Value), NCDLib.Math.GetLSB(Value))
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 14, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Decimal = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Scale = 0 Then
                        Calculation = RealWord * 0.0014015416958655
                    Else
                        Calculation = RealWord * (0.0014015416958655 / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " mA"
                End Function
            End Class
            Public Class PR53_11
                Public Shared Function IdentifyDevice(ByRef ncdObj As NCDEnterprise.NCDController)
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 11, 0)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 7)
                    Return Result
                End Function
                Public Shared Function ReadCurrent(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 3
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 11, StartChannel, StopChannel)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
            End Class
            Public Class PR53_37

            End Class
            Public Class PR53_33
                Public Shared Function StorePowerUpDefaultOptions(ByRef ncdObj As NCDEnterprise.NCDController, RecoveryMethod As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7632, 16)
                    If I IsNot Nothing Then
                        Dim Menu As Byte = RecoveryMethod
                        I(0) = Menu
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7632, I)
                    End If
                End Function
                Public Shared Function StorePowerUpDefaultState(ByRef ncdObj As NCDEnterprise.NCDController, DAC1 As Integer, DAC2 As Integer, DAC3 As Integer, DAC4 As Integer)
                    Dim I(15) As Byte
                    I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdObj, True, 7616, 16)
                    If I IsNot Nothing Then
                        I(8) = NCDLib.Math.GetMSB(DAC1)
                        I(9) = NCDLib.Math.GetLSB(DAC1)
                        I(10) = NCDLib.Math.GetMSB(DAC2)
                        I(11) = NCDLib.Math.GetLSB(DAC2)
                        I(12) = NCDLib.Math.GetMSB(DAC3)
                        I(13) = NCDLib.Math.GetLSB(DAC3)
                        I(14) = NCDLib.Math.GetMSB(DAC4)
                        I(15) = NCDLib.Math.GetLSB(DAC4)
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, True, 7616, I)
                    End If
                End Function
                Public Shared Function SetOutputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Value As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    If Value > 15250 Then Value = 15250
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 33, StartChannel, StopChannel, NCDLib.Math.GetMSB(Value), NCDLib.Math.GetLSB(Value))
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 33, StartChannel, StopChannel)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Decimal = ((MSB * 256) + LSB)
                    Dim Calculation As Decimal
                    If Scale = 0 Then
                        Calculation = RealWord * 0.0014015416958655
                    Else
                        Calculation = RealWord * (0.0014015416958655 / 2)
                    End If
                    RealValue = String.Format("{0:0.000}", Calculation) + " mA"
                End Function
            End Class

        End Class



        Public Class Hardware
            Public Class I2C
                Public Shared I2CError As String

                Public Class Chip

                    Public Class AS1115
                        Public Shared Sub DisplayBrightness(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Brightness As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &HA, Brightness)
                        End Sub
                        Public Shared Sub DisplayValue(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Value As Integer)
                            Dim VString As String = "000"
                            Dim CH1 As Integer = 0
                            Dim CH2 As Integer = 0
                            Dim CH3 As Integer = 0
                            'Convert Value to 3 Digit String
                            VString = Value.ToString
                            If Len(VString) = 1 Then
                                VString = "00" + Value.ToString
                            Else
                                If Len(VString) = 2 Then
                                    VString = "0" + Value.ToString
                                End If
                            End If
                            'Extract Each Digit and Send to Display as 3 Bytes (Left to Right)
                            CH1 = Mid(VString, 1, 1) 'Left Digit
                            CH2 = Mid(VString, 2, 1) 'Center Digit
                            CH3 = Mid(VString, 3, 1) 'Right Digit
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H1, CH1, CH2, CH3)
                        End Sub
                        Public Shared Sub DisplayInit(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &H9, &H7, &HFF, &H3, &H1)
                        End Sub
                        Public Shared Sub DisplayPortLocator(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, A As Integer, B As Integer, C As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &H9, &H7, &HFF, &H3, &H1)
                            NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &H1, A, B, C)
                        End Sub
                    End Class
                    Public Class PCA8574_Display
                        Public Shared DisplayByte As Byte
                        Public Shared Sub BacklightOn(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            'Backlight = Bit 3 (Value = 8)
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 3, 1)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteByte(ncdObj, I2CPort, Hardware, Address, DisplayByte)
                        End Sub
                        Public Shared Sub BacklightOff(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            'Backlight = Bit 3 (Value = 8)
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 3, 0)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteByte(ncdObj, I2CPort, Hardware, Address, DisplayByte)
                        End Sub
                        Public Shared Sub DisplayOffCursorOff(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &H8)
                        End Sub
                        Public Shared Sub DisplayOnCursorUnderline(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &HE)
                        End Sub
                        Public Shared Sub DisplayOnCursorOff(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &HC)
                        End Sub
                        Public Shared Sub DisplayOnCursorBlock(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &HF)
                        End Sub
                        Public Shared Sub DisplayShiftLeft(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &H18)
                        End Sub
                        Public Shared Sub DisplayShiftRight(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &H1C)
                        End Sub
                        Public Shared Sub CursorLeft(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &H10)
                        End Sub
                        Public Shared Sub CursorRight(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &H14)
                        End Sub
                        Public Shared Sub ClearDisplay(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &H1)
                        End Sub
                        Public Shared Sub HomeCursor(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &H2)
                        End Sub
                        Public Shared Sub Line1_20x4(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &H80)
                        End Sub
                        Public Shared Sub Line2_20x4(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &HC0)
                        End Sub
                        Public Shared Sub Line3_20x4(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &H94)
                        End Sub
                        Public Shared Sub Line4_20x4(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteCommand(ncdObj, I2CPort, Hardware, Address, &HD4)
                        End Sub
                        Public Shared Sub Text(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer, DisplayText As String, Limit As Integer)
                            Dim Letter As Integer
                            If DisplayText IsNot Nothing Then
                                For Count = 1 To NCDLib.Safe.Limit_Value(Len(DisplayText), 1, Limit)
                                    Letter = Asc(Mid(DisplayText, Count, 1))
                                    'Debug.Print(Count.ToString + " " + Letter.ToString)
                                    NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteData(ncdObj, I2CPort, Hardware, Address, Letter)
                                Next
                            End If
                        End Sub
                        Public Shared Sub Initialize20x4(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer)
                            DisplayByte = 2
                            'DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.BacklightOn(ncdObj, I2CPort, Hardware, Address)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 3)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 3)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 3)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 2)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 2)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 8)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 0)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 8)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 0)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 1)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 0)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 6)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 0)
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, 15)
                        End Sub

                        Public Shared Sub WriteCommand(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer, Value As Integer)
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                            If Hardware = False Then
                                NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteUpperNibble(ncdObj, I2CPort, Hardware, Address, Value)
                                NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, Value)
                            Else
                                NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteDisplayByte(ncdObj, I2CPort, Hardware, Address, Value)
                            End If
                        End Sub

                        Public Shared Sub WriteData(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer, Value As Integer)
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 1) 'RS Line = High (Data Mode)
                            If Hardware = False Then
                                NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteUpperNibble(ncdObj, I2CPort, Hardware, Address, Value)
                                NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, I2CPort, Hardware, Address, Value)
                            Else
                                NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteDisplayByte(ncdObj, I2CPort, Hardware, Address, Value)
                            End If
                        End Sub
                        Public Shared Sub WriteLowerNibble(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer, Value As Integer)

                            Dim DisplayByteA As Integer
                            ' Dim DisplayByteB As Integer

                            If Hardware = False Then
                                'DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 1, 0) 'RW Line = Low
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 1) 'E  Line = High
                                'This Bit is Reserved for the Backlight Control Line
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 4, NCDLib.Math.GetBit(Value, 0)) 'D0
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 5, NCDLib.Math.GetBit(Value, 1)) 'D1
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 6, NCDLib.Math.GetBit(Value, 2)) 'D2
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 7, NCDLib.Math.GetBit(Value, 3)) 'D3
                                '   NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                                '   DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = High
                                NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, DisplayByte)
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = Low
                                NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, DisplayByte)
                            Else

                                'DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 1, 0) 'RW Line = Low
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 1) 'E  Line = High
                                'This Bit is Reserved for the Backlight Control Line
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 4, NCDLib.Math.GetBit(Value, 0)) 'D0
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 5, NCDLib.Math.GetBit(Value, 1)) 'D1
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 6, NCDLib.Math.GetBit(Value, 2)) 'D2
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 7, NCDLib.Math.GetBit(Value, 3)) 'D3
                                '   NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                                '   DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = High
                                'Write to Hardware Display Command Set
                                'NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteHW(ncdObj, I2CPort, Address, DisplayByte)
                                'DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = Low
                                ''Write to Hardware Display Command Set
                                'NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteHW(ncdObj, I2CPort, Address, DisplayByte)

                                DisplayByteA = DisplayByte
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = Low
                                'Write to Hardware Display Command Set
                                'DisplayByteB = DisplayByte
                                NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteNibble(ncdObj, I2CPort, Address, DisplayByteA)
                            End If


                        End Sub
                        Public Shared Sub WriteUpperNibble(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer, Value As Integer)

                            Dim DisplayByteA As Integer
                            Dim DisplayByteB As Integer

                            If Hardware = False Then
                                'Write to I2C Port Directly

                                ' DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 1, 0) 'RW Line = Low
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 1) 'E  Line = High
                                'This Bit is Reserved for the Backlight Control Line
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 4, NCDLib.Math.GetBit(Value, 4)) 'D4
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 5, NCDLib.Math.GetBit(Value, 5)) 'D5
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 6, NCDLib.Math.GetBit(Value, 6)) 'D6
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 7, NCDLib.Math.GetBit(Value, 7)) 'D7
                                '   NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                                '   DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = High
                                NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, DisplayByte)
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = Low
                                NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, DisplayByte)

                            Else

                                ' DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 1, 0) 'RW Line = Low
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 1) 'E  Line = High
                                'This Bit is Reserved for the Backlight Control Line
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 4, NCDLib.Math.GetBit(Value, 4)) 'D4
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 5, NCDLib.Math.GetBit(Value, 5)) 'D5
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 6, NCDLib.Math.GetBit(Value, 6)) 'D6
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 7, NCDLib.Math.GetBit(Value, 7)) 'D7
                                '   NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                                '   DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = High
                                'Write to Hardware Display Command Set
                                'NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteHW(ncdObj, I2CPort, Address, DisplayByte)
                                DisplayByteA = DisplayByte
                                DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = Low
                                'Write to Hardware Display Command Set
                                DisplayByteB = DisplayByte
                                'NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteHW(ncdObj, I2CPort, Address, DisplayByte)
                                NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteNibble(ncdObj, I2CPort, Address, DisplayByteA)
                            End If



                        End Sub
                        Public Shared Sub WriteDisplayByte(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer, Value As Integer)
                            Dim DisplayByteA As Integer
                            Dim DisplayByteB As Integer
                            'Dim DisplayByteC As Integer
                            'Dim DisplayByteD As Integer
                            'Upper Nibble Calculation
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 1, 0) 'RW Line = Low
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 1) 'E  Line = High
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 4, NCDLib.Math.GetBit(Value, 4)) 'D4
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 5, NCDLib.Math.GetBit(Value, 5)) 'D5
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 6, NCDLib.Math.GetBit(Value, 6)) 'D6
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 7, NCDLib.Math.GetBit(Value, 7)) 'D7
                            DisplayByteA = DisplayByte
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = Low
                            'DisplayByteB = DisplayByte
                            'Lower Nibble Calculation
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 1, 0) 'RW Line = Low
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 1) 'E  Line = High
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 4, NCDLib.Math.GetBit(Value, 0)) 'D0
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 5, NCDLib.Math.GetBit(Value, 1)) 'D1
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 6, NCDLib.Math.GetBit(Value, 2)) 'D2
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 7, NCDLib.Math.GetBit(Value, 3)) 'D3
                            DisplayByteB = DisplayByte
                            DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = Low
                            'DisplayByteD = DisplayByte
                            'Write to Hardware Display Command Set
                            NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteHWByte(ncdObj, I2CPort, Address, DisplayByteA, DisplayByteB) ', DisplayByteC, DisplayByteD)

                        End Sub
                        Public Shared Sub WriteByte(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Hardware As Boolean, Address As Integer, Value As Integer)
                            Debug.Print(NCDLib.Math.DecToBinaryStringStandard(Value))
                            If Hardware = False Then
                                'Write to I2C Port Directly
                                NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, Value)
                            Else
                                'Write to Hardware Display Command Set (Significantly Faster)
                                NCDLib.Enterprise.Hardware.I2C.Chip.PCA8574_Display.WriteHW(ncdObj, I2CPort, Address, Value)
                            End If
                        End Sub

                        Public Shared Function WriteHW(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Value As Byte) As Byte()
                            Debug.Print("Hardware WriteByte Function")
                            'See Firmware I2CLibrary_HW for Connector to this Function

                            Dim aI(5) As Byte

                            I2CError = ""
                            aI(0) = 189                  'Byte 0
                            aI(1) = I2CPort              'Byte 1
                            aI(2) = 195                  'Byte 2 - InStream[1]
                            aI(3) = 54                   'Byte 3 - InStream[2]
                            aI(4) = Address              'Byte 4 - InStream[3]
                            aI(5) = Value                'Byte 5 - InStream[4]

                            NCDLib.WriteBytesAPI(ncdObj, True, aI)
                            ' Debug.Print("-------------- Hardware LCD Command:")
                            ' For Each a In aI
                            '     Debug.Print(a)
                            ' Next
                            ' Debug.Print("-------------- END Command")

                            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                            If (Not (rData Is Nothing)) Then
                                If rData(0) = 4 Then    'If we received 4 bytes of data
                                    If rData(1) = 188 Then
                                        If rData(4) = 67 Then
                                            I2CError = ("I2C Write - Error Package:")
                                            If rData(2) = 90 Then
                                                If rData(3) = (255 - 90) Then
                                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                                End If
                                            End If
                                            If rData(2) = 91 Then
                                                If rData(3) = (255 - 91) Then
                                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                                End If
                                            End If
                                            If rData(2) = 92 Then
                                                If rData(3) = (255 - 92) Then
                                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                                Return rData
                            Else
                                I2CError = ("NO DATA RECEIVED")
                            End If

                        End Function

                        Public Shared Function WriteNibble(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, ValueA As Byte) As Byte()
                            Debug.Print("Hardware WriteByte Function")
                            'See Firmware I2CLibrary_HW for Connector to this Function

                            Dim aI(5) As Byte

                            I2CError = ""
                            aI(0) = 189                  'Byte 0
                            aI(1) = I2CPort              'Byte 1
                            aI(2) = 195                  'Byte 2 - InStream[1]
                            aI(3) = 55                   'Byte 3 - InStream[2]
                            aI(4) = Address              'Byte 4 - InStream[3]
                            aI(5) = ValueA               'Byte 5 - InStream[4]
                            'aI(6) = ValueB               'Byte 5 - InStream[4]

                            NCDLib.WriteBytesAPI(ncdObj, True, aI)
                            ' Debug.Print("-------------- Hardware LCD Command:")
                            ' For Each a In aI
                            '     Debug.Print(a)
                            ' Next
                            ' Debug.Print("-------------- END Command")

                            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                            If (Not (rData Is Nothing)) Then
                                If rData(0) = 4 Then    'If we received 4 bytes of data
                                    If rData(1) = 188 Then
                                        If rData(4) = 67 Then
                                            I2CError = ("I2C Write - Error Package:")
                                            If rData(2) = 90 Then
                                                If rData(3) = (255 - 90) Then
                                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                                End If
                                            End If
                                            If rData(2) = 91 Then
                                                If rData(3) = (255 - 91) Then
                                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                                End If
                                            End If
                                            If rData(2) = 92 Then
                                                If rData(3) = (255 - 92) Then
                                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                                Return rData
                            Else
                                I2CError = ("NO DATA RECEIVED")
                            End If

                        End Function
                        Public Shared Function WriteHWByte(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, ValueA As Byte, ValueB As Byte) As Byte() ', ValueC As Byte, ValueD As Byte) As Byte()
                            Debug.Print("Hardware WriteByte Function")
                            'See Firmware I2CLibrary_HW for Connector to this Function

                            Dim aI(6) As Byte

                            I2CError = ""
                            aI(0) = 189                  'Byte 0
                            aI(1) = I2CPort              'Byte 1
                            aI(2) = 195                  'Byte 2 - InStream[1]
                            aI(3) = 56                   'Byte 3 - InStream[2]
                            aI(4) = Address              'Byte 4 - InStream[3]
                            aI(5) = ValueA               'Byte 5 - InStream[4]
                            aI(6) = ValueB               'Byte 6 - InStream[5]

                            NCDLib.WriteBytesAPI(ncdObj, True, aI)
                            'Debug.Print("-------------- Hardware LCD Command:")
                            'For Each a In aI
                            '    Debug.Print(a)
                            'Next
                            'Debug.Print("-------------- END Command")

                            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                            If (Not (rData Is Nothing)) Then
                                If rData(0) = 4 Then    'If we received 4 bytes of data
                                    If rData(1) = 188 Then
                                        If rData(4) = 67 Then
                                            I2CError = ("I2C Write - Error Package:")
                                            If rData(2) = 90 Then
                                                If rData(3) = (255 - 90) Then
                                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                                End If
                                            End If
                                            If rData(2) = 91 Then
                                                If rData(3) = (255 - 91) Then
                                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                                End If
                                            End If
                                            If rData(2) = 92 Then
                                                If rData(3) = (255 - 92) Then
                                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                                Return rData
                            Else
                                I2CError = ("NO DATA RECEIVED")
                            End If

                        End Function

                    End Class



                    '  End Class



                    ' End Class



                    Public Class ADS1115
                        Public Shared Function Read_Channel(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer, Gain As Integer)
                            If Channel > 3 Then GoTo InvalidSettings
                            If Gain > 7 Then GoTo InvalidSettings

                            Dim LoConfig As Integer
                            Dim HiConfig As Integer
                            Dim BitChannel As Integer
                            Dim BitGain As Integer

                            Dim OS As Byte = 128    'Bit 8 128 = 196 + BitChannel Mux Selection
                            Dim Mux2 As Byte = 64   'Bit 7 64
                            Dim Mux1 As Byte = 32    'Bit 6 32
                            Dim Mux0 As Byte = 16    'Bit 5 16

                            Dim PGA2 As Byte = 8    'Bit 4 8
                            Dim PGA1 As Byte = 4    'Bit 3 4
                            Dim PGA0 As Byte = 2    'Bit 2 2
                            Dim Mode As Byte = 1    'Bit 1 1

                            Dim DR2 As Byte = 128     'Bit 7 128 = 131
                            Dim DR1 As Byte = 0       'Bit 6 64
                            Dim DR0 As Byte = 0       'Bit 5 32
                            Dim COMP_MODE As Byte = 0 'Bit 4 16
                            Dim COMP_POL As Byte = 0  'Bit 3 8
                            Dim COMP_LAT As Byte = 0  'Bit 2 4
                            Dim COMP_QUE1 As Byte = 2 'Bit 1 2
                            Dim COMP_QUE0 As Byte = 1 'Bit 0 1

                            'Bits 0 and 1 are Not Allocated

                            'Channel = 0 to 3            
                            If Channel = 0 Then BitChannel = (Mux2 * 1) + (Mux1 * 0) + (Mux0 * 0)
                            If Channel = 1 Then BitChannel = (Mux2 * 1) + (Mux1 * 0) + (Mux0 * 1)
                            If Channel = 2 Then BitChannel = (Mux2 * 1) + (Mux1 * 1) + (Mux0 * 0)
                            If Channel = 3 Then BitChannel = (Mux2 * 1) + (Mux1 * 1) + (Mux0 * 1)

                            'User Gain Value
                            If Gain = 0 Then BitGain = (PGA2 * 0) + (PGA1 * 0) + (PGA0 * 0)
                            If Gain = 1 Then BitGain = (PGA2 * 0) + (PGA1 * 0) + (PGA0 * 1)
                            If Gain = 2 Then BitGain = (PGA2 * 0) + (PGA1 * 1) + (PGA0 * 0)
                            If Gain = 3 Then BitGain = (PGA2 * 0) + (PGA1 * 1) + (PGA0 * 1)
                            If Gain = 4 Then BitGain = (PGA2 * 1) + (PGA1 * 0) + (PGA0 * 0)
                            If Gain = 5 Then BitGain = (PGA2 * 1) + (PGA1 * 0) + (PGA0 * 1)
                            If Gain = 6 Then BitGain = (PGA2 * 1) + (PGA1 * 1) + (PGA0 * 0)
                            If Gain = 7 Then BitGain = (PGA2 * 1) + (PGA1 * 1) + (PGA0 * 1)

                            LoConfig = COMP_QUE0 + COMP_QUE1 + COMP_LAT + COMP_POL + COMP_MODE + DR0 + DR1 + DR2
                            HiConfig = Mode + BitGain + BitChannel + OS

                            'Write to Configuration Register
                            Dim Result1() As Byte = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 1, HiConfig, LoConfig)

                            ncdObj.Sleep(100)
                            'Read Conversion Register
                            Dim Delay As Integer = 0
                            Dim Result2() As Byte = NCDLib.Enterprise.Hardware.I2C.WriteRead(ncdObj, I2CPort, Address, 2, Delay, &H0)

                            If Not (Result2 Is Nothing) Then
                                If (Result2.Length = 2) Then
                                    Dim d As Long
                                    'If (Result2(0) And 128) = 128 Then
                                    '   Result2(0) = Result2(0) - 128
                                    'End If
                                    d = (Result2(0) * 256) + Result2(1)
                                    If d > 32767 Then d = 0
                                    Debug.Print(d.ToString)
                                    Read_Channel = d
                                    Return Read_Channel
                                End If
                            End If
                            Return -1

InvalidSettings:
                            Debug.Print("---------------------------------------------------")
                            Debug.Print("ERROR: ADS1115 Invalid Parameters")
                            If Channel > 7 Then Debug.Print("ERROR: ADS1115 Invalid Channel")
                            'If Resolution > 2 Then Debug.Print("ERROR: ADS7828 Invalid Resolution")
                            'If Gain > 3 Then Debug.Print("ERROR: ADS7828 Invalid Gain")

                        End Function


                    End Class
                    ' Public Class AS1115
                    '     Public Shared Sub DisplayValue(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, A As Integer, B As Integer, C As Integer)
                    '         NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &H9, &H7)
                    '         NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &HA, &HFF)
                    '         NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &HC, &H1)
                    '         'NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &HE, &H0)
                    '         NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &HB, &H3)
                    '         NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &H1, A)
                    '         NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &H2, B)
                    '         NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, 0, &H3, C)
                    '     End Sub
                    ' End Class

                    Public Class PCA9685
                        Public Shared Sub Setup(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Frequency As Integer)
                            Dim Result As Byte()
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H0, &H0)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H0, &H10)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &HFE, &H5)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H0, &H0)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H0, 161)
                        End Sub
                        Public Shared Function SetChannel(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer, Value As Integer)
                            Dim Result As Byte()
                            If Channel = 1 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 6, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 2 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 10, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 3 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 14, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 4 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 18, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                            If Channel = 5 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 22, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 6 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 26, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 7 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 30, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 8 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 34, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                            If Channel = 9 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 38, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 10 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 42, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 11 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 46, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 12 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 50, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                            If Channel = 13 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 54, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 14 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 58, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 15 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 62, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 16 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 66, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                            Return Result
                        End Function
                    End Class

                    Public Class PCA9634
                        'This library Implementation is not complete
                        Public Shared Sub Setup(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Frequency As Integer)
                            Dim Result As Byte()
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H3, &H6)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H0, &H10)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &HFE, &H5)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H0, &H0)
                            Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, &H0, 161)
                        End Sub
                        'This library Implementation is not complete
                        Public Shared Function SetChannel(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer, Value As Integer)
                            Dim Result As Byte()
                            If Channel = 1 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 6, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 2 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 10, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 3 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 14, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 4 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 18, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                            If Channel = 5 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 22, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 6 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 26, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 7 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 30, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                            If Channel = 8 Then Result = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, 34, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                            Return Result
                        End Function
                    End Class

                    Public Class ADS7828

                        Public Shared Function Read_Channel(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer)

                            If Channel > 7 Then GoTo InvalidSettings

                            Dim CRG As Integer
                            Dim BitChannel As Integer
                            '                         Dim BitConversion As Integer = 16  'Conversion Mode =    Bit 4 = 1

                            Dim SD As Byte = 128    'Bit 7
                            Dim C2 As Byte = 64     'Bit 6
                            Dim C1 As Byte = 32     'Bit 5
                            Dim C0 As Byte = 16     'Bit 4
                            Dim PD1 As Byte = 0     'Bit 3
                            Dim PD0 As Byte = 4     'Bit 2
                            'Bits 0 and 1 are Not Allocated

                            'Channel = 0 to 7                Bit 6-5
                            If Channel = 0 Then BitChannel = (C2 * 0) + (C1 * 0) + (C0 * 0)
                            If Channel = 1 Then BitChannel = (C2 * 1) + (C1 * 0) + (C0 * 0)
                            If Channel = 2 Then BitChannel = (C2 * 0) + (C1 * 0) + (C0 * 1)
                            If Channel = 3 Then BitChannel = (C2 * 1) + (C1 * 0) + (C0 * 1)
                            If Channel = 4 Then BitChannel = (C2 * 0) + (C1 * 1) + (C0 * 0)
                            If Channel = 5 Then BitChannel = (C2 * 1) + (C1 * 1) + (C0 * 0)
                            If Channel = 6 Then BitChannel = (C2 * 0) + (C1 * 1) + (C0 * 1)
                            If Channel = 7 Then BitChannel = (C2 * 1) + (C1 * 1) + (C0 * 1)


                            CRG = SD + BitChannel + PD1 + PD0

                            'Debug.Print("-----------CRG----------- " + CRG.ToString)
                            'Debug.Print(NCDLib.Math.DecToBinaryStringStandard(CRG))

                            'Dim result1() As Byte = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, CRG)
                            'Dim result2() As Byte = NCDLib.Enterprise.Hardware.I2C.Read(ncdObj, I2CPort, Address, 2)

                            Dim Result2() As Byte = NCDLib.Enterprise.Hardware.I2C.WriteRead(ncdObj, I2CPort, Address, 2, 0, CRG)

                            If Not (result2 Is Nothing) Then
                                If (result2.Length = 2) Then
                                    Dim d As Long
                                    d = (result2(0) * 256) + result2(1)
                                    Debug.Print(d.ToString)
                                    Read_Channel = d
                                    Return Read_Channel
                                End If
                            End If
                            Return -1

InvalidSettings:
                            Debug.Print("---------------------------------------------------")
                            Debug.Print("ERROR: ADS7828 Invalid Parameters")
                            If Channel > 7 Then Debug.Print("ERROR: ADS7828 Invalid Channel")
                            'If Resolution > 2 Then Debug.Print("ERROR: ADS7828 Invalid Resolution")
                            'If Gain > 3 Then Debug.Print("ERROR: ADS7828 Invalid Gain")
                            Debug.Print("---------------------------------------------------")

                        End Function

                    End Class

                    Public Class MCP3428
                        Public Shared Sub SetChannelResolutionGain(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)

                            If Channel > 3 Then GoTo InvalidSettings
                            If Resolution > 2 Then GoTo InvalidSettings
                            If Gain > 3 Then GoTo InvalidSettings

                            Dim CRG As Integer
                            Dim BitChannel As Integer
                            Dim BitConversion As Integer = 16  'Conversion Mode =    Bit 4 = 1
                            Dim BitResolution As Integer
                            Dim BitGain As Integer

                            'Channel = 0 to 3                Bit 6-5
                            If Channel = 0 Then BitChannel = 0
                            If Channel = 1 Then BitChannel = 32
                            If Channel = 2 Then BitChannel = 64
                            If Channel = 3 Then BitChannel = 96

                            'Resolution = 0 to 2  Bit 3-2
                            If Resolution = 0 Then BitResolution = 0    '12-Bit Resolution
                            If Resolution = 1 Then BitResolution = 4    '14-Bit Resolution
                            If Resolution = 2 Then BitResolution = 8    '16-Bit Resolution

                            'Gain = 0 to 3        Bit 1-0
                            If Gain = 0 Then BitGain = 0    'x1 Gain
                            If Gain = 1 Then BitGain = 1    'x2 Gain
                            If Gain = 2 Then BitGain = 2    'x4 Gain
                            If Gain = 3 Then BitGain = 3    'x8 Gain
                            '0 + 8 + 1 + 16
                            CRG = BitChannel + BitConversion + BitResolution + BitGain

                            'Debug.Print("-----------CRG----------- " + Channel.ToString)
                            'Debug.Print(NCDLib.Math.DecToBinaryStringStandard(CRG))

                            If I2CPort <> 0 Then
                                NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, CRG)
                            Else
                                NCDLib.I2CBasic.Write(ncdObj, Address, CRG)
                            End If

                            Exit Sub

InvalidSettings:
                            Debug.Print("---------------------------------------------------")
                            Debug.Print("ERROR: MCP3428 Invalid Parameters")
                            If Channel > 3 Then Debug.Print("ERROR: MCP3428 Invalid Channel")
                            If Resolution > 2 Then Debug.Print("ERROR: MCP3428 Invalid Resolution")
                            If Gain > 3 Then Debug.Print("ERROR: MCP3428 Invalid Gain")
                            Debug.Print("---------------------------------------------------")
                        End Sub

                        '  Public Shared Sub Setup_Channel(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)
                        '
                        '      NCDLib.Enterprise.Hardware.I2C.Chip.MCP3428.SetChannelResolutionGain(ncdObj, I2CPort, Address, Channel, Resolution, Gain)
                        '
                        '  End Sub

                        ' Public Shared Function Read_Channel_OLD(ByRef ncdObj As NCDEnterprise.NCDController, Port As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)
                        '
                        '
                        '     NCDLib.Enterprise.Hardware.I2C.Chip.MCP3428.SetChannelResolutionGain(ncdObj, Port, Address, Channel, Resolution, Gain)
                        '
                        '     'Wait for I2C Chip to Finish ADC Conversion
                        '     If Resolution = 2 Then
                        '         ncdObj.Sleep(66) ' Delay 1/15th Second
                        '     End If
                        '
                        '     Dim result() As Byte = NCDLib.Enterprise.Hardware.I2C.Read(ncdObj, Port, Address, 2)
                        '
                        '     If Not (result Is Nothing) Then
                        '         If (result.Length = 3) Then
                        '             Dim d As Long
                        '
                        '             'Debug.Print("---------Resolution---" + Resolution.ToString)
                        '
                        '             If Resolution = 0 Then
                        '                 'Debug.Print("12-Bit Resolution")
                        '                 d = (result(1) And &HF) * 256 + result(2) '(result(1) * 256 + result(2))
                        '             Else
                        '                 ' Debug.Print("High Resolution")
                        '                 d = (result(1) * 256) + result(2) '(result(1) * 256 + result(2))
                        '             End If
                        '             Debug.Print(d.ToString)
                        '             Read_Channel_OLD = d
                        '             Return Read_Channel_OLD
                        '         End If
                        '     End If
                        '     Return -1
                        '
                        ' End Function

                        Public Shared Function Read_Channel(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)

                            If Channel > 3 Then GoTo InvalidSettings
                            If Resolution > 2 Then GoTo InvalidSettings
                            If Gain > 3 Then GoTo InvalidSettings

                            Dim CRG As Integer
                            Dim BitChannel As Integer
                            Dim BitConversion As Integer = 16  'Conversion Mode =    Bit 4 = 1
                            Dim BitResolution As Integer
                            Dim BitGain As Integer

                            'Channel = 0 to 3                Bit 6-5
                            If Channel = 0 Then BitChannel = 0
                            If Channel = 1 Then BitChannel = 32
                            If Channel = 2 Then BitChannel = 64
                            If Channel = 3 Then BitChannel = 96

                            'Resolution = 0 to 2  Bit 3-2
                            If Resolution = 0 Then BitResolution = 0    '12-Bit Resolution
                            If Resolution = 1 Then BitResolution = 4    '14-Bit Resolution
                            If Resolution = 2 Then BitResolution = 8    '16-Bit Resolution

                            'Gain = 0 to 3        Bit 1-0
                            If Gain = 0 Then BitGain = 0    'x1 Gain
                            If Gain = 1 Then BitGain = 1    'x2 Gain
                            If Gain = 2 Then BitGain = 2    'x4 Gain
                            If Gain = 3 Then BitGain = 3    'x8 Gain
                            '0 + 8 + 1 + 16
                            CRG = BitChannel + BitConversion + BitResolution + BitGain

                            'Debug.Print("-----------CRG----------- " + Channel.ToString)
                            'Debug.Print(NCDLib.Math.DecToBinaryStringStandard(CRG))

                            Dim result() As Byte = NCDLib.Enterprise.Hardware.I2C.WriteRead(ncdObj, I2CPort, Address, 2, 22, CRG)

                            If Not (result Is Nothing) Then
                                If (result.Length = 2) Then
                                    Dim d As Long
                                    If Resolution = 0 Then
                                        'Debug.Print("12-Bit Resolution")
                                        d = (result(0) And &HF) * 256 + result(1) '(result(1) * 256 + result(2))
                                    Else
                                        ' Debug.Print("High Resolution")
                                        d = (result(0) * 256) + result(1) '(result(1) * 256 + result(2))
                                    End If
                                    Debug.Print(d.ToString)
                                    Read_Channel = d
                                    Return Read_Channel
                                End If
                            End If
                            Return -1

InvalidSettings:
                            Debug.Print("---------------------------------------------------")
                            Debug.Print("ERROR: MCP3428 Invalid Parameters")
                            If Channel > 3 Then Debug.Print("ERROR: MCP3428 Invalid Channel")
                            If Resolution > 2 Then Debug.Print("ERROR: MCP3428 Invalid Resolution")
                            If Gain > 3 Then Debug.Print("ERROR: MCP3428 Invalid Gain")
                            Debug.Print("---------------------------------------------------")

                        End Function

                    End Class

                End Class

                Public Shared Function Read(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, RXBytes As Integer) As Byte()

                    Dim aI(4) As Byte

                    I2CError = ""

                    aI(0) = 189                  'Byte 0
                    aI(1) = I2CPort              'Byte 1
                    aI(2) = 191                  'Byte 2
                    aI(3) = Address              'Byte 3
                    aI(4) = RXBytes              'Byte 4

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function
                Public Shared Function Write(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()

                    Dim TransmitCount As Integer = TXDAT.Length
                    Dim aI(TransmitCount + 3) As Byte

                    I2CError = ""
                    aI(0) = 189                  'Byte 0
                    aI(1) = I2CPort              'Byte 1
                    aI(2) = 190                  'Byte 2
                    aI(3) = Address              'Byte 3
                    For i1 As Integer = 0 To TransmitCount - 1
                        aI(i1 + 4) = TXDAT(i1) 'Int(txArray(i1).Text)
                    Next

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    ' Debug.Print("-------------- I2C Write Command:")
                    ' For Each a In aI
                    '     Debug.Print(a)
                    ' Next
                    ' Debug.Print("-------------- END Command")


                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = ("I2C Write - Error Package:")
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If

                End Function
                Public Shared Function WriteLite(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()

                    Dim TransmitCount As Integer = TXDAT.Length
                    Dim aI(TransmitCount + 1) As Byte

                    I2CError = ""
                    aI(0) = 190                  'Byte 2
                    aI(1) = Address              'Byte 3
                    For i1 As Integer = 0 To TransmitCount - 1
                        aI(i1 + 2) = TXDAT(i1) 'Int(txArray(i1).Text)
                    Next

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    Debug.Print("-------------- I2C Write Command:")
                    For Each a In aI
                        Debug.Print(a)
                    Next
                    Debug.Print("-------------- END Command")


                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = ("I2C Write - Error Package:")
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If

                End Function
                Public Shared Function WriteRead(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, RXBytes As Integer, Delay As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()

                    Dim TransmitCount As Integer = TXDAT.Length
                    Dim aI(TransmitCount + 5) As Byte

                    I2CError = ""
                    aI(0) = 189                  'Byte 0
                    aI(1) = I2CPort              'Byte 1
                    aI(2) = 192                  'Byte 2
                    aI(3) = Address              'Byte 3
                    aI(4) = RXBytes              'Byte 4
                    aI(5) = Delay                'Byte 5
                    For i1 As Integer = 0 To TransmitCount - 1
                        aI(i1 + 6) = TXDAT(i1) 'Int(txArray(i1).Text)
                    Next

                    Debug.Print("DUMP BEGIN")
                    For Temp As Integer = 0 To aI.Length - 1
                        Debug.Print(aI(Temp).ToString)
                    Next
                    Debug.Print("DUMP END")

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function

                Public Shared Function Scan(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                    Dim aI(3) As Byte

                    '189 2 192 0

                    I2CError = ""

                    aI(0) = 189                  'Select I2C Port Command
                    aI(1) = I2CPort              'Port Selection
                    aI(2) = 193                  'Byte 0 Updated I2C Scan
                    aI(3) = 0                    'Byte 1

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)

                    If (Not (rData Is Nothing)) Then
                        Debug.Print("-------------- I2C Scan Command:")
                        For Each a In rData
                            Debug.Print(a)
                        Next
                        Debug.Print("-------------- END Command")
                    End If


                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function
                Public Shared Function PortSet(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                    Dim aI(1) As Byte

                    I2CError = ""
                    aI(0) = 188                  'Byte 0
                    aI(1) = I2CPort              'Byte 1

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function

                Public Shared Function PortGet(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, RXBytes As Integer) As Byte()

                    Dim aI(1) As Byte

                    I2CError = ""
                    aI(0) = 188                  'Byte 0
                    aI(1) = 255                  'Byte 1


                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function

            End Class
        End Class

    End Class

    Public Class ExtendedMemoryMenu
        Public Shared Function GetDescription(Address As Integer) As String


            ' Dim ReturnString As String = ""
            ' If Address > 0 And Address < 256 Then
            '
            '     ReturnString = "Relay Port "
            '     ReturnString = ReturnString + Int((Address / 16) + 1).ToString
            '     ReturnString = ReturnString + " Bank "
            ' End If


            ' Dim FILE_NAME As String = "E:\Numbers.txt"
            '
            ' If System.IO.File.Exists(FILE_NAME) = True Then
            '
            '     Dim objWriter As New System.IO.StreamWriter(FILE_NAME)
            '     Dim Counter As Integer = 1
            '
            '     For Temp As Integer = 256 To 1023
            '         objWriter.Write("Case " + Temp.ToString + " : Return 0" + Chr(13) + Chr(10))
            '         Counter = Counter + 1
            '         If Counter = 17 Then
            '             Counter = 1
            '             objWriter.Write("   " + Chr(13) + Chr(10))
            '         End If
            '     Next Temp
            '
            '     objWriter.Close()
            '     MessageBox.Show("Text written to file")
            '     End
            '
            ' Else
            '     MessageBox.Show("File Does Not Exist")
            '     End
            '
            ' End If

            Select Case Address
                Case 8000 : Return "Serial Number 1 Sensor 1"
                Case 8001 : Return "Serial Number 2"
                Case 8002 : Return "Serial Number 3"
                Case 8003 : Return "Serial Number 4"
                Case 8004 : Return "Serial Number 5"
                Case 8005 : Return "Serial Number 6"
                Case 8006 : Return "Serial Number 7"
                Case 8007 : Return "Serial Number 8"
                Case 8008 : Return "Sensor Type"
                Case 8009 : Return "Sensor Value Start Byte"
                Case 8010 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8011 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8012 : Return "Macro to Trigger Below Limit 1"
                Case 8013 : Return "Limit 1 MSB"
                Case 8014 : Return "Limit 1 LSB"
                Case 8015 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8016 : Return "Limit 2 MSB"
                Case 8017 : Return "Limit 2 LSB"
                Case 8018 : Return "Macro to Trigger Above Limit 2"
                Case 8019 : Return "Current Sensor Value MSB3"
                Case 8020 : Return "Current Sensor Value MSB2"
                Case 8021 : Return "Current Sensor Value MSB"
                Case 8022 : Return "Current Sensor Value LSB"
                Case 8023 : Return "Last Sensor Value MSB3"
                Case 8024 : Return "Last Sensor Value MSB2"
                Case 8025 : Return "Last Sensor Value MSB"
                Case 8026 : Return "Last Sensor Value LSB"
                Case 8027 : Return "Meta Data 1"
                Case 8028 : Return "Meta Data 2"
                Case 8029 : Return "Meta Data 3"
                Case 8030 : Return "Meta Data 4"
                Case 8031 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8032 : Return "Serial Number 1 Sensor 2"
                Case 8033 : Return "Serial Number 2"
                Case 8034 : Return "Serial Number 3"
                Case 8035 : Return "Serial Number 4"
                Case 8036 : Return "Serial Number 5"
                Case 8037 : Return "Serial Number 6"
                Case 8038 : Return "Serial Number 7"
                Case 8039 : Return "Serial Number 8"
                Case 8040 : Return "Sensor Type"
                Case 8041 : Return "Sensor Value Start Byte"
                Case 8042 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8043 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8044 : Return "Macro to Trigger Below Limit 1"
                Case 8045 : Return "Limit 1 MSB"
                Case 8046 : Return "Limit 1 LSB"
                Case 8047 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8048 : Return "Limit 2 MSB"
                Case 8049 : Return "Limit 2 LSB"
                Case 8050 : Return "Macro to Trigger Above Limit 2"
                Case 8051 : Return "Current Sensor Value MSB3"
                Case 8052 : Return "Current Sensor Value MSB2"
                Case 8053 : Return "Current Sensor Value MSB"
                Case 8054 : Return "Current Sensor Value LSB"
                Case 8055 : Return "Last Sensor Value MSB3"
                Case 8056 : Return "Last Sensor Value MSB2"
                Case 8057 : Return "Last Sensor Value MSB"
                Case 8058 : Return "Last Sensor Value LSB"
                Case 8059 : Return "Meta Data 1"
                Case 8060 : Return "Meta Data 2"
                Case 8061 : Return "Meta Data 3"
                Case 8062 : Return "Meta Data 4"
                Case 8063 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8064 : Return "Serial Number 1 Sensor 3"
                Case 8065 : Return "Serial Number 2"
                Case 8066 : Return "Serial Number 3"
                Case 8067 : Return "Serial Number 4"
                Case 8068 : Return "Serial Number 5"
                Case 8069 : Return "Serial Number 6"
                Case 8070 : Return "Serial Number 7"
                Case 8071 : Return "Serial Number 8"
                Case 8072 : Return "Sensor Type"
                Case 8073 : Return "Sensor Value Start Byte"
                Case 8074 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8075 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8076 : Return "Macro to Trigger Below Limit 1"
                Case 8077 : Return "Limit 1 MSB"
                Case 8078 : Return "Limit 1 LSB"
                Case 8079 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8080 : Return "Limit 2 MSB"
                Case 8081 : Return "Limit 2 LSB"
                Case 8082 : Return "Macro to Trigger Above Limit 2"
                Case 8083 : Return "Current Sensor Value MSB3"
                Case 8084 : Return "Current Sensor Value MSB2"
                Case 8085 : Return "Current Sensor Value MSB"
                Case 8086 : Return "Current Sensor Value LSB"
                Case 8087 : Return "Last Sensor Value MSB3"
                Case 8088 : Return "Last Sensor Value MSB2"
                Case 8089 : Return "Last Sensor Value MSB"
                Case 8090 : Return "Last Sensor Value LSB"
                Case 8091 : Return "Meta Data 1"
                Case 8092 : Return "Meta Data 2"
                Case 8093 : Return "Meta Data 3"
                Case 8094 : Return "Meta Data 4"
                Case 8095 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8096 : Return "Serial Number 1 Sensor 4"
                Case 8097 : Return "Serial Number 2"
                Case 8098 : Return "Serial Number 3"
                Case 8099 : Return "Serial Number 4"
                Case 8100 : Return "Serial Number 5"
                Case 8101 : Return "Serial Number 6"
                Case 8102 : Return "Serial Number 7"
                Case 8103 : Return "Serial Number 8"
                Case 8104 : Return "Sensor Type"
                Case 8105 : Return "Sensor Value Start Byte"
                Case 8106 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8107 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8108 : Return "Macro to Trigger Below Limit 1"
                Case 8109 : Return "Limit 1 MSB"
                Case 8110 : Return "Limit 1 LSB"
                Case 8111 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8112 : Return "Limit 2 MSB"
                Case 8113 : Return "Limit 2 LSB"
                Case 8114 : Return "Macro to Trigger Above Limit 2"
                Case 8115 : Return "Current Sensor Value MSB3"
                Case 8116 : Return "Current Sensor Value MSB2"
                Case 8117 : Return "Current Sensor Value MSB"
                Case 8118 : Return "Current Sensor Value LSB"
                Case 8119 : Return "Last Sensor Value MSB3"
                Case 8120 : Return "Last Sensor Value MSB2"
                Case 8121 : Return "Last Sensor Value MSB"
                Case 8122 : Return "Last Sensor Value LSB"
                Case 8123 : Return "Meta Data 1"
                Case 8124 : Return "Meta Data 2"
                Case 8125 : Return "Meta Data 3"
                Case 8126 : Return "Meta Data 4"
                Case 8127 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8128 : Return "Serial Number 1 Sensor 5"
                Case 8129 : Return "Serial Number 2"
                Case 8130 : Return "Serial Number 3"
                Case 8131 : Return "Serial Number 4"
                Case 8132 : Return "Serial Number 5"
                Case 8133 : Return "Serial Number 6"
                Case 8134 : Return "Serial Number 7"
                Case 8135 : Return "Serial Number 8"
                Case 8136 : Return "Sensor Type"
                Case 8137 : Return "Sensor Value Start Byte"
                Case 8138 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8139 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8140 : Return "Macro to Trigger Below Limit 1"
                Case 8141 : Return "Limit 1 MSB"
                Case 8142 : Return "Limit 1 LSB"
                Case 8143 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8144 : Return "Limit 2 MSB"
                Case 8145 : Return "Limit 2 LSB"
                Case 8146 : Return "Macro to Trigger Above Limit 2"
                Case 8147 : Return "Current Sensor Value MSB3"
                Case 8148 : Return "Current Sensor Value MSB2"
                Case 8149 : Return "Current Sensor Value MSB"
                Case 8150 : Return "Current Sensor Value LSB"
                Case 8151 : Return "Last Sensor Value MSB3"
                Case 8152 : Return "Last Sensor Value MSB2"
                Case 8153 : Return "Last Sensor Value MSB"
                Case 8154 : Return "Last Sensor Value LSB"
                Case 8155 : Return "Meta Data 1"
                Case 8156 : Return "Meta Data 2"
                Case 8157 : Return "Meta Data 3"
                Case 8158 : Return "Meta Data 4"
                Case 8159 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8160 : Return "Serial Number 1 Sensor 6"
                Case 8161 : Return "Serial Number 2"
                Case 8162 : Return "Serial Number 3"
                Case 8163 : Return "Serial Number 4"
                Case 8164 : Return "Serial Number 5"
                Case 8165 : Return "Serial Number 6"
                Case 8166 : Return "Serial Number 7"
                Case 8167 : Return "Serial Number 8"
                Case 8168 : Return "Sensor Type"
                Case 8169 : Return "Sensor Value Start Byte"
                Case 8170 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8171 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8172 : Return "Macro to Trigger Below Limit 1"
                Case 8173 : Return "Limit 1 MSB"
                Case 8174 : Return "Limit 1 LSB"
                Case 8175 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8176 : Return "Limit 2 MSB"
                Case 8177 : Return "Limit 2 LSB"
                Case 8178 : Return "Macro to Trigger Above Limit 2"
                Case 8179 : Return "Current Sensor Value MSB3"
                Case 8180 : Return "Current Sensor Value MSB2"
                Case 8181 : Return "Current Sensor Value MSB"
                Case 8182 : Return "Current Sensor Value LSB"
                Case 8183 : Return "Last Sensor Value MSB3"
                Case 8184 : Return "Last Sensor Value MSB2"
                Case 8185 : Return "Last Sensor Value MSB"
                Case 8186 : Return "Last Sensor Value LSB"
                Case 8187 : Return "Meta Data 1"
                Case 8188 : Return "Meta Data 2"
                Case 8189 : Return "Meta Data 3"
                Case 8190 : Return "Meta Data 4"
                Case 8191 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8192 : Return "Serial Number 1 Sensor 7"
                Case 8193 : Return "Serial Number 2"
                Case 8194 : Return "Serial Number 3"
                Case 8195 : Return "Serial Number 4"
                Case 8196 : Return "Serial Number 5"
                Case 8197 : Return "Serial Number 6"
                Case 8198 : Return "Serial Number 7"
                Case 8199 : Return "Serial Number 8"
                Case 8200 : Return "Sensor Type"
                Case 8201 : Return "Sensor Value Start Byte"
                Case 8202 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8203 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8204 : Return "Macro to Trigger Below Limit 1"
                Case 8205 : Return "Limit 1 MSB"
                Case 8206 : Return "Limit 1 LSB"
                Case 8207 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8208 : Return "Limit 2 MSB"
                Case 8209 : Return "Limit 2 LSB"
                Case 8210 : Return "Macro to Trigger Above Limit 2"
                Case 8211 : Return "Current Sensor Value MSB3"
                Case 8212 : Return "Current Sensor Value MSB2"
                Case 8213 : Return "Current Sensor Value MSB"
                Case 8214 : Return "Current Sensor Value LSB"
                Case 8215 : Return "Last Sensor Value MSB3"
                Case 8216 : Return "Last Sensor Value MSB2"
                Case 8217 : Return "Last Sensor Value MSB"
                Case 8218 : Return "Last Sensor Value LSB"
                Case 8219 : Return "Meta Data 1"
                Case 8220 : Return "Meta Data 2"
                Case 8221 : Return "Meta Data 3"
                Case 8222 : Return "Meta Data 4"
                Case 8223 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8224 : Return "Serial Number 1 Sensor 8"
                Case 8225 : Return "Serial Number 2"
                Case 8226 : Return "Serial Number 3"
                Case 8227 : Return "Serial Number 4"
                Case 8228 : Return "Serial Number 5"
                Case 8229 : Return "Serial Number 6"
                Case 8230 : Return "Serial Number 7"
                Case 8231 : Return "Serial Number 8"
                Case 8232 : Return "Sensor Type"
                Case 8233 : Return "Sensor Value Start Byte"
                Case 8234 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8235 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8236 : Return "Macro to Trigger Below Limit 1"
                Case 8237 : Return "Limit 1 MSB"
                Case 8238 : Return "Limit 1 LSB"
                Case 8239 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8240 : Return "Limit 2 MSB"
                Case 8241 : Return "Limit 2 LSB"
                Case 8242 : Return "Macro to Trigger Above Limit 2"
                Case 8243 : Return "Current Sensor Value MSB3"
                Case 8244 : Return "Current Sensor Value MSB2"
                Case 8245 : Return "Current Sensor Value MSB"
                Case 8246 : Return "Current Sensor Value LSB"
                Case 8247 : Return "Last Sensor Value MSB3"
                Case 8248 : Return "Last Sensor Value MSB2"
                Case 8249 : Return "Last Sensor Value MSB"
                Case 8250 : Return "Last Sensor Value LSB"
                Case 8251 : Return "Meta Data 1"
                Case 8252 : Return "Meta Data 2"
                Case 8253 : Return "Meta Data 3"
                Case 8254 : Return "Meta Data 4"
                Case 8255 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8256 : Return "Serial Number 1 Sensor 9"
                Case 8257 : Return "Serial Number 2"
                Case 8258 : Return "Serial Number 3"
                Case 8259 : Return "Serial Number 4"
                Case 8260 : Return "Serial Number 5"
                Case 8261 : Return "Serial Number 6"
                Case 8262 : Return "Serial Number 7"
                Case 8263 : Return "Serial Number 8"
                Case 8264 : Return "Sensor Type"
                Case 8265 : Return "Sensor Value Start Byte"
                Case 8266 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8267 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8268 : Return "Macro to Trigger Below Limit 1"
                Case 8269 : Return "Limit 1 MSB"
                Case 8270 : Return "Limit 1 LSB"
                Case 8271 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8272 : Return "Limit 2 MSB"
                Case 8273 : Return "Limit 2 LSB"
                Case 8274 : Return "Macro to Trigger Above Limit 2"
                Case 8275 : Return "Current Sensor Value MSB3"
                Case 8276 : Return "Current Sensor Value MSB2"
                Case 8277 : Return "Current Sensor Value MSB"
                Case 8278 : Return "Current Sensor Value LSB"
                Case 8279 : Return "Last Sensor Value MSB3"
                Case 8280 : Return "Last Sensor Value MSB2"
                Case 8281 : Return "Last Sensor Value MSB"
                Case 8282 : Return "Last Sensor Value LSB"
                Case 8283 : Return "Meta Data 1"
                Case 8284 : Return "Meta Data 2"
                Case 8285 : Return "Meta Data 3"
                Case 8286 : Return "Meta Data 4"
                Case 8287 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8288 : Return "Serial Number 1 Sensor 10"
                Case 8289 : Return "Serial Number 2"
                Case 8290 : Return "Serial Number 3"
                Case 8291 : Return "Serial Number 4"
                Case 8292 : Return "Serial Number 5"
                Case 8293 : Return "Serial Number 6"
                Case 8294 : Return "Serial Number 7"
                Case 8295 : Return "Serial Number 8"
                Case 8296 : Return "Sensor Type"
                Case 8297 : Return "Sensor Value Start Byte"
                Case 8298 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8299 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8300 : Return "Macro to Trigger Below Limit 1"
                Case 8301 : Return "Limit 1 MSB"
                Case 8302 : Return "Limit 1 LSB"
                Case 8303 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8304 : Return "Limit 2 MSB"
                Case 8305 : Return "Limit 2 LSB"
                Case 8306 : Return "Macro to Trigger Above Limit 2"
                Case 8307 : Return "Current Sensor Value MSB3"
                Case 8308 : Return "Current Sensor Value MSB2"
                Case 8309 : Return "Current Sensor Value MSB"
                Case 8310 : Return "Current Sensor Value LSB"
                Case 8311 : Return "Last Sensor Value MSB3"
                Case 8312 : Return "Last Sensor Value MSB2"
                Case 8313 : Return "Last Sensor Value MSB"
                Case 8314 : Return "Last Sensor Value LSB"
                Case 8315 : Return "Meta Data 1"
                Case 8316 : Return "Meta Data 2"
                Case 8317 : Return "Meta Data 3"
                Case 8318 : Return "Meta Data 4"
                Case 8319 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8320 : Return "Serial Number 1 Sensor 11"
                Case 8321 : Return "Serial Number 2"
                Case 8322 : Return "Serial Number 3"
                Case 8323 : Return "Serial Number 4"
                Case 8324 : Return "Serial Number 5"
                Case 8325 : Return "Serial Number 6"
                Case 8326 : Return "Serial Number 7"
                Case 8327 : Return "Serial Number 8"
                Case 8328 : Return "Sensor Type"
                Case 8329 : Return "Sensor Value Start Byte"
                Case 8330 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8331 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8332 : Return "Macro to Trigger Below Limit 1"
                Case 8333 : Return "Limit 1 MSB"
                Case 8334 : Return "Limit 1 LSB"
                Case 8335 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8336 : Return "Limit 2 MSB"
                Case 8337 : Return "Limit 2 LSB"
                Case 8338 : Return "Macro to Trigger Above Limit 2"
                Case 8339 : Return "Current Sensor Value MSB3"
                Case 8340 : Return "Current Sensor Value MSB2"
                Case 8341 : Return "Current Sensor Value MSB"
                Case 8342 : Return "Current Sensor Value LSB"
                Case 8343 : Return "Last Sensor Value MSB3"
                Case 8344 : Return "Last Sensor Value MSB2"
                Case 8345 : Return "Last Sensor Value MSB"
                Case 8346 : Return "Last Sensor Value LSB"
                Case 8347 : Return "Meta Data 1"
                Case 8348 : Return "Meta Data 2"
                Case 8349 : Return "Meta Data 3"
                Case 8350 : Return "Meta Data 4"
                Case 8351 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8352 : Return "Serial Number 1 Sensor 12"
                Case 8353 : Return "Serial Number 2"
                Case 8354 : Return "Serial Number 3"
                Case 8355 : Return "Serial Number 4"
                Case 8356 : Return "Serial Number 5"
                Case 8357 : Return "Serial Number 6"
                Case 8358 : Return "Serial Number 7"
                Case 8359 : Return "Serial Number 8"
                Case 8360 : Return "Sensor Type"
                Case 8361 : Return "Sensor Value Start Byte"
                Case 8362 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8363 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8364 : Return "Macro to Trigger Below Limit 1"
                Case 8365 : Return "Limit 1 MSB"
                Case 8366 : Return "Limit 1 LSB"
                Case 8367 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8368 : Return "Limit 2 MSB"
                Case 8369 : Return "Limit 2 LSB"
                Case 8370 : Return "Macro to Trigger Above Limit 2"
                Case 8371 : Return "Current Sensor Value MSB3"
                Case 8372 : Return "Current Sensor Value MSB2"
                Case 8373 : Return "Current Sensor Value MSB"
                Case 8374 : Return "Current Sensor Value LSB"
                Case 8375 : Return "Last Sensor Value MSB3"
                Case 8376 : Return "Last Sensor Value MSB2"
                Case 8377 : Return "Last Sensor Value MSB"
                Case 8378 : Return "Last Sensor Value LSB"
                Case 8379 : Return "Meta Data 1"
                Case 8380 : Return "Meta Data 2"
                Case 8381 : Return "Meta Data 3"
                Case 8382 : Return "Meta Data 4"
                Case 8383 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8384 : Return "Serial Number 1 Sensor 13"
                Case 8385 : Return "Serial Number 2"
                Case 8386 : Return "Serial Number 3"
                Case 8387 : Return "Serial Number 4"
                Case 8388 : Return "Serial Number 5"
                Case 8389 : Return "Serial Number 6"
                Case 8390 : Return "Serial Number 7"
                Case 8391 : Return "Serial Number 8"
                Case 8392 : Return "Sensor Type"
                Case 8393 : Return "Sensor Value Start Byte"
                Case 8394 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8395 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8396 : Return "Macro to Trigger Below Limit 1"
                Case 8397 : Return "Limit 1 MSB"
                Case 8398 : Return "Limit 1 LSB"
                Case 8399 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8400 : Return "Limit 2 MSB"
                Case 8401 : Return "Limit 2 LSB"
                Case 8402 : Return "Macro to Trigger Above Limit 2"
                Case 8403 : Return "Current Sensor Value MSB3"
                Case 8404 : Return "Current Sensor Value MSB2"
                Case 8405 : Return "Current Sensor Value MSB"
                Case 8406 : Return "Current Sensor Value LSB"
                Case 8407 : Return "Last Sensor Value MSB3"
                Case 8408 : Return "Last Sensor Value MSB2"
                Case 8409 : Return "Last Sensor Value MSB"
                Case 8410 : Return "Last Sensor Value LSB"
                Case 8411 : Return "Meta Data 1"
                Case 8412 : Return "Meta Data 2"
                Case 8413 : Return "Meta Data 3"
                Case 8414 : Return "Meta Data 4"
                Case 8415 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8416 : Return "Serial Number 1 Sensor 14"
                Case 8417 : Return "Serial Number 2"
                Case 8418 : Return "Serial Number 3"
                Case 8419 : Return "Serial Number 4"
                Case 8420 : Return "Serial Number 5"
                Case 8421 : Return "Serial Number 6"
                Case 8422 : Return "Serial Number 7"
                Case 8423 : Return "Serial Number 8"
                Case 8424 : Return "Sensor Type"
                Case 8425 : Return "Sensor Value Start Byte"
                Case 8426 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8427 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8428 : Return "Macro to Trigger Below Limit 1"
                Case 8429 : Return "Limit 1 MSB"
                Case 8430 : Return "Limit 1 LSB"
                Case 8431 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8432 : Return "Limit 2 MSB"
                Case 8433 : Return "Limit 2 LSB"
                Case 8434 : Return "Macro to Trigger Above Limit 2"
                Case 8435 : Return "Current Sensor Value MSB3"
                Case 8436 : Return "Current Sensor Value MSB2"
                Case 8437 : Return "Current Sensor Value MSB"
                Case 8438 : Return "Current Sensor Value LSB"
                Case 8439 : Return "Last Sensor Value MSB3"
                Case 8440 : Return "Last Sensor Value MSB2"
                Case 8441 : Return "Last Sensor Value MSB"
                Case 8442 : Return "Last Sensor Value LSB"
                Case 8443 : Return "Meta Data 1"
                Case 8444 : Return "Meta Data 2"
                Case 8445 : Return "Meta Data 3"
                Case 8446 : Return "Meta Data 4"
                Case 8447 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8448 : Return "Serial Number 1 Sensor 15"
                Case 8449 : Return "Serial Number 2"
                Case 8450 : Return "Serial Number 3"
                Case 8451 : Return "Serial Number 4"
                Case 8452 : Return "Serial Number 5"
                Case 8453 : Return "Serial Number 6"
                Case 8454 : Return "Serial Number 7"
                Case 8455 : Return "Serial Number 8"
                Case 8456 : Return "Sensor Type"
                Case 8457 : Return "Sensor Value Start Byte"
                Case 8458 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8459 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8460 : Return "Macro to Trigger Below Limit 1"
                Case 8461 : Return "Limit 1 MSB"
                Case 8462 : Return "Limit 1 LSB"
                Case 8463 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8464 : Return "Limit 2 MSB"
                Case 8465 : Return "Limit 2 LSB"
                Case 8466 : Return "Macro to Trigger Above Limit 2"
                Case 8467 : Return "Current Sensor Value MSB3"
                Case 8468 : Return "Current Sensor Value MSB2"
                Case 8469 : Return "Current Sensor Value MSB"
                Case 8470 : Return "Current Sensor Value LSB"
                Case 8471 : Return "Last Sensor Value MSB3"
                Case 8472 : Return "Last Sensor Value MSB2"
                Case 8473 : Return "Last Sensor Value MSB"
                Case 8474 : Return "Last Sensor Value LSB"
                Case 8475 : Return "Meta Data 1"
                Case 8476 : Return "Meta Data 2"
                Case 8477 : Return "Meta Data 3"
                Case 8478 : Return "Meta Data 4"
                Case 8479 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

                Case 8480 : Return "Serial Number 1 Sensor 16"
                Case 8481 : Return "Serial Number 2"
                Case 8482 : Return "Serial Number 3"
                Case 8483 : Return "Serial Number 4"
                Case 8484 : Return "Serial Number 5"
                Case 8485 : Return "Serial Number 6"
                Case 8486 : Return "Serial Number 7"
                Case 8487 : Return "Serial Number 8"
                Case 8488 : Return "Sensor Type"
                Case 8489 : Return "Sensor Value Start Byte"
                Case 8490 : Return "Handler (8,16,24,32,MSB/LSB,LSB/MSB)"
                Case 8491 : Return "Number of Limits 0=None, 1, or 2 Limits, 3=Mirror"
                Case 8492 : Return "Macro to Trigger Below Limit 1"
                Case 8493 : Return "Limit 1 MSB"
                Case 8494 : Return "Limit 1 LSB"
                Case 8495 : Return "Macro to Trigger Between Limit 1 and 2"
                Case 8496 : Return "Limit 2 MSB"
                Case 8497 : Return "Limit 2 LSB"
                Case 8498 : Return "Macro to Trigger Above Limit 2"
                Case 8499 : Return "Current Sensor Value MSB3"
                Case 8500 : Return "Current Sensor Value MSB2"
                Case 8501 : Return "Current Sensor Value MSB"
                Case 8502 : Return "Current Sensor Value LSB"
                Case 8503 : Return "Last Sensor Value MSB3"
                Case 8504 : Return "Last Sensor Value MSB2"
                Case 8505 : Return "Last Sensor Value MSB"
                Case 8506 : Return "Last Sensor Value LSB"
                Case 8507 : Return "Meta Data 1"
                Case 8508 : Return "Meta Data 2"
                Case 8509 : Return "Meta Data 3"
                Case 8510 : Return "Meta Data 4"
                Case 8511 : Return "Mirror Output Conversion Format 0=(4-20mA),1=(0-10V), etc."

            End Select

            Return "Unused Memory Space"

        End Function

    End Class
End Class


























































