﻿Public Class frmNumberCounters
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public FormLoading As Boolean = True
    Private Sub frmNumberCounters_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        For Temp As Integer = 1 To 16
            DataTable.Rows.Add()
        Next Temp
        FillTableA()
        FormLoading = False
    End Sub
    Private Sub StartAddress_ValueChanged(sender As Object, e As EventArgs) Handles StartAddress.ValueChanged
        If FormLoading = False Then
            FillTableA()
        End If
    End Sub
    Public Sub FillTableA()
        Dim I(15) As Byte
        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress.Value, 16)
        If I IsNot Nothing Then
            For Y As Integer = 0 To 15
                Dim Address As Double = StartAddress.Value + Y
                Dim Hex_Value As String
                Hex_Value = Hex(Address)
                CellData(0, Y, Address.ToString + "-" + Hex_Value)
                CellData(1, Y, Hex(I(Y)).ToString)
                CellData(2, Y, I(Y).ToString)
                CellData(3, Y, NCDLib.Enterprise.ProXR.Menu.GetDescription(Address))
            Next Y
        End If

        'Update UI with the Values of all 4 Counters
        Dim Result1 As UInteger = NCDLib.Enterprise.System.NumberCounters.ReadCounter(NCDComponent1, 1)
        Count1.Value = Result1.ToString
        Dim Result2 As UInteger = NCDLib.Enterprise.System.NumberCounters.ReadCounter(NCDComponent1, 2)
        Count2.Value = Result2.ToString
        Dim Result3 As UInteger = NCDLib.Enterprise.System.NumberCounters.ReadCounter(NCDComponent1, 3)
        Count3.Value = Result3.ToString
        Dim Result4 As UInteger = NCDLib.Enterprise.System.NumberCounters.ReadCounter(NCDComponent1, 4)
        Count4.Value = Result4.ToString

    End Sub
    Public Sub FillRow(Row As Integer, Dat As Byte)
        CellData(1, Row, Hex(Dat).ToString)
        CellData(2, Row, Dat.ToString)
    End Sub

    Public Sub CellData(x As Integer, Y As Integer, Dat As String)
        'If FormLoading = False Then
        DataTable(x, Y).Value = Dat
        'End If
    End Sub
    Public Function GetCellData(x As Integer, Y As Integer) As String
        GetCellData = DataTable(x, Y).Value
    End Function
    Private Sub Refresh_Click(sender As Object, e As EventArgs) Handles Refresh.Click
        If FormLoading = False Then
            FillTableA()
        End If
    End Sub


    Private Sub IncreaseCount1_Click(sender As Object, e As EventArgs) Handles IncreaseCount1.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.IncreaseCounter(NCDComponent1, 1)
        Count1.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub DecreaseCount1_Click(sender As Object, e As EventArgs) Handles DecreaseCount1.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.DecreaseCounter(NCDComponent1, 1)
        Count1.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub SetCount1_Click(sender As Object, e As EventArgs) Handles SetCount1.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.SetCounter(NCDComponent1, 1, Count1.Value)
        Count1.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub ResetCounter1_Click(sender As Object, e As EventArgs) Handles ResetCounter1.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.ResetCounter(NCDComponent1, 1)
        Count1.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub ReadCounter1_Click(sender As Object, e As EventArgs) Handles ReadCounter1.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.ReadCounter(NCDComponent1, 1)
        Count1.Value = Result.ToString
        GetTXRXData()
    End Sub



    Private Sub IncreaseCount2_Click(sender As Object, e As EventArgs) Handles IncreaseCount2.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.IncreaseCounter(NCDComponent1, 2)
        Count2.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub DecreaseCount2_Click(sender As Object, e As EventArgs) Handles DecreaseCount2.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.DecreaseCounter(NCDComponent1, 2)
        Count2.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub SetCount2_Click(sender As Object, e As EventArgs) Handles SetCount2.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.SetCounter(NCDComponent1, 2, Count2.Value)
        Count2.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub ResetCounter2_Click(sender As Object, e As EventArgs) Handles ResetCounter2.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.ResetCounter(NCDComponent1, 2)
        Count2.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub ReadCounter2_Click(sender As Object, e As EventArgs) Handles ReadCounter2.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.ReadCounter(NCDComponent1, 2)
        Count2.Value = Result.ToString
        GetTXRXData()
    End Sub



    Private Sub IncreaseCount3_Click(sender As Object, e As EventArgs) Handles IncreaseCount3.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.IncreaseCounter(NCDComponent1, 3)
        Count3.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub DecreaseCount3_Click(sender As Object, e As EventArgs) Handles DecreaseCount3.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.DecreaseCounter(NCDComponent1, 3)
        Count3.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub SetCount3_Click(sender As Object, e As EventArgs) Handles SetCount3.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.SetCounter(NCDComponent1, 3, Count3.Value)
        Count3.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub ResetCounter3_Click(sender As Object, e As EventArgs) Handles ResetCounter3.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.ResetCounter(NCDComponent1, 3)
        Count3.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub ReadCounter3_Click(sender As Object, e As EventArgs) Handles ReadCounter3.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.ReadCounter(NCDComponent1, 3)
        Count3.Value = Result.ToString
        GetTXRXData()
    End Sub



    Private Sub IncreaseCount4_Click(sender As Object, e As EventArgs) Handles IncreaseCount4.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.IncreaseCounter(NCDComponent1, 4)
        Count4.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub DecreaseCount4_Click(sender As Object, e As EventArgs) Handles DecreaseCount4.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.DecreaseCounter(NCDComponent1, 4)
        Count4.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub SetCount4_Click(sender As Object, e As EventArgs) Handles SetCount4.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.SetCounter(NCDComponent1, 4, Count4.Value)
        Count4.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub ResetCounter4_Click(sender As Object, e As EventArgs) Handles ResetCounter4.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.ResetCounter(NCDComponent1, 4)
        Count4.Value = Result.ToString
        GetTXRXData()
    End Sub
    Private Sub ReadCounter4_Click(sender As Object, e As EventArgs) Handles ReadCounter4.Click
        Dim Result As UInteger = NCDLib.Enterprise.System.NumberCounters.ReadCounter(NCDComponent1, 4)
        Count4.Value = Result.ToString
        GetTXRXData()
    End Sub

    Private Sub DetailView_CheckedChanged(sender As Object, e As EventArgs) Handles DetailView.CheckedChanged
        If DetailView.Checked = False Then
            Me.Width = 390
            Me.Height = 519
        Else
            Me.Width = 900
            Me.Height = 519
        End If
    End Sub
    Public Sub GetTXRXData()
        txtTransmitString.Text = NCDLib.GetLastTransmitString
        txtRecString.Text = NCDLib.GetLastReceivingString
    End Sub
End Class