﻿Imports System.Xml
Imports System.Xml.Schema
Imports System.Xml.Serialization
Imports System.Text
Imports System.Drawing.Printing
Imports System.Drawing

Public Class frmNcdAdmin

    Public adminInfo As New AdminInformation

    '  Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public FormLoading As Boolean = True

    'Dim FirmwarePath As String = "C:\Users\Lenovo\Documents\NCDAdmin\Firmware\"
    ' Dim FirmwarePath As String = "C:\Users\Ryan\Documents\NCDAdmin\Firmware\"

    Dim FirmwarePath As String = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\NCDAdmin\Firmware\"


    'Dim FirmwarePath As String = "C:\Users\"

    Dim ProgrammerPath As String = "C:\Program Files (x86)\melabs Programmer\meProg.exe"
    Dim AtmelICE() As String = {"1800090522", "1800089357", "1800089453"}
    Dim AtmelCPU As String

    ''' <summary>
    ''' Class for Admin information 
    ''' </summary>
    Public Class AdminInformation
        Public Class PortInfo
            Public PortName As String
            Public Selected As Boolean
        End Class

        Public FirmwarePath As String = GetConfigureInfoPath() + "\Firmware\"
        Public ProgrammerPath As String = "C:\Program Files (x86)\melabs Programmer\meProg.exe"
        Public ComPorts() As PortInfo
        Public AtmelICE() As String
        Public Sub Load()
            Dim filename As String = GetConfigureInfoPath() + "\NCDConfig.cfg"
            If IO.File.Exists(filename) Then
                Dim x As XmlSerializer = New XmlSerializer(GetType(AdminInformation))
                Dim sw As System.IO.StreamReader = New System.IO.StreamReader(filename)
                Dim d As AdminInformation = x.Deserialize(sw)
                FirmwarePath = d.FirmwarePath
                ProgrammerPath = d.ProgrammerPath
                ComPorts = d.ComPorts
                AtmelICE = d.AtmelICE
                sw.Close()
            End If

        End Sub

        Public Sub Save()
            Dim w As XmlWriter = XmlWriter.Create(GetConfigureInfoPath() + "\NCDConfig.cfg")
            Dim x As New XmlSerializer(GetType(AdminInformation))
            x.Serialize(w, Me)
            w.Close()
        End Sub

        ''' <summary>
        ''' Update serial ports scaned, will keep selected ports's status if they are exist
        ''' </summary>
        Public Sub UpdateSerialPorts(ports() As PortInfo)
            If ports Is Nothing Then
                Exit Sub
            End If
            If ComPorts Is Nothing Then
                ComPorts = ports
                Exit Sub
            End If
            For Each newPort As PortInfo In ports
                For Each oldPort As PortInfo In ComPorts
                    If (newPort.PortName = oldPort.PortName) Then
                        newPort.Selected = oldPort.Selected
                    End If
                Next
            Next
            ' update ports
            ComPorts = ports
        End Sub

        ''' <summary>
        ''' Get unselected ports, will return in a string list
        ''' </summary>
        ''' <returns></returns>
        Public Function GetUnselectedPorts(allPorts() As String) As String()
            If allPorts Is Nothing Then
                Exit Function
            End If
            If ComPorts Is Nothing Then
                Return allPorts
            End If
            Dim unselectedPorts As New ArrayList
            For Each p In allPorts
                For Each cp In ComPorts
                    If p = cp.PortName And Not cp.Selected Then
                        unselectedPorts.Add(p)
                    End If
                Next
            Next
            Return unselectedPorts.ToArray(GetType(String))
        End Function


        Public Function GetConfigureInfoPath() As String
            GetConfigureInfoPath = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\NCDAdmin"
            IO.Directory.CreateDirectory(GetConfigureInfoPath)
        End Function
    End Class



    Public Sub CPUError()
        MsgBox("CPU and Firmware Not Yet Defined")
    End Sub
    Private Sub ProgramME(config As String)

        Dim strExe As String = ProgrammerPath
        Dim p As New Process
        Dim pinfo As New ProcessStartInfo
        Dim Prog As String = " -A64"
        Dim Burn As Boolean = False

        Dim CPUIDFlag As Boolean = False
        For Temp As Integer = 1 To Len(config)
            If Temp > 10 And CPUIDFlag = False Then
                If Mid(config, Temp, 1) = "-" Then
                    If Mid(config, Temp + 1, 1) = "D" Then
                        CPU.Text = Mid(config, Temp + 2, Len(config))
                        CPUIDFlag = True
                    End If
                End If
            End If
        Next

        For Programmer As Integer = 1 To 56
            Burn = False
            If Programmer = 1 And Programmer1.Checked = True Then Burn = True : Prog = " -A64" 'Working
            If Programmer = 2 And Programmer2.Checked = True Then Burn = True : Prog = " -A65" 'Working
            If Programmer = 3 And Programmer3.Checked = True Then Burn = True : Prog = " -A66" 'Working
            If Programmer = 4 And Programmer4.Checked = True Then Burn = True : Prog = " -A67" 'Working
            If Programmer = 5 And Programmer5.Checked = True Then Burn = True : Prog = " -A68" 'Working
            If Programmer = 6 And Programmer6.Checked = True Then Burn = True : Prog = " -A69" 'Working
            If Programmer = 7 And Programmer7.Checked = True Then Burn = True : Prog = " -A70" 'Working
            If Programmer = 8 And Programmer8.Checked = True Then Burn = True : Prog = " -A71" 'Working
            If Programmer = 9 And Programmer9.Checked = True Then Burn = True : Prog = " -A72" 'Working
            If Programmer = 10 And Programmer10.Checked = True Then Burn = True : Prog = " -A73" 'Working
            If Programmer = 11 And Programmer11.Checked = True Then Burn = True : Prog = " -A74" 'Working
            If Programmer = 12 And Programmer12.Checked = True Then Burn = True : Prog = " -A75" 'Working
            If Programmer = 13 And Programmer13.Checked = True Then Burn = True : Prog = " -A76" 'Working
            If Programmer = 14 And Programmer14.Checked = True Then Burn = True : Prog = " -A77" 'Working
            If Programmer = 15 And Programmer15.Checked = True Then Burn = True : Prog = " -A78" 'Working
            If Programmer = 16 And Programmer16.Checked = True Then Burn = True : Prog = " -A79" 'Working

            If Programmer = 17 And Programmer17.Checked = True Then Burn = True : Prog = " -A80"
            If Programmer = 18 And Programmer18.Checked = True Then Burn = True : Prog = " -A81"
            If Programmer = 19 And Programmer19.Checked = True Then Burn = True : Prog = " -A82"
            If Programmer = 20 And Programmer20.Checked = True Then Burn = True : Prog = " -A83"
            If Programmer = 21 And Programmer21.Checked = True Then Burn = True : Prog = " -A84"
            If Programmer = 22 And Programmer22.Checked = True Then Burn = True : Prog = " -A85"
            If Programmer = 23 And Programmer23.Checked = True Then Burn = True : Prog = " -A86"
            If Programmer = 24 And Programmer24.Checked = True Then Burn = True : Prog = " -A87"
            If Programmer = 25 And Programmer25.Checked = True Then Burn = True : Prog = " -A88"
            If Programmer = 26 And Programmer26.Checked = True Then Burn = True : Prog = " -A89"
            If Programmer = 27 And Programmer27.Checked = True Then Burn = True : Prog = " -A90"
            If Programmer = 28 And Programmer28.Checked = True Then Burn = True : Prog = " -A91"
            If Programmer = 29 And Programmer29.Checked = True Then Burn = True : Prog = " -A92"
            If Programmer = 30 And Programmer30.Checked = True Then Burn = True : Prog = " -A93"
            If Programmer = 31 And Programmer31.Checked = True Then Burn = True : Prog = " -A94"
            If Programmer = 32 And Programmer32.Checked = True Then Burn = True : Prog = " -A95"
            If Programmer = 33 And Programmer33.Checked = True Then Burn = True : Prog = " -A96"
            If Programmer = 34 And Programmer34.Checked = True Then Burn = True : Prog = " -A97"
            If Programmer = 35 And Programmer35.Checked = True Then Burn = True : Prog = " -A98"
            If Programmer = 36 And Programmer36.Checked = True Then Burn = True : Prog = " -A99"
            If Programmer = 37 And Programmer37.Checked = True Then Burn = True : Prog = " -A100"
            If Programmer = 38 And Programmer38.Checked = True Then Burn = True : Prog = " -A101"
            If Programmer = 39 And Programmer39.Checked = True Then Burn = True : Prog = " -A102"
            If Programmer = 40 And Programmer40.Checked = True Then Burn = True : Prog = " -A103"
            If Programmer = 41 And Programmer41.Checked = True Then Burn = True : Prog = " -A104"
            If Programmer = 42 And Programmer42.Checked = True Then Burn = True : Prog = " -A105"
            If Programmer = 43 And Programmer43.Checked = True Then Burn = True : Prog = " -A106"
            If Programmer = 44 And Programmer44.Checked = True Then Burn = True : Prog = " -A107"
            If Programmer = 45 And Programmer45.Checked = True Then Burn = True : Prog = " -A108"
            If Programmer = 46 And Programmer46.Checked = True Then Burn = True : Prog = " -A109"
            If Programmer = 47 And Programmer47.Checked = True Then Burn = True : Prog = " -A110"
            If Programmer = 48 And Programmer48.Checked = True Then Burn = True : Prog = " -A111"
            If Programmer = 49 And Programmer49.Checked = True Then Burn = True : Prog = " -A112"
            If Programmer = 50 And Programmer50.Checked = True Then Burn = True : Prog = " -A113"
            If Programmer = 51 And Programmer51.Checked = True Then Burn = True : Prog = " -A114"
            If Programmer = 52 And Programmer52.Checked = True Then Burn = True : Prog = " -A115"
            If Programmer = 53 And Programmer53.Checked = True Then Burn = True : Prog = " -A116"
            If Programmer = 54 And Programmer54.Checked = True Then Burn = True : Prog = " -A117"
            If Programmer = 55 And Programmer55.Checked = True Then Burn = True : Prog = " -A118"
            If Programmer = 56 And Programmer56.Checked = True Then Burn = True : Prog = " -A119"

            Dim AutoCloseOption As String = ""
            If AutoClose.Checked = True Then
                AutoCloseOption = " -X"
            End If

            Dim AutoProgramOption As String = ""
            If AutoProgram.Checked = True Then
                AutoProgramOption = " -P"
            End If

            If AutoProgram.Checked = True Then
                If Burn = True Then
                    pinfo.UseShellExecute = False
                    pinfo.RedirectStandardOutput = True
                    pinfo.Arguments = config + Prog + AutoProgramOption + AutoCloseOption
                    pinfo.FileName = strExe
                    pinfo.WindowStyle = ProcessWindowStyle.Normal
                    pinfo.CreateNoWindow = True
                    p.StartInfo = pinfo
                    p.Start()
                End If
            End If


        Next Programmer

    End Sub

    Private Sub ProgramATMEL(File As String, Processor As String)

        Dim strExe As String = ProgrammerPath
        Dim p As New Process
        Dim pinfo As New ProcessStartInfo
        Dim Prog As String = AtmelICE(0)
        Dim Burn As Boolean = False


        Dim CPUIDFlag As Boolean = False


        'For Temp As Integer = 1 To Len(File)
        '    If Temp > 10 And CPUIDFlag = False Then
        '        If Mid(File, Temp, 1) = "-" Then
        '            If Mid(File, Temp + 1, 1) = "D" Then
        '                CPU.Text = Mid(File, Temp + 2, Len(File))
        '                CPUIDFlag = True
        '            End If
        '        End If
        '    End If
        'Next

        For Programmer As Integer = 1 To AtmelICE.Length
            Burn = False
            If Programmer = 1 And Programmer1.Checked = True Then Burn = True : Prog = AtmelICE(0)
            If Programmer = 2 And Programmer2.Checked = True Then Burn = True : Prog = AtmelICE(1)
            If Programmer = 3 And Programmer3.Checked = True Then Burn = True : Prog = AtmelICE(2)
            If Programmer = 4 And Programmer4.Checked = True Then Burn = True : Prog = AtmelICE(3)
            If Programmer = 5 And Programmer5.Checked = True Then Burn = True : Prog = AtmelICE(4)
            If Programmer = 6 And Programmer6.Checked = True Then Burn = True : Prog = AtmelICE(5)
            If Programmer = 7 And Programmer7.Checked = True Then Burn = True : Prog = AtmelICE(6)
            If Programmer = 8 And Programmer8.Checked = True Then Burn = True : Prog = AtmelICE(7)
            If Programmer = 9 And Programmer9.Checked = True Then Burn = True : Prog = AtmelICE(8)
            If Programmer = 10 And Programmer10.Checked = True Then Burn = True : Prog = AtmelICE(9)
            If Programmer = 11 And Programmer11.Checked = True Then Burn = True : Prog = AtmelICE(10)
            If Programmer = 12 And Programmer12.Checked = True Then Burn = True : Prog = AtmelICE(11)
            If Programmer = 13 And Programmer13.Checked = True Then Burn = True : Prog = AtmelICE(12)
            If Programmer = 14 And Programmer14.Checked = True Then Burn = True : Prog = AtmelICE(13)
            If Programmer = 15 And Programmer15.Checked = True Then Burn = True : Prog = AtmelICE(14)
            If Programmer = 16 And Programmer16.Checked = True Then Burn = True : Prog = AtmelICE(15)

            If Programmer = 17 And Programmer17.Checked = True Then Burn = True : Prog = AtmelICE(16)
            If Programmer = 18 And Programmer18.Checked = True Then Burn = True : Prog = AtmelICE(17)
            If Programmer = 19 And Programmer19.Checked = True Then Burn = True : Prog = AtmelICE(18)
            If Programmer = 20 And Programmer20.Checked = True Then Burn = True : Prog = AtmelICE(19)
            If Programmer = 21 And Programmer21.Checked = True Then Burn = True : Prog = AtmelICE(20)
            If Programmer = 22 And Programmer22.Checked = True Then Burn = True : Prog = AtmelICE(21)
            If Programmer = 23 And Programmer23.Checked = True Then Burn = True : Prog = AtmelICE(22)
            If Programmer = 24 And Programmer24.Checked = True Then Burn = True : Prog = AtmelICE(23)
            If Programmer = 25 And Programmer25.Checked = True Then Burn = True : Prog = AtmelICE(24)
            If Programmer = 26 And Programmer26.Checked = True Then Burn = True : Prog = AtmelICE(25)
            If Programmer = 27 And Programmer27.Checked = True Then Burn = True : Prog = AtmelICE(26)
            If Programmer = 28 And Programmer28.Checked = True Then Burn = True : Prog = AtmelICE(27)
            If Programmer = 29 And Programmer29.Checked = True Then Burn = True : Prog = AtmelICE(28)
            If Programmer = 30 And Programmer30.Checked = True Then Burn = True : Prog = AtmelICE(29)
            If Programmer = 31 And Programmer31.Checked = True Then Burn = True : Prog = AtmelICE(30)
            If Programmer = 32 And Programmer32.Checked = True Then Burn = True : Prog = AtmelICE(31)

            If Programmer = 33 And Programmer33.Checked = True Then Burn = True : Prog = AtmelICE(32)
            If Programmer = 34 And Programmer34.Checked = True Then Burn = True : Prog = AtmelICE(33)
            If Programmer = 35 And Programmer35.Checked = True Then Burn = True : Prog = AtmelICE(34)
            If Programmer = 36 And Programmer36.Checked = True Then Burn = True : Prog = AtmelICE(35)
            If Programmer = 37 And Programmer37.Checked = True Then Burn = True : Prog = AtmelICE(36)
            If Programmer = 38 And Programmer38.Checked = True Then Burn = True : Prog = AtmelICE(37)
            If Programmer = 39 And Programmer39.Checked = True Then Burn = True : Prog = AtmelICE(38)
            If Programmer = 40 And Programmer40.Checked = True Then Burn = True : Prog = AtmelICE(39)
            If Programmer = 41 And Programmer41.Checked = True Then Burn = True : Prog = AtmelICE(40)
            If Programmer = 42 And Programmer42.Checked = True Then Burn = True : Prog = AtmelICE(41)
            If Programmer = 43 And Programmer43.Checked = True Then Burn = True : Prog = AtmelICE(42)
            If Programmer = 44 And Programmer44.Checked = True Then Burn = True : Prog = AtmelICE(43)
            If Programmer = 45 And Programmer45.Checked = True Then Burn = True : Prog = AtmelICE(44)
            If Programmer = 46 And Programmer46.Checked = True Then Burn = True : Prog = AtmelICE(45)
            If Programmer = 47 And Programmer47.Checked = True Then Burn = True : Prog = AtmelICE(46)
            If Programmer = 48 And Programmer48.Checked = True Then Burn = True : Prog = AtmelICE(47)

            If Programmer = 49 And Programmer49.Checked = True Then Burn = True : Prog = AtmelICE(48)
            If Programmer = 50 And Programmer50.Checked = True Then Burn = True : Prog = AtmelICE(49)
            If Programmer = 51 And Programmer51.Checked = True Then Burn = True : Prog = AtmelICE(50)
            If Programmer = 52 And Programmer52.Checked = True Then Burn = True : Prog = AtmelICE(51)
            If Programmer = 53 And Programmer53.Checked = True Then Burn = True : Prog = AtmelICE(52)
            If Programmer = 54 And Programmer54.Checked = True Then Burn = True : Prog = AtmelICE(53)
            If Programmer = 55 And Programmer55.Checked = True Then Burn = True : Prog = AtmelICE(54)
            If Programmer = 56 And Programmer56.Checked = True Then Burn = True : Prog = AtmelICE(55)

            'C:\Program Files (x86)\Atmel\Studio\7.0\atbackend>atprogram -t -s 1800090522 atmelice -i ISP -d atmega328P program -fl -f C:\Users\Lenovo\Documents\NCDAdmin\Firmware\ncd_porduction_28th_May_2019\PR52-33N\40_KX222_Vibration.elf --verify -fs --verify -lb --verify

            Dim AtmelCPU As String = Processor ' "atmega328P"
            Dim AtmelPath As String = FirmwarePath + "Enterprise\"
            Dim AtmelFile As String = File + ".elf" '"40_KX222_Vibration.elf"
            Dim AtemlProgrammer As String = Prog
            Dim AtmelCMD As String = "C:\Program Files (x86)\Atmel\Studio\7.0\atbackend\atprogram.exe"
            Dim AtmelARG As String = " -t  atmelice -s " + "J4" + AtemlProgrammer + " -i ISP -d " + AtmelCPU + " chiperase  program -fl -f " + AtmelPath + AtmelFile + " --verify -fs --verify -lb --verify"

            If Burn = True Then
                Debug.Print("Flashing:" + AtmelCMD)
                pinfo.UseShellExecute = False
                pinfo.RedirectStandardOutput = True
                pinfo.Arguments = AtmelARG ' "" 'File + Prog
                pinfo.FileName = AtmelCMD 'strExe
                'pinfo.WorkingDirectory = "G:\Utils"
                pinfo.WindowStyle = ProcessWindowStyle.Normal
                'pinfo.WorkingDirectory = 

                pinfo.CreateNoWindow = True
                p.StartInfo = pinfo
                p.Start()
            End If

        Next Programmer

    End Sub

    Private Sub FirstProgrammer_ValueChanged(sender As Object, e As EventArgs) Handles FirstProgrammer.ValueChanged
        RefreshUI()
    End Sub
    Private Sub LastProgrammer_ValueChanged(sender As Object, e As EventArgs) Handles LastProgrammer.ValueChanged
        RefreshUI()
    End Sub
    Public Sub RefreshUI()
        If FirstProgrammer.Value > LastProgrammer.Value Then
            LastProgrammer.Value = FirstProgrammer.Value
        Else
            If LastProgrammer.Value < FirstProgrammer.Value Then
                FirstProgrammer.Value = LastProgrammer.Value
            End If
        End If

        Programmer1.Checked = False
        Programmer2.Checked = False
        Programmer3.Checked = False
        Programmer4.Checked = False
        Programmer5.Checked = False
        Programmer6.Checked = False
        Programmer7.Checked = False
        Programmer8.Checked = False
        Programmer9.Checked = False
        Programmer10.Checked = False
        Programmer11.Checked = False
        Programmer12.Checked = False
        Programmer13.Checked = False
        Programmer14.Checked = False
        Programmer15.Checked = False
        Programmer16.Checked = False
        Programmer17.Checked = False
        Programmer18.Checked = False
        Programmer19.Checked = False
        Programmer20.Checked = False
        Programmer21.Checked = False
        Programmer22.Checked = False
        Programmer23.Checked = False
        Programmer24.Checked = False
        Programmer25.Checked = False
        Programmer26.Checked = False
        Programmer27.Checked = False
        Programmer28.Checked = False
        Programmer29.Checked = False
        Programmer30.Checked = False
        Programmer31.Checked = False
        Programmer32.Checked = False
        Programmer33.Checked = False
        Programmer34.Checked = False
        Programmer35.Checked = False
        Programmer36.Checked = False
        Programmer37.Checked = False
        Programmer38.Checked = False
        Programmer39.Checked = False
        Programmer40.Checked = False
        Programmer41.Checked = False
        Programmer42.Checked = False
        Programmer43.Checked = False
        Programmer44.Checked = False
        Programmer45.Checked = False
        Programmer46.Checked = False
        Programmer47.Checked = False
        Programmer48.Checked = False
        Programmer49.Checked = False
        Programmer50.Checked = False
        Programmer51.Checked = False
        Programmer52.Checked = False
        Programmer53.Checked = False
        Programmer54.Checked = False
        Programmer55.Checked = False
        Programmer56.Checked = False

        For Temp As Integer = FirstProgrammer.Value To LastProgrammer.Value
            If Temp = 1 Then Programmer1.Checked = True
            If Temp = 2 Then Programmer2.Checked = True
            If Temp = 3 Then Programmer3.Checked = True
            If Temp = 4 Then Programmer4.Checked = True
            If Temp = 5 Then Programmer5.Checked = True
            If Temp = 6 Then Programmer6.Checked = True
            If Temp = 7 Then Programmer7.Checked = True
            If Temp = 8 Then Programmer8.Checked = True
            If Temp = 9 Then Programmer9.Checked = True
            If Temp = 10 Then Programmer10.Checked = True
            If Temp = 11 Then Programmer11.Checked = True
            If Temp = 12 Then Programmer12.Checked = True
            If Temp = 13 Then Programmer13.Checked = True
            If Temp = 14 Then Programmer14.Checked = True
            If Temp = 15 Then Programmer15.Checked = True
            If Temp = 16 Then Programmer16.Checked = True
            If Temp = 17 Then Programmer17.Checked = True
            If Temp = 18 Then Programmer18.Checked = True
            If Temp = 19 Then Programmer19.Checked = True
            If Temp = 20 Then Programmer20.Checked = True
            If Temp = 21 Then Programmer21.Checked = True
            If Temp = 22 Then Programmer22.Checked = True
            If Temp = 23 Then Programmer23.Checked = True
            If Temp = 24 Then Programmer24.Checked = True
            If Temp = 25 Then Programmer25.Checked = True
            If Temp = 26 Then Programmer26.Checked = True
            If Temp = 27 Then Programmer27.Checked = True
            If Temp = 28 Then Programmer28.Checked = True
            If Temp = 29 Then Programmer29.Checked = True
            If Temp = 30 Then Programmer30.Checked = True
            If Temp = 31 Then Programmer31.Checked = True
            If Temp = 32 Then Programmer32.Checked = True
            If Temp = 33 Then Programmer33.Checked = True
            If Temp = 34 Then Programmer34.Checked = True
            If Temp = 35 Then Programmer35.Checked = True
            If Temp = 36 Then Programmer36.Checked = True
            If Temp = 37 Then Programmer37.Checked = True
            If Temp = 38 Then Programmer38.Checked = True
            If Temp = 39 Then Programmer39.Checked = True
            If Temp = 40 Then Programmer40.Checked = True
            If Temp = 41 Then Programmer41.Checked = True
            If Temp = 42 Then Programmer42.Checked = True
            If Temp = 43 Then Programmer43.Checked = True
            If Temp = 44 Then Programmer44.Checked = True
            If Temp = 45 Then Programmer45.Checked = True
            If Temp = 46 Then Programmer46.Checked = True
            If Temp = 47 Then Programmer47.Checked = True
            If Temp = 48 Then Programmer48.Checked = True
            If Temp = 49 Then Programmer49.Checked = True
            If Temp = 50 Then Programmer50.Checked = True
            If Temp = 51 Then Programmer51.Checked = True
            If Temp = 52 Then Programmer52.Checked = True
            If Temp = 53 Then Programmer53.Checked = True
            If Temp = 54 Then Programmer54.Checked = True
            If Temp = 55 Then Programmer55.Checked = True
            If Temp = 56 Then Programmer56.Checked = True
        Next
    End Sub
    Private Sub R1x_Click(sender As Object, e As EventArgs) Handles R1x.Click
        ProgramME(FirmwarePath + "R2X_12F683.hex -DPIC12F683")
        SelectTest(0) '"1 Or 2-Channel Low Cost Serial")
        '0 = 1 Or 2-Channel Low Cost Serial
        '1 = 1 Or 2-Channel Low Cost ZigBee
        '2 = 4 Or 8-Channel Pro Series
        '3 = Fusion Series
        '4 = ProXR Series
        '5 = Reactor Series
        '6 = Scan Series
        '7 = Taralist Series
        '8 = AD8 Test
        '9 = AD1216 Test

    End Sub

    Public Sub SelectTest(Test As String)
        ' TestApplication.SelectedText = Test
        TestApplication.SelectedIndex = Test
    End Sub

    Private Sub R2x_Click(sender As Object, e As EventArgs) Handles R2x.Click
        ProgramME(FirmwarePath + "R2X_12F683.hex -DPIC12F683")
        SelectTest(0)
    End Sub
    Private Sub ZR1x_Click(sender As Object, e As EventArgs) Handles ZR1x.Click
        ProgramME(FirmwarePath + "ZR1x_ZR2x_2014.HEX -DPIC12F683")
        SelectTest(1)
    End Sub
    Private Sub ZR2x_Click(sender As Object, e As EventArgs) Handles ZR2x.Click
        ProgramME(FirmwarePath + "ZR1x_ZR2x_2014.HEX -DPIC12F683")
        SelectTest(1)
    End Sub
    Private Sub R4xPRO_Click(sender As Object, e As EventArgs) Handles R4xPRO.Click
        ProgramME(FirmwarePath + "R4x_PRO.HEX -DPIC16F628A")
        SelectTest(2)
    End Sub
    Private Sub R8xPRO_Click(sender As Object, e As EventArgs) Handles R8xPRO.Click
        ProgramME(FirmwarePath + "R8x_PRO.HEX -DPIC16F628A")
        SelectTest(2)
    End Sub
    '  Private Sub R1xPL_Click(sender As Object, e As EventArgs) Handles R1xPL.Click
    '      ProgramME(FirmwarePath + "ProXR_Lite124_ENH.HEX -DPIC18F14K22")
    '  End Sub
    '  Private Sub R2xPL_Click(sender As Object, e As EventArgs) Handles R2xPL.Click
    '      ProgramME(FirmwarePath + "ProXR_Lite124_ENH.HEX -DPIC18F14K22")
    ' End Sub
    'Private Sub R4xPL_Click(sender As Object, e As EventArgs) Handles R4xPL.Click
    '    ProgramME(FirmwarePath + "ProXR_Lite124_ENH.HEX -DPIC18F14K22")
    'End Sub
    'Private Sub R8xPL_Click(sender As Object, e As EventArgs) Handles R8xPL.Click
    '    ProgramME(FirmwarePath + "ProXR_Lite8_ENH.HEX -DPIC18F14K22")
    'End Sub
    Private Sub ProXRAD8_Click(sender As Object, e As EventArgs)
        ProgramME(FirmwarePath + "ProXR_ENH_AD8.HEX -DPIC18F14K22")
    End Sub
    Private Sub ProXRUXP_Click(sender As Object, e As EventArgs)
        ProgramME(FirmwarePath + "ProXR_ENH_UXP_V3_5.HEX -DPIC18F14K22")
    End Sub
    Private Sub ProXRAD1216_Click(sender As Object, e As EventArgs)
        ProgramME(FirmwarePath + "ProXR_ENH_AD1216.HEX -DPIC18F14K22")
    End Sub
    Private Sub LRR1x_Click(sender As Object, e As EventArgs) Handles LRR1x.Click
        ProgramME(FirmwarePath + "ReactorLIVE_V49.HEX -DPIC16F690")
        SelectTest(5)
    End Sub
    Private Sub LRR2x_Click(sender As Object, e As EventArgs) Handles LRR2x.Click
        ProgramME(FirmwarePath + "ReactorLIVE_V49.HEX -DPIC16F690")
        SelectTest(5)
    End Sub
    Private Sub LRR4x_Click(sender As Object, e As EventArgs) Handles LRR4x.Click
        ProgramME(FirmwarePath + "ReactorLIVE_V49.HEX -DPIC16F690")
        SelectTest(5)
    End Sub
    Private Sub LRR4x0_Click(sender As Object, e As EventArgs) Handles LRR4x0.Click
        ProgramME(FirmwarePath + "Reactor_V49_R4x0.HEX -DPIC16F690")
        SelectTest(5)
    End Sub
    Private Sub LRR8x_Click(sender As Object, e As EventArgs) Handles LRR8x.Click
        ProgramME(FirmwarePath + "ReactorLIVE_V49.HEX -DPIC16F690")
        SelectTest(5)
    End Sub
    Private Sub Taralist_ENH_Click(sender As Object, e As EventArgs) Handles Taralist_ENH.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_TAR_C.HEX -DPIC18F14K22")
        SelectTest(7)
    End Sub

    Private Sub BeanaVision_Click(sender As Object, e As EventArgs) Handles BeanaVision.Click
        ProgramME(FirmwarePath + "WIOADR16x.HEX -DPIC16F877")
    End Sub
    Private Sub Fusion_Click(sender As Object, e As EventArgs) Handles Fusion.Click
        ProgramME(FirmwarePath + "Fusion\FUSION_FULL.HEX -DPIC18F46K22")
        SelectTest(3)
    End Sub
    Private Sub FusionS3B_Click(sender As Object, e As EventArgs) Handles FusionS3B.Click
        ProgramME(FirmwarePath + "Fusion\BRIDGEX2.HEX -DPIC18F46K22")
        SelectTest(3)
    End Sub
    Private Sub FusionMirW_Click(sender As Object, e As EventArgs) Handles FusionMirW.Click
        ProgramME(FirmwarePath + "Fusion\MirW_Receiver_S3B.HEX -DPIC18F46K22")
    End Sub

    Private Sub EnterpriseSensors_Click(sender As Object, e As EventArgs) Handles Enterprise.Click
        'http://ww1.microchip.com/downloads/en/AppNotes/00002466A.pdf
        'atprogram -t jtagice3 -i jtag -d at32uc3b0512 program -f e: \file.elf
        'atprogram -t avrone -i pdi -d atxmega128a1 chiperase

        Debug.Print("Enterprise Tab")
        Dim fileNames = My.Computer.FileSystem.GetFiles(FirmwarePath + "Enterprise\", FileIO.SearchOption.SearchTopLevelOnly, "*.elf")

        For Each fileName As String In fileNames
            Debug.Print("FILE: " + fileName)
            Dim result As String = fileName ' Path.GetFileName(fileName)
            FirmwareList.Items.Add(result)
        Next

    End Sub
    Private Sub Fusion_S3B_MirW_Receiver_Click(sender As Object, e As EventArgs) Handles Fusion_S3B_MirW_Receiver.Click
        ProgramME(FirmwarePath + "Fusion\MirW_Receiver_S3B.HEX -DPIC18F46K22")
    End Sub
    Private Sub MirCC1x_S3B_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC2x_S3B_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC4x_S3B_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC8x_S3B_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC1x_Serial_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC2x_Serial_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC4x_Serial_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC8x_Serial_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC1x_USB_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC2x_USB_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC4x_USB_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC8x_USB_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC1x_WiFi_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC2x_WiFi_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC4x_WiFi_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC8x_WiFi_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC1x_Ethernet_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC2x_Ethernet_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC4x_Ethernet_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub MirCC8x_Ethernet_Push_Click(sender As Object, e As EventArgs)

    End Sub
    Private Sub KFX_Click(sender As Object, e As EventArgs) Handles KFX.Click
        ProgramME(FirmwarePath + "KFX_V2.HEX -DPIC18F14K22")
    End Sub
    Private Sub ProXRStandardAD8USB_Click(sender As Object, e As EventArgs) Handles ProXRStandardAD8USB.Click
        ProgramME(FirmwarePath + "ProXR_Standard\ProXR-AD8-USB_V2.HEX -DPIC16F690")
        SelectTest(4)
    End Sub
    Private Sub ProXRStandardAD8ZigBee_Click(sender As Object, e As EventArgs) Handles ProXRStandardAD8ZigBee.Click
        ProgramME(FirmwarePath + "ProXR_Standard\ProXR-AD8-Zigbee_V2.HEX -DPIC16F690")
    End Sub
    Private Sub R1xPL_USB_Click(sender As Object, e As EventArgs) Handles R1xPL_USB.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_USB.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 1
    End Sub
    Private Sub R2xPL_USB_Click(sender As Object, e As EventArgs) Handles R2xPL_USB.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_USB.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 2

    End Sub
    Private Sub R4xPL_USB_Click(sender As Object, e As EventArgs) Handles R4xPL_USB.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_USB.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 3

    End Sub
    Private Sub R8xPL_USB_Click(sender As Object, e As EventArgs) Handles R8xPL_USB.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite8_ENH_USB.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub R1xPL_Bluetooth_Click(sender As Object, e As EventArgs) Handles R1xPL_Bluetooth.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_Bluetooth.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 1
    End Sub
    Private Sub R2xPL_Bluetooth_Click(sender As Object, e As EventArgs) Handles R2xPL_Bluetooth.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_Bluetooth.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 2
    End Sub
    Private Sub R4xPL_Bluetooth_Click(sender As Object, e As EventArgs) Handles R4xPL_Bluetooth.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_Bluetooth.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 3
    End Sub
    Private Sub R8xPL_Bluetooth_Click(sender As Object, e As EventArgs) Handles R8xPL_Bluetooth.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite8_ENH_Bluetooth.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4
    End Sub
    Private Sub R1xPL_802154_Click(sender As Object, e As EventArgs) Handles R1xPL_802154.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_802154.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 1
    End Sub
    Private Sub R2xPL_802154_Click(sender As Object, e As EventArgs) Handles R2xPL_802154.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_802154.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 2
    End Sub
    Private Sub R4xPL_802154_Click(sender As Object, e As EventArgs) Handles R4xPL_802154.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_802154.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 3
    End Sub
    Private Sub R8xPL_802154_Click(sender As Object, e As EventArgs) Handles R8xPL_802154.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite8_ENH_802154.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4
    End Sub
    Private Sub R1xPL_Ethernet_Click(sender As Object, e As EventArgs) Handles R1xPL_Ethernet.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_Ethernet.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 1
    End Sub
    Private Sub R2xPL_Ethernet_Click(sender As Object, e As EventArgs) Handles R2xPL_Ethernet.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_Ethernet.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 2
    End Sub
    Private Sub R4xPL_Ethernet_Click(sender As Object, e As EventArgs) Handles R4xPL_Ethernet.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_Ethernet.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 3
    End Sub
    Private Sub R8xPL_Ethernet_Click(sender As Object, e As EventArgs) Handles R8xPL_Ethernet.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite8_ENH_Ethernet.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4
    End Sub
    Private Sub R1xPL_RS232_Click(sender As Object, e As EventArgs) Handles R1xPL_RS232.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_RS232.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 1
    End Sub
    Private Sub R2xPL_RS232_Click(sender As Object, e As EventArgs) Handles R2xPL_RS232.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_RS232.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 2
    End Sub
    Private Sub R4xPL_RS232_Click(sender As Object, e As EventArgs) Handles R4xPL_RS232.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_RS232.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 3
    End Sub
    Private Sub R8xPL_RS232_Click(sender As Object, e As EventArgs) Handles R8xPL_RS232.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite8_ENH_RS232.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4
    End Sub
    Private Sub R1xPL_RS485_Click(sender As Object, e As EventArgs) Handles R1xPL_RS485.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_RS485.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 1
    End Sub
    Private Sub R2xPL_RS485_Click(sender As Object, e As EventArgs) Handles R2xPL_RS485.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_RS485.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 2
    End Sub
    Private Sub R4xPL_RS485_Click(sender As Object, e As EventArgs) Handles R4xPL_RS485.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_RS485.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 3
    End Sub
    Private Sub R8xPL_RS485_Click(sender As Object, e As EventArgs) Handles R8xPL_RS485.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite8_ENH_RS485.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4
    End Sub
    Private Sub R1xPL_WebI_Click(sender As Object, e As EventArgs) Handles R1xPL_WebI.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_WebI.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 1
    End Sub
    Private Sub R2xPL_WebI_Click(sender As Object, e As EventArgs) Handles R2xPL_WebI.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_WebI.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 2
    End Sub
    Private Sub R4xPL_WebI_Click(sender As Object, e As EventArgs) Handles R4xPL_WebI.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_WebI.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 3
    End Sub
    Private Sub R8xPL_WebI_Click(sender As Object, e As EventArgs) Handles R8xPL_WebI.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite8_ENH_WebI.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4
    End Sub
    Private Sub R1xPL_WiFi_Click(sender As Object, e As EventArgs) Handles R1xPL_WiFi.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_WiFi.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 1
    End Sub
    Private Sub R2xPL_WiFi_Click(sender As Object, e As EventArgs) Handles R2xPL_WiFi.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_WiFi.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 2
    End Sub
    Private Sub R4xPL_WiFi_Click(sender As Object, e As EventArgs) Handles R4xPL_WiFi.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_WiFi.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 3
    End Sub
    Private Sub R8xPL_WiFi_Click(sender As Object, e As EventArgs) Handles R8xPL_WiFi.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite8_ENH_WiFi.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4
    End Sub
    Private Sub R1xPL_ZigBee_Click(sender As Object, e As EventArgs) Handles R1xPL_ZigBee.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_ZigBee.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 1
    End Sub
    Private Sub R2xPL_ZigBee_Click(sender As Object, e As EventArgs) Handles R2xPL_ZigBee.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_ZigBee.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 2
    End Sub
    Private Sub R4xPL_ZigBee_Click(sender As Object, e As EventArgs) Handles R4xPL_ZigBee.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite124_ENH_ZigBee.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 3
    End Sub
    Private Sub R8xPL_ZigBee_Click(sender As Object, e As EventArgs) Handles R8xPL_ZigBee.Click
        ProgramME(FirmwarePath + "ProXR_Lite\ProXR_Lite8_ENH_ZigBee.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4
    End Sub
    Private Sub ProXRAD8_USB_Click(sender As Object, e As EventArgs) Handles ProXRAD8_USB.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_AD8_312_USB.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4
    End Sub
    Private Sub ProXR_AD8_Bluetooth_Click(sender As Object, e As EventArgs) Handles ProXR_AD8_Bluetooth.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_AD8_312_Bluetooth.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4
    End Sub
    Private Sub ProXR_AD8_802154_Click(sender As Object, e As EventArgs) Handles ProXR_AD8_802154.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_AD8_312_802154.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXR_AD8_Ethernet_Click(sender As Object, e As EventArgs) Handles ProXR_AD8_Ethernet.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_AD8_312_Ethernet.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRAD8_RS232_Click(sender As Object, e As EventArgs) Handles ProXRAD8_RS232.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_AD8_312_RS232.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRAD8_RS485_Click(sender As Object, e As EventArgs) Handles ProXRAD8_RS485.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_AD8_312_RS485.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRAD8_WebI_Click(sender As Object, e As EventArgs) Handles ProXRAD8_WebI.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_AD8_312_WebI.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRAD8_WiFi_Click(sender As Object, e As EventArgs) Handles ProXRAD8_WiFi.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_AD8_312_WiFi.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRAD8_ZigBee_Click(sender As Object, e As EventArgs) Handles ProXRAD8_ZigBee.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_AD8_312_ZigBee.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRUXP_USB_Click(sender As Object, e As EventArgs) Handles ProXRUXP_USB.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_UXP_V3_5_USB.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRUXP_Bluetooth_Click(sender As Object, e As EventArgs) Handles ProXRUXP_Bluetooth.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_UXP_V3_5_Bluetooth.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRUXP_802154_Click(sender As Object, e As EventArgs) Handles ProXRUXP_802154.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_UXP_V3_5_802154.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRUXP_Ethernet_Click(sender As Object, e As EventArgs) Handles ProXRUXP_Ethernet.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_UXP_V3_5_Ethernet.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRUXP_RS232_Click(sender As Object, e As EventArgs) Handles ProXRUXP_RS232.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_UXP_V3_5_RS232.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRUXP_RS485_Click(sender As Object, e As EventArgs) Handles ProXRUXP_RS485.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_UXP_V3_5_RS485.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRUXP_WebI_Click(sender As Object, e As EventArgs) Handles ProXRUXP_WebI.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_UXP_V3_5_WebI.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRUXP_WiFi_Click(sender As Object, e As EventArgs) Handles ProXRUXP_WiFi.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_UXP_V3_5_WiFi.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRUXP_ZigBee_Click(sender As Object, e As EventArgs) Handles ProXRUXP_ZigBee.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_UXP_V3_5_ZigBee.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub ProXRAD1216_Click_1(sender As Object, e As EventArgs) Handles ProXRAD1216.Click
        ProgramME(FirmwarePath + "ProXR_Enhanced\ProXR_ENH_AD1216.HEX -DPIC18F14K22")
        SelectTest(4)
        Channels.SelectedIndex = 4

    End Sub
    Private Sub MIRCC1x_S3B_Sender_Click(sender As Object, e As EventArgs) Handles MIRCC1x_S3B_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-S124-SENDER.HEX -DPIC16F690")
    End Sub
    Private Sub MIRCC2x_S3B_Sender_Click(sender As Object, e As EventArgs) Handles MIRCC2x_S3B_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-S124-SENDER.HEX -DPIC16F690")
    End Sub
    Private Sub MIRCC4x_S3B_Sender_Click(sender As Object, e As EventArgs) Handles MIRCC4x_S3B_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-S124-SENDER.HEX -DPIC16F690")
    End Sub
    Private Sub MIRCC8x_S3B_Sender_Click(sender As Object, e As EventArgs) Handles MIRCC8x_S3B_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-S8-SENDER.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR1x_S3B_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR1x_S3B_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-R124.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR2x_S3B_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR2x_S3B_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-R124.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR4x_S3B_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR4x_S3B_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-R124.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR8x_S3B_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR8x_S3B_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-R8.HEX -DPIC16F690")
    End Sub
    Private Sub MirCC1x_Etherent_Sender_Click(sender As Object, e As EventArgs) Handles MirCC1x_Etherent_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-124-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirCC2x_Etherent_Sender_Click(sender As Object, e As EventArgs) Handles MirCC2x_Etherent_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-124-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirCC4x_Etherent_Sender_Click(sender As Object, e As EventArgs) Handles MirCC4x_Etherent_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-124-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirCC8x_Etherent_Sender_Click(sender As Object, e As EventArgs) Handles MirCC8x_Etherent_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-8-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR1x_Ethernet_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR1x_Ethernet_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-124-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR2x_Ethernet_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR2x_Ethernet_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-124-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR4x_Ethernet_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR4x_Ethernet_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-124-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR8x_Ethernet_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR8x_Ethernet_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-8-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirCC1x_Wired_Sender_Click(sender As Object, e As EventArgs) Handles MirCC1x_Wired_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-S124-SENDER-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirCC2x_Wired_Sender_Click(sender As Object, e As EventArgs) Handles MirCC2x_Wired_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-S124-SENDER-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirCC4x_Wired_Sender_Click(sender As Object, e As EventArgs) Handles MirCC4x_Wired_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-S124-SENDER-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirCC8x_Wired_Sender_Click(sender As Object, e As EventArgs) Handles MirCC8x_Wired_Sender.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-S8-SENDER-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR1x_Wired_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR1x_Wired_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-R124-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR2x_Wired_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR2x_Wired_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-R124-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR4x_Wired_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR4x_Wired_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-R124-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirCR8x_Wired_Receiver_Click(sender As Object, e As EventArgs) Handles MirCR8x_Wired_Receiver.Click
        ProgramME(FirmwarePath + "Mirror\MIRC-R8-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR1x_S3B_Click(sender As Object, e As EventArgs) Handles MirXR1x_S3B.Click
        ProgramME(FirmwarePath + "Mirror\MIRX-R124.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR2x_S3B_Click(sender As Object, e As EventArgs) Handles MirXR2x_S3B.Click
        ProgramME(FirmwarePath + "Mirror\MIRX-R124.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR4x_S3B_Click(sender As Object, e As EventArgs) Handles MirXR4x_S3B.Click
        ProgramME(FirmwarePath + "Mirror\MIRX-R124.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR8x_S3B_Click(sender As Object, e As EventArgs) Handles MirXR8x_S3B.Click
        ProgramME(FirmwarePath + "Mirror\MIRX-R8.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR1x_Ethernet_Click(sender As Object, e As EventArgs) Handles MirXR1x_Ethernet.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-124-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR2x_Ethernet_Click(sender As Object, e As EventArgs) Handles MirXR2x_Ethernet.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-124-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR4x_Ethernet_Click(sender As Object, e As EventArgs) Handles MirXR4x_Ethernet.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-124-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR8x_Ethernet_Click(sender As Object, e As EventArgs) Handles MirXR8x_Ethernet.Click
        ProgramME(FirmwarePath + "Mirror\MXNET-8-Channel.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR1x_Wired_Click(sender As Object, e As EventArgs) Handles MirXR1x_Wired.Click
        ProgramME(FirmwarePath + "Mirror\MIRX-R124-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR2x_Wired_Click(sender As Object, e As EventArgs) Handles MirXR2x_Wired.Click
        ProgramME(FirmwarePath + "Mirror\MIRX-R124-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR4x_Wired_Click(sender As Object, e As EventArgs) Handles MirXR4x_Wired.Click
        ProgramME(FirmwarePath + "Mirror\MIRX-R124-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirXR8x_Wired_Click(sender As Object, e As EventArgs) Handles MirXR8x_Wired.Click
        ProgramME(FirmwarePath + "Mirror\MIRX-R8-9600.HEX -DPIC16F690")
    End Sub
    Private Sub MirCCR1x_802154_Click(sender As Object, e As EventArgs) Handles MirCCR1x_802154.Click
        ProgramME(FirmwarePath + "ProXR-AD8-Lite124.hex -DPIC16F690")
    End Sub
    Private Sub MirCCR2x_802154_Click(sender As Object, e As EventArgs) Handles MirCCR2x_802154.Click
        ProgramME(FirmwarePath + "ProXR-AD8-Lite124.hex -DPIC16F690")
    End Sub
    Private Sub MirCCR4x_802154_Click(sender As Object, e As EventArgs) Handles MirCCR4x_802154.Click
        ProgramME(FirmwarePath + "ProXR-AD8-Lite124.hex -DPIC16F690")
    End Sub
    Private Sub MirCCR8x_802154_Click(sender As Object, e As EventArgs) Handles MirCCR8x_802154.Click
        ProgramME(FirmwarePath + "ProXR-AD8-Lite8.hex -DPIC16F690")
    End Sub
    Private Sub MirM_Inputs_Click(sender As Object, e As EventArgs) Handles MirM_Inputs.Click
        ProgramME(FirmwarePath + "Mirror\MirM_Sender_V2.HEX -DPIC16F690")
    End Sub
    Private Sub MIRCC1x_S3B_MirW_Click(sender As Object, e As EventArgs) Handles MIRCC1x_S3B_MirW.Click
        ProgramME(FirmwarePath + "Mirror\MirW_Sender_1-Channel_S3B.HEX -DPIC18F14K22")
    End Sub
    Private Sub MIRCC2x_S3B_MirW_Click(sender As Object, e As EventArgs) Handles MIRCC2x_S3B_MirW.Click
        ProgramME(FirmwarePath + "Mirror\MirW_Sender_2-Channel_S3B.HEX -DPIC18F14K22")
    End Sub
    Private Sub MIRCC4x_S3B_MirW_Click(sender As Object, e As EventArgs) Handles MIRCC4x_S3B_MirW.Click
        ProgramME(FirmwarePath + "Mirror\MirW_Sender_4-Channel_S3B.HEX -DPIC18F14K22")
    End Sub
    Private Sub MIRCC8x_S3B_MirW_Click(sender As Object, e As EventArgs) Handles MIRCC8x_S3B_MirW.Click
        ProgramME(FirmwarePath + "Mirror\MirW_Sender_8-Channel_S3B.HEX -DPIC18F14K22")
    End Sub
    Private Sub PR3317_Click(sender As Object, e As EventArgs) Handles PR3317.Click
        ProgramME(FirmwarePath + "PR33-17_HW-I2C.hex -DPIC12F1840")
    End Sub
    Private Sub PR3318_Click(sender As Object, e As EventArgs) Handles PR3318.Click
        ProgramME(FirmwarePath + "PR33-17_HW-I2C.hex -DPIC12F1840")
    End Sub
    Private Sub MirCC1x_WiFi_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC1x_WiFi_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_WIFI_1-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC2x_WiFi_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC2x_WiFi_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_WIFI_2-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC4x_WiFi_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC4x_WiFi_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_WIFI_4-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC8x_WiFi_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC8x_WiFi_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_WIFI_8-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC1x_Ethernet_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC1x_Ethernet_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_Ethernet_1-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC2x_Ethernet_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC2x_Ethernet_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_Ethernet_2-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC4x_Ethernet_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC4x_Ethernet_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_Ethernet_4-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC8x_Ethernet_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC8x_Ethernet_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_Ethernet_8-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC1x_S3B_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC1x_S3B_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_S3B_1-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC2x_S3B_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC2x_S3B_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_S3B_2-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC4x_S3B_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC4x_S3B_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_S3B_4-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC8x_S3B_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC8x_S3B_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_S3B_8-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC1x_Serial_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC1x_Serial_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_Serial_1-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC2x_Serial_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC2x_Serial_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_Serial_2-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC4x_Serial_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC4x_Serial_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_Serial_4-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC8x_Serial_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC8x_Serial_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_Serial_8-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC1x_USB_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC1x_USB_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_USB_1-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC2x_USB_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC2x_USB_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_USB_2-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC4x_USB_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC4x_USB_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_USB_4-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub MirCC8x_USB_Push_Click_1(sender As Object, e As EventArgs) Handles MirCC8x_USB_Push.Click
        ProgramME(FirmwarePath + "Push\PushAlert_USB_8-Channel.HEX -DPIC18F14K22")
    End Sub
    Private Sub ASM11_Click(sender As Object, e As EventArgs) Handles ASM11.Click
        ProgramME(FirmwarePath + "endNode\ASM1-1.HEX -DPIC18F46K22")
    End Sub
    Private Sub ASM12_Click(sender As Object, e As EventArgs) Handles ASM12.Click
        ProgramME(FirmwarePath + "endNode\ASM1-2.HEX -DPIC18F46K22")
    End Sub
    Private Sub ASM13_Click(sender As Object, e As EventArgs) Handles ASM13.Click
        ProgramME(FirmwarePath + "endNode\ASM1-3.HEX -DPIC18F46K22")
    End Sub
    Private Sub ASM14_Click(sender As Object, e As EventArgs) Handles ASM14.Click
        ProgramME(FirmwarePath + "endNode\ASM1-4.HEX -DPIC18F46K22")
    End Sub
    Private Sub ASM15_Click(sender As Object, e As EventArgs) Handles ASM15.Click
        ProgramME(FirmwarePath + "endNode\ASM1-5.HEX -DPIC18F46K22")
    End Sub
    Private Sub ASM16_Click(sender As Object, e As EventArgs) Handles ASM16.Click
        ProgramME(FirmwarePath + "endNode\ASM1-6.HEX -DPIC18F46K22")
    End Sub
    Private Sub ASM17_Click(sender As Object, e As EventArgs) Handles ASM17.Click
        ProgramME(FirmwarePath + "endNode\ASM1-7.HEX -DPIC18F46K22")
    End Sub
    Private Sub ASM18_Click(sender As Object, e As EventArgs) Handles ASM18.Click
        ProgramME(FirmwarePath + "endNode\ASM1-8.HEX -DPIC18F46K22")
    End Sub
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        FillAdminInfo()


        'C:\Users\Ryan\Documents\NCDAdmin\admin.txt

        LastProgrammer.Value = 1


        Debug.Print(FirmwarePath)

        'Dim filename2 As String = GetConfigureInfoPath() + "\NCDConfig.cfg"
        'If IO.File.Exists(filename2) Then
        'End If



        Dim BaseLength = (FirmwarePath + "Enterprise\").Length + 1
        Dim fileNames = My.Computer.FileSystem.GetFiles(FirmwarePath + "Enterprise\", FileIO.SearchOption.SearchTopLevelOnly, "*.elf")
        Dim DifferenceLength As Integer

        For Each fileName As String In fileNames
            DifferenceLength = (fileName.Length - BaseLength) - 3
            Dim result As String = Mid(fileName, BaseLength, DifferenceLength) ' Path.GetFileName(fileName)
            FirmwareList.Items.Add(result)
        Next



    End Sub
    Private Sub FirmwareList_SelectedIndexChanged(sender As Object, e As EventArgs) Handles FirmwareList.SelectedIndexChanged
        AtmelProgram.Enabled = True
        AtmelCPU = "atmega168pa"
        If FirmwareList.SelectedItem = "PR49-24H" Then AtmelCPU = "atmega328p"
        If FirmwareList.SelectedItem = "PR55-20" Then AtmelCPU = "atmega328p"
        If FirmwareList.SelectedItem = "PR52-33N" Then AtmelCPU = "atmega328p"
        If FirmwareList.SelectedItem = "PR55-17C_Autoencoder" Then AtmelCPU = "atiny841"
        If FirmwareList.SelectedItem = "PR55-17C_Emulator" Then AtmelCPU = "atiny841"
        If FirmwareList.SelectedItem = "Unity" Then AtmelCPU = "atiny841"
        CPU.Text = AtmelCPU
    End Sub
    Private Sub AtmelProgram_Click(sender As Object, e As EventArgs) Handles AtmelProgram.Click
        ProgramATMEL(FirmwareList.SelectedItem, AtmelCPU)
    End Sub

    Private Sub None_Click(sender As Object, e As EventArgs) Handles None.Click

        Dim Programmer As Integer

        For Programmer = FirstProgrammer.Value To LastProgrammer.Value

            If Programmer = 1 Then Programmer1.Checked = False
            If Programmer = 2 Then Programmer2.Checked = False
            If Programmer = 3 Then Programmer3.Checked = False
            If Programmer = 4 Then Programmer4.Checked = False
            If Programmer = 5 Then Programmer5.Checked = False
            If Programmer = 6 Then Programmer6.Checked = False
            If Programmer = 7 Then Programmer7.Checked = False
            If Programmer = 8 Then Programmer8.Checked = False
            If Programmer = 9 Then Programmer9.Checked = False
            If Programmer = 10 Then Programmer10.Checked = False
            If Programmer = 11 Then Programmer11.Checked = False
            If Programmer = 12 Then Programmer12.Checked = False
            If Programmer = 13 Then Programmer13.Checked = False
            If Programmer = 14 Then Programmer14.Checked = False
            If Programmer = 15 Then Programmer15.Checked = False
            If Programmer = 16 Then Programmer16.Checked = False

            If Programmer = 17 Then Programmer17.Checked = False
            If Programmer = 18 Then Programmer18.Checked = False
            If Programmer = 19 Then Programmer19.Checked = False
            If Programmer = 20 Then Programmer20.Checked = False
            If Programmer = 21 Then Programmer21.Checked = False
            If Programmer = 22 Then Programmer22.Checked = False
            If Programmer = 23 Then Programmer23.Checked = False
            If Programmer = 24 Then Programmer24.Checked = False
            If Programmer = 25 Then Programmer25.Checked = False
            If Programmer = 26 Then Programmer26.Checked = False
            If Programmer = 27 Then Programmer27.Checked = False
            If Programmer = 28 Then Programmer28.Checked = False
            If Programmer = 29 Then Programmer29.Checked = False
            If Programmer = 30 Then Programmer30.Checked = False
            If Programmer = 31 Then Programmer31.Checked = False
            If Programmer = 32 Then Programmer32.Checked = False

            If Programmer = 33 Then Programmer33.Checked = False
            If Programmer = 34 Then Programmer34.Checked = False
            If Programmer = 35 Then Programmer35.Checked = False
            If Programmer = 36 Then Programmer36.Checked = False
            If Programmer = 37 Then Programmer37.Checked = False
            If Programmer = 38 Then Programmer38.Checked = False
            If Programmer = 39 Then Programmer39.Checked = False
            If Programmer = 40 Then Programmer40.Checked = False
            If Programmer = 41 Then Programmer41.Checked = False
            If Programmer = 42 Then Programmer42.Checked = False
            If Programmer = 43 Then Programmer43.Checked = False
            If Programmer = 44 Then Programmer44.Checked = False
            If Programmer = 45 Then Programmer45.Checked = False
            If Programmer = 46 Then Programmer46.Checked = False
            If Programmer = 47 Then Programmer47.Checked = False
            If Programmer = 48 Then Programmer48.Checked = False

            If Programmer = 49 Then Programmer49.Checked = False
            If Programmer = 50 Then Programmer50.Checked = False
            If Programmer = 51 Then Programmer51.Checked = False
            If Programmer = 52 Then Programmer52.Checked = False
            If Programmer = 53 Then Programmer53.Checked = False
            If Programmer = 54 Then Programmer54.Checked = False
            If Programmer = 55 Then Programmer55.Checked = False
            If Programmer = 56 Then Programmer56.Checked = False

        Next Programmer

    End Sub
    Private Sub Even_Click(sender As Object, e As EventArgs) Handles Even.Click
        Dim Programmer As Integer

        For Programmer = FirstProgrammer.Value To LastProgrammer.Value

            If Programmer = 1 Then Programmer1.Checked = False
            If Programmer = 2 Then Programmer2.Checked = True
            If Programmer = 3 Then Programmer3.Checked = False
            If Programmer = 4 Then Programmer4.Checked = True
            If Programmer = 5 Then Programmer5.Checked = False
            If Programmer = 6 Then Programmer6.Checked = True
            If Programmer = 7 Then Programmer7.Checked = False
            If Programmer = 8 Then Programmer8.Checked = True
            If Programmer = 9 Then Programmer9.Checked = False
            If Programmer = 10 Then Programmer10.Checked = True
            If Programmer = 11 Then Programmer11.Checked = False
            If Programmer = 12 Then Programmer12.Checked = True
            If Programmer = 13 Then Programmer13.Checked = False
            If Programmer = 14 Then Programmer14.Checked = True
            If Programmer = 15 Then Programmer15.Checked = False
            If Programmer = 16 Then Programmer16.Checked = True

            If Programmer = 17 Then Programmer17.Checked = False
            If Programmer = 18 Then Programmer18.Checked = True
            If Programmer = 19 Then Programmer19.Checked = False
            If Programmer = 20 Then Programmer20.Checked = True
            If Programmer = 21 Then Programmer21.Checked = False
            If Programmer = 22 Then Programmer22.Checked = True
            If Programmer = 23 Then Programmer23.Checked = False
            If Programmer = 24 Then Programmer24.Checked = True
            If Programmer = 25 Then Programmer25.Checked = False
            If Programmer = 26 Then Programmer26.Checked = True
            If Programmer = 27 Then Programmer27.Checked = False
            If Programmer = 28 Then Programmer28.Checked = True
            If Programmer = 29 Then Programmer29.Checked = False
            If Programmer = 30 Then Programmer30.Checked = True
            If Programmer = 31 Then Programmer31.Checked = False
            If Programmer = 32 Then Programmer32.Checked = True

            If Programmer = 33 Then Programmer33.Checked = False
            If Programmer = 34 Then Programmer34.Checked = True
            If Programmer = 35 Then Programmer35.Checked = False
            If Programmer = 36 Then Programmer36.Checked = True
            If Programmer = 37 Then Programmer37.Checked = False
            If Programmer = 38 Then Programmer38.Checked = True
            If Programmer = 39 Then Programmer39.Checked = False
            If Programmer = 40 Then Programmer40.Checked = True
            If Programmer = 41 Then Programmer41.Checked = False
            If Programmer = 42 Then Programmer42.Checked = True
            If Programmer = 43 Then Programmer43.Checked = False
            If Programmer = 44 Then Programmer44.Checked = True
            If Programmer = 45 Then Programmer45.Checked = False
            If Programmer = 46 Then Programmer46.Checked = True
            If Programmer = 47 Then Programmer47.Checked = False
            If Programmer = 48 Then Programmer48.Checked = True

            If Programmer = 49 Then Programmer49.Checked = False
            If Programmer = 50 Then Programmer50.Checked = True
            If Programmer = 51 Then Programmer51.Checked = False
            If Programmer = 52 Then Programmer52.Checked = True
            If Programmer = 53 Then Programmer53.Checked = False
            If Programmer = 54 Then Programmer54.Checked = True
            If Programmer = 55 Then Programmer55.Checked = False
            If Programmer = 56 Then Programmer56.Checked = True

        Next Programmer
    End Sub
    Private Sub Odd_Click(sender As Object, e As EventArgs) Handles Odd.Click
        Dim Programmer As Integer

        For Programmer = FirstProgrammer.Value To LastProgrammer.Value

            If Programmer = 1 Then Programmer1.Checked = True
            If Programmer = 2 Then Programmer2.Checked = False
            If Programmer = 3 Then Programmer3.Checked = True
            If Programmer = 4 Then Programmer4.Checked = False
            If Programmer = 5 Then Programmer5.Checked = True
            If Programmer = 6 Then Programmer6.Checked = False
            If Programmer = 7 Then Programmer7.Checked = True
            If Programmer = 8 Then Programmer8.Checked = False
            If Programmer = 9 Then Programmer9.Checked = True
            If Programmer = 10 Then Programmer10.Checked = False
            If Programmer = 11 Then Programmer11.Checked = True
            If Programmer = 12 Then Programmer12.Checked = False
            If Programmer = 13 Then Programmer13.Checked = True
            If Programmer = 14 Then Programmer14.Checked = False
            If Programmer = 15 Then Programmer15.Checked = True
            If Programmer = 16 Then Programmer16.Checked = False

            If Programmer = 17 Then Programmer17.Checked = True
            If Programmer = 18 Then Programmer18.Checked = False
            If Programmer = 19 Then Programmer19.Checked = True
            If Programmer = 20 Then Programmer20.Checked = False
            If Programmer = 21 Then Programmer21.Checked = True
            If Programmer = 22 Then Programmer22.Checked = False
            If Programmer = 23 Then Programmer23.Checked = True
            If Programmer = 24 Then Programmer24.Checked = False
            If Programmer = 25 Then Programmer25.Checked = True
            If Programmer = 26 Then Programmer26.Checked = False
            If Programmer = 27 Then Programmer27.Checked = True
            If Programmer = 28 Then Programmer28.Checked = False
            If Programmer = 29 Then Programmer29.Checked = True
            If Programmer = 30 Then Programmer30.Checked = False
            If Programmer = 31 Then Programmer31.Checked = True
            If Programmer = 32 Then Programmer32.Checked = False

            If Programmer = 33 Then Programmer33.Checked = True
            If Programmer = 34 Then Programmer34.Checked = False
            If Programmer = 35 Then Programmer35.Checked = True
            If Programmer = 36 Then Programmer36.Checked = False
            If Programmer = 37 Then Programmer37.Checked = True
            If Programmer = 38 Then Programmer38.Checked = False
            If Programmer = 39 Then Programmer39.Checked = True
            If Programmer = 40 Then Programmer40.Checked = False
            If Programmer = 41 Then Programmer41.Checked = True
            If Programmer = 42 Then Programmer42.Checked = False
            If Programmer = 43 Then Programmer43.Checked = True
            If Programmer = 44 Then Programmer44.Checked = False
            If Programmer = 45 Then Programmer45.Checked = True
            If Programmer = 46 Then Programmer46.Checked = False
            If Programmer = 47 Then Programmer47.Checked = True
            If Programmer = 48 Then Programmer48.Checked = False

            If Programmer = 49 Then Programmer49.Checked = True
            If Programmer = 50 Then Programmer50.Checked = False
            If Programmer = 51 Then Programmer51.Checked = True
            If Programmer = 52 Then Programmer52.Checked = False
            If Programmer = 53 Then Programmer53.Checked = True
            If Programmer = 54 Then Programmer54.Checked = False
            If Programmer = 55 Then Programmer55.Checked = True
            If Programmer = 56 Then Programmer56.Checked = False

        Next Programmer
    End Sub
    Private Sub Thirds_Click(sender As Object, e As EventArgs) Handles Thirds.Click
        Dim Programmer As Integer

        For Programmer = FirstProgrammer.Value To LastProgrammer.Value

            If Programmer = 1 Then Programmer1.Checked = True
            If Programmer = 2 Then Programmer2.Checked = False
            If Programmer = 3 Then Programmer3.Checked = False
            If Programmer = 4 Then Programmer4.Checked = True
            If Programmer = 5 Then Programmer5.Checked = False
            If Programmer = 6 Then Programmer6.Checked = False
            If Programmer = 7 Then Programmer7.Checked = True
            If Programmer = 8 Then Programmer8.Checked = False
            If Programmer = 9 Then Programmer9.Checked = False
            If Programmer = 10 Then Programmer10.Checked = True
            If Programmer = 11 Then Programmer11.Checked = False
            If Programmer = 12 Then Programmer12.Checked = False
            If Programmer = 13 Then Programmer13.Checked = True
            If Programmer = 14 Then Programmer14.Checked = False
            If Programmer = 15 Then Programmer15.Checked = False
            If Programmer = 16 Then Programmer16.Checked = True

            If Programmer = 17 Then Programmer17.Checked = False
            If Programmer = 18 Then Programmer18.Checked = False
            If Programmer = 19 Then Programmer19.Checked = True
            If Programmer = 20 Then Programmer20.Checked = False
            If Programmer = 21 Then Programmer21.Checked = False
            If Programmer = 22 Then Programmer22.Checked = True
            If Programmer = 23 Then Programmer23.Checked = False
            If Programmer = 24 Then Programmer24.Checked = False
            If Programmer = 25 Then Programmer25.Checked = True
            If Programmer = 26 Then Programmer26.Checked = False
            If Programmer = 27 Then Programmer27.Checked = False
            If Programmer = 28 Then Programmer28.Checked = True
            If Programmer = 29 Then Programmer29.Checked = False
            If Programmer = 30 Then Programmer30.Checked = False
            If Programmer = 31 Then Programmer31.Checked = True
            If Programmer = 32 Then Programmer32.Checked = False

            If Programmer = 33 Then Programmer33.Checked = False
            If Programmer = 34 Then Programmer34.Checked = True
            If Programmer = 35 Then Programmer35.Checked = False
            If Programmer = 36 Then Programmer36.Checked = False
            If Programmer = 37 Then Programmer37.Checked = True
            If Programmer = 38 Then Programmer38.Checked = False
            If Programmer = 39 Then Programmer39.Checked = False
            If Programmer = 40 Then Programmer40.Checked = True
            If Programmer = 41 Then Programmer41.Checked = False
            If Programmer = 42 Then Programmer42.Checked = False
            If Programmer = 43 Then Programmer43.Checked = True
            If Programmer = 44 Then Programmer44.Checked = False
            If Programmer = 45 Then Programmer45.Checked = False
            If Programmer = 46 Then Programmer46.Checked = True
            If Programmer = 47 Then Programmer47.Checked = False
            If Programmer = 48 Then Programmer48.Checked = False

            If Programmer = 49 Then Programmer49.Checked = True
            If Programmer = 50 Then Programmer50.Checked = False
            If Programmer = 51 Then Programmer51.Checked = False
            If Programmer = 52 Then Programmer52.Checked = True
            If Programmer = 53 Then Programmer53.Checked = False
            If Programmer = 54 Then Programmer54.Checked = False
            If Programmer = 55 Then Programmer55.Checked = True
            If Programmer = 56 Then Programmer56.Checked = False

        Next Programmer
    End Sub
    Private Sub Fourths_Click(sender As Object, e As EventArgs) Handles Fourths.Click

        Dim Programmer As Integer

        For Programmer = FirstProgrammer.Value To LastProgrammer.Value

            If Programmer = 1 Then Programmer1.Checked = True
            If Programmer = 2 Then Programmer2.Checked = False
            If Programmer = 3 Then Programmer3.Checked = False
            If Programmer = 4 Then Programmer4.Checked = False
            If Programmer = 5 Then Programmer5.Checked = True
            If Programmer = 6 Then Programmer6.Checked = False
            If Programmer = 7 Then Programmer7.Checked = False
            If Programmer = 8 Then Programmer8.Checked = False
            If Programmer = 9 Then Programmer9.Checked = True
            If Programmer = 10 Then Programmer10.Checked = False
            If Programmer = 11 Then Programmer11.Checked = False
            If Programmer = 12 Then Programmer12.Checked = False
            If Programmer = 13 Then Programmer13.Checked = True
            If Programmer = 14 Then Programmer14.Checked = False
            If Programmer = 15 Then Programmer15.Checked = False
            If Programmer = 16 Then Programmer16.Checked = False

            If Programmer = 17 Then Programmer17.Checked = True
            If Programmer = 18 Then Programmer18.Checked = False
            If Programmer = 19 Then Programmer19.Checked = False
            If Programmer = 20 Then Programmer20.Checked = False
            If Programmer = 21 Then Programmer21.Checked = True
            If Programmer = 22 Then Programmer22.Checked = False
            If Programmer = 23 Then Programmer23.Checked = False
            If Programmer = 24 Then Programmer24.Checked = False
            If Programmer = 25 Then Programmer25.Checked = True
            If Programmer = 26 Then Programmer26.Checked = False
            If Programmer = 27 Then Programmer27.Checked = False
            If Programmer = 28 Then Programmer28.Checked = False
            If Programmer = 29 Then Programmer29.Checked = True
            If Programmer = 30 Then Programmer30.Checked = False
            If Programmer = 31 Then Programmer31.Checked = False
            If Programmer = 32 Then Programmer32.Checked = False

            If Programmer = 33 Then Programmer33.Checked = True
            If Programmer = 34 Then Programmer34.Checked = False
            If Programmer = 35 Then Programmer35.Checked = False
            If Programmer = 36 Then Programmer36.Checked = False
            If Programmer = 37 Then Programmer37.Checked = True
            If Programmer = 38 Then Programmer38.Checked = False
            If Programmer = 39 Then Programmer39.Checked = False
            If Programmer = 40 Then Programmer40.Checked = False
            If Programmer = 41 Then Programmer41.Checked = True
            If Programmer = 42 Then Programmer42.Checked = False
            If Programmer = 43 Then Programmer43.Checked = False
            If Programmer = 44 Then Programmer44.Checked = False
            If Programmer = 45 Then Programmer45.Checked = True
            If Programmer = 46 Then Programmer46.Checked = False
            If Programmer = 47 Then Programmer47.Checked = False
            If Programmer = 48 Then Programmer48.Checked = False

            If Programmer = 49 Then Programmer49.Checked = True
            If Programmer = 50 Then Programmer50.Checked = False
            If Programmer = 51 Then Programmer51.Checked = False
            If Programmer = 52 Then Programmer52.Checked = False
            If Programmer = 53 Then Programmer53.Checked = True
            If Programmer = 54 Then Programmer54.Checked = False
            If Programmer = 55 Then Programmer55.Checked = False
            If Programmer = 56 Then Programmer56.Checked = False

        Next Programmer

    End Sub
    Private Sub R124PL_Standard_Click(sender As Object, e As EventArgs) Handles R124PL_Standard.Click
        ProgramME(FirmwarePath + "ProXR-AD8-Lite124.hex -DPIC16F690")
        SelectTest(4)
    End Sub
    Private Sub R8PL_Standard_Click(sender As Object, e As EventArgs) Handles R8PL_Standard.Click
        ProgramME(FirmwarePath + "ProXR-AD8-Lite8.hex -DPIC16F690")
        SelectTest(4)
    End Sub
    Private Sub UPOT8PROXR_Click(sender As Object, e As EventArgs) Handles UPOT8PROXR.Click
        ProgramME(FirmwarePath + "ProXR-POT-USB.hex -DPIC16F690")
        SelectTest(4)
    End Sub



    ''' <summary>
    ''' Get com ports in strings, exclude the one selected
    ''' </summary>
    ''' <returns></returns>
    Private Function GetUsableComPorts() As String()
        Dim ports As New ArrayList
        Dim portsString() As String
        mSerialPortInfos = NCDEnterprise.ListPorts.EnumPorts()
        If Not (mSerialPortInfos Is Nothing) Then
            For Each p In mSerialPortInfos
                ports.Add(p.PortName)
            Next
            portsString = ports.ToArray(GetType(String))
            portsString = adminInfo.GetUnselectedPorts(portsString)
        End If
        Return portsString
    End Function

    Private Sub ScanPorts_Click(sender As Object, e As EventArgs) Handles ScanPorts.Click

        BuildCOMList()

    End Sub

    Public Sub BuildCOMList()
        'mSerialPortInfos = NCDEnterprise.ListPorts.EnumPorts()
        'USBTestingPorts.Items.Clear()

        TestList.Rows.Clear()

        'If Not (mSerialPortInfos Is Nothing) Then
        '    For i As Integer = 0 To mSerialPortInfos.Length - 1
        '        USBTestingPorts.Items.Add(mSerialPortInfos(i).PortName)
        '    Next
        '    If USBTestingPorts.Items.Count > 0 And PortName = String.Empty Then
        '        USBTestingPorts.SelectedIndex = 0
        '    Else
        '        USBTestingPorts.Text = PortName
        '    End If
        'End If
        ''''''''''''''''''''''''''''''''''''''''''''''''''
        Dim ports() As String = GetUsableComPorts()
        Dim Y As Integer = 0
        If Not (ports Is Nothing) Then

            ' If USBTestingPorts.Items.Count > 0 And PortName = String.Empty Then
            '     USBTestingPorts.SelectedIndex = 0
            ' Else
            '     USBTestingPorts.Text = PortName
            ' End If

            For Each p In ports
                ' USBTestingPorts.Items.Add(p)
                Me.TestList.Rows.Add()
                Y = Y + 1

                TestList(0, Y - 1).Value = True
                PutCellData(1, Y - 1, p) 'Add COM Port to List
                PutCellData(2, Y - 1, "Untested") 'Set Status to Untested
            Next

        End If

        SelectAll.Visible = True
        SelectNone.Visible = True
        TestSelectedDevices.Visible = True
    End Sub

    Public Sub PutCellData(x As Integer, Y As Integer, Dat As String)

        'DataTable(x, Y).Value = Dat

        ' DataTable.RowCount() = 33
        ' DataTable.ColumnCount() = 10
        ' DataTable(x, Y).Value = Dat
        ' DataTable()

        '  DataTable
        TestList(x, Y).Value = Dat

    End Sub

    Public Function GetCellData(x As Integer, Y As Integer) As String

        'DataTable(x, Y).Value = Dat

        ' DataTable.RowCount() = 33
        ' DataTable.ColumnCount() = 10
        ' DataTable(x, Y).Value = Dat
        ' DataTable()

        '  DataTable
        GetCellData = TestList(x, Y).Value

    End Function

    ' Public Property PortName() As String
    '     Get
    '         Return USBTestingPorts.Text
    '     End Get
    '     Set(ByVal value As String)
    '         USBTestingPorts.Text = value
    '     End Set
    ' End Property


    ''' <summary>
    ''' Update serial ports scaned, will keep selected ports's status if they are exist
    ''' </summary>
    'Public Sub UpdateSerialPorts(portsnew() As PortInfo, portsOld())
    '    If ports Is Nothing Then
    '        Exit Sub
    '    End If
    '    If ComPorts Is Nothing Then
    '        ComPorts = ports
    '        Exit Sub
    '    End If
    '    For Each newPort As PortInfo In ports
    '        For Each oldPort As PortInfo In ComPorts
    '            If (newPort.PortName = oldPort.PortName) Then
    '                newPort.Selected = oldPort.Selected
    '            End If
    '        Next
    '    Next
    '    ' update ports
    '    ComPorts = ports
    'End Sub

    ' Private mSerialPortInfos() As NCDEnterprise.SerialDeviceInfo
    Private Sub ExcludeScanPorts_Click(sender As Object, e As EventArgs) Handles ExcludeScanPorts.Click

        mSerialPortInfos = NCDEnterprise.ListPorts.EnumPorts()
        Dim portsArr As New ArrayList
        ' keep the current selected
        Dim oldportsArr As New ArrayList
        For Each item In ExcludedUSBPorts.CheckedItems
            Dim port As New AdminInformation.PortInfo
            port.PortName = item.ToString
            port.Selected = True
            oldportsArr.Add(port)
        Next

        TestList.Rows.Clear()
        ExcludedUSBPorts.Items.Clear()
        If Not (mSerialPortInfos Is Nothing) Then
            For Each p In mSerialPortInfos
                Dim portInfo As New AdminInformation.PortInfo
                portInfo.PortName = p.PortName
                portsArr.Add(portInfo)
            Next
            For Each p In portsArr
                For Each pold In oldportsArr
                    If p.PortName = pold.PortName Then
                        p.selected = True
                    End If
                Next
            Next
            'Dim portsInfo() As AdminInformation.PortInfo = portsArr.ToArray(GetType(AdminInformation.PortInfo))
            ''adminInfo.UpdateSerialPorts(portsInfo)
            'If adminInfo.ComPorts Is Nothing Then
            '    Exit Sub
            'End If
            For Each p In portsArr
                Dim id As Integer = ExcludedUSBPorts.Items.Add(p.PortName, p.Selected)
            Next

            If ExcludedUSBPorts.Items.Count > 0 And PortName2 = String.Empty Then
                ExcludedUSBPorts.SelectedIndex = 0
            Else
                ExcludedUSBPorts.Text = PortName2
            End If
        End If
    End Sub
    Public Property PortName2() As String
        Get
            Return ExcludedUSBPorts.Text
        End Get
        Set(ByVal value As String)
            ExcludedUSBPorts.Text = value
        End Set
    End Property

    Private Sub SelectAll_Click(sender As Object, e As EventArgs) Handles SelectAll.Click
        For I = 0 To TestList.Rows.Count - 1
            ' USBTestingPorts.SetItemChecked(I, True)
            TestList(0, I).Value = True
        Next
    End Sub

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        'adminInfo.FirmwarePath = "c:\tt"
        'adminInfo.ProgrammerPath = "d:\tt"
        Dim portsArr As New ArrayList
        For i = 1 To ExcludedUSBPorts.Items.Count
            Dim port As New AdminInformation.PortInfo
            port.PortName = ExcludedUSBPorts.Items.Item(i - 1).ToString
            port.Selected = ExcludedUSBPorts.GetItemChecked(i - 1)
            portsArr.Add(port)
        Next
        adminInfo.ComPorts = portsArr.ToArray(GetType(AdminInformation.PortInfo))
        Dim AtmelIECArr As New ArrayList

        For Each item In AtmelICESerialNumbers.Items
            AtmelIECArr.Add(item.ToString)
        Next
        adminInfo.AtmelICE = AtmelIECArr.ToArray(GetType(String))

        adminInfo.FirmwarePath = txtFirmware.Text
        adminInfo.ProgrammerPath = txtProgrammer.Text
        adminInfo.Save()

        FirmwarePath = adminInfo.FirmwarePath
        ' update programmer path, if needed

    End Sub

    Private Sub ExcludedUSBPorts_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ExcludedUSBPorts.SelectedIndexChanged

    End Sub

    Private Sub btnAddAtmel_Click(sender As Object, e As EventArgs) Handles btnAddAtmel.Click
        Dim frm As New frmAddAtmel
        If frm.ShowDialog = DialogResult.OK Then
            AtmelICESerialNumbers.Items.Add(frm.txtID.Text)
        End If

    End Sub

    Private Sub SetFirmwarePath_Click(sender As Object, e As EventArgs) Handles SetFirmwarePath.Click
        FolderBrowserDialog1.SelectedPath = txtFirmware.Text
        If FolderBrowserDialog1.ShowDialog() = DialogResult.OK Then
            txtFirmware.Text = FolderBrowserDialog1.SelectedPath
        End If
    End Sub

    Private Sub SetProgrammerPath_Click(sender As Object, e As EventArgs) Handles SetProgrammerPath.Click
        OpenFileDialog1.FileName = txtProgrammer.Text
        If OpenFileDialog1.ShowDialog = DialogResult.OK Then
            txtProgrammer.Text = OpenFileDialog1.FileName
        End If
    End Sub

    Private Sub chkDeleteAtmel_Click(sender As Object, e As EventArgs) Handles chkDeleteAtmel.Click
        If AtmelICESerialNumbers.SelectedItem Is Nothing Then
        Else
            AtmelICESerialNumbers.Items.Remove(AtmelICESerialNumbers.SelectedItem)

        End If
    End Sub
    Private Sub SelectNone_Click(sender As Object, e As EventArgs) Handles SelectNone.Click


        For I = 0 To TestList.Rows.Count - 1
            '    USBTestingPorts.SetItemChecked(I, False)
            TestList(0, I).Value = False
        Next
    End Sub

    Private Sub TestSelectedDevices_Click(sender As Object, e As EventArgs) Handles TestSelectedDevices.Click
        'For Each item In USBTestingPorts_BAD.CheckedItems


        ' Debug.Print(TestList.Rows.Count.ToString)

        For Item = 1 To TestList.Rows.Count
            If TestList(0, Item - 1).Value = True Then  'If COM Port is Checked
                Dim Port As String = GetCellData(1, Item - 1) '  Item.ToString()
                Debug.Print(Port)
                TestList(0, Item - 1).Selected = True

                Dim Result As String = "Untested"
                Result = LaunchTestApplication(Port)

                TestList(0, Item - 1).Selected = False

                If Result <> "" Then
                    TestList(2, Item - 1).Value = Result 'frm.TestResult
                End If

                ' If frm.TestResult = "Pass" Then
                If Result = "Pass" Then
                        ' Debug.Print(frm.TestResult)
                        TestList(0, Item - 1).Value = 0
                    End If

                    ' check frm return status
                    NcdController1.ClosePort()
                End If




            ' If TestList(0, item).Value = True Then
            'Debug.Print(GetCellData(0, Item))
            '
            '      NcdController1.UsingComPort = True
            '          NcdController1.PortName = item.ToString()
            '          NcdController1.BaudRate = 115200
            '          NcdController1.OpenPort()
            '          ' call the form
            '          Dim frm As New frmProXR_Quality_V2
            '          frm.NCDComponent1 = NcdController1
            '          ' check frm return status
            '
            '          NcdController1.ClosePort()
            '     ' End If
        Next

        'For i = 0 To USBTestingPorts.Items.Count - 1
        '    If USBTestingPorts.GetItemChecked(i) = True Then 'GetItemChecked(i, True)

        '        Debug.Print(USBTestingPorts.GetItemText(i))
        '        Debug.Print(USBTestingPorts.Text(i))
        '        ' Debug.Print(USBTestingPorts(i).Text)
        '    End If
        'Next
    End Sub

    Public Function LaunchTestApplication(Port As String)
        NcdController1.UsingComPort = True
        NcdController1.PortName = Port
        NcdController1.BaudRate = 115200
        NcdController1.OpenPort()
        ' call the form

        ' 1 Or 2-Channel Low Cost Serial (OK)
        ' 1 Or 2-Channel Low Cost ZigBee (OK)
        ' 4 Or 8-Channel Pro Series (OK)
        ' Fusion Series (OK)
        ' ProXR Series (OK)
        ' Reactor Series (OK)
        ' Scan Series (OK)
        ' Taralist Series (OK)
        ' AD8 Test (OK)
        ' AD8 Port 2 Test (OK)
        ' AD1216 Test (OK)
        ' Reactor AD8 Test (OK)

        If TestApplication.SelectedItem = "Scan Series" Then
            Dim frm As New frmSCAN_Quality
            frm.NCDComponent1 = NcdController1
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If

        If TestApplication.SelectedItem = "Reactor AD8 Test" Then
            Dim frm As New frmReactorAD8_Quality
            frm.NCDComponent1 = NcdController1
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If

        If TestApplication.SelectedItem = "AD8 Port 2 Test" Then
            Dim frm As New frmAD8_Port2_Quality
            frm.NCDComponent1 = NcdController1
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If

        If TestApplication.SelectedItem = "AD8 Test" Then
            Dim frm As New frmAD8_Quality
            frm.NCDComponent1 = NcdController1
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If

        If TestApplication.SelectedItem = "AD1216 Test" Then
            Dim frm As New frmAD1216_Quality
            frm.NCDComponent1 = NcdController1
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If

        If TestApplication.SelectedItem = "1 Or 2-Channel Low Cost Serial" Then
            Dim frm As New frmR1xR2x_Quality
            frm.NCDComponent1 = NcdController1
            If Channels.SelectedIndex = 0 Then frm.RelaysSelected = 4 ' 0
            If Channels.SelectedIndex = 1 Then frm.RelaysSelected = 1 ' 1
            If Channels.SelectedIndex = 2 Then frm.RelaysSelected = 2 ' 2
            If Channels.SelectedIndex = 3 Then frm.RelaysSelected = 4 ' 4
            If Channels.SelectedIndex = 4 Then frm.RelaysSelected = 8 ' 8     
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If

        If TestApplication.SelectedItem = "1 Or 2-Channel Low Cost ZigBee" Then
            Dim frm As New frmZR1xZR2x_Quality
            frm.NCDComponent1 = NcdController1
            If Channels.SelectedIndex = 0 Then frm.RelaysSelected = 4 ' 0
            If Channels.SelectedIndex = 1 Then frm.RelaysSelected = 1 ' 1
            If Channels.SelectedIndex = 2 Then frm.RelaysSelected = 2 ' 2
            If Channels.SelectedIndex = 3 Then frm.RelaysSelected = 4 ' 4
            If Channels.SelectedIndex = 4 Then frm.RelaysSelected = 8 ' 8     
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If


        If TestApplication.SelectedItem = "ProXR Series" Then
            Dim frm As New frmProXR_Quality_V2
            frm.NCDComponent1 = NcdController1
            If Channels.SelectedIndex = 0 Then frm.RelaysSelected = 4 ' 0
            If Channels.SelectedIndex = 1 Then frm.RelaysSelected = 1 ' 1
            If Channels.SelectedIndex = 2 Then frm.RelaysSelected = 2 ' 2
            If Channels.SelectedIndex = 3 Then frm.RelaysSelected = 4 ' 4
            If Channels.SelectedIndex = 4 Then frm.RelaysSelected = 8 ' 8
            If Channels.SelectedIndex = 5 Then frm.RelaysSelected = 16 ' 16
            If Channels.SelectedIndex = 6 Then frm.RelaysSelected = 24 ' 24
            If Channels.SelectedIndex = 7 Then frm.RelaysSelected = 32 ' 32
            If Channels.SelectedIndex = 8 Then frm.RelaysSelected = 48 ' 48
            If Channels.SelectedIndex = 9 Then frm.RelaysSelected = 56 ' 56
            If Channels.SelectedIndex = 10 Then frm.RelaysSelected = 64 ' 64        
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If


        If TestApplication.SelectedItem = "Fusion Series" Then
            Dim frm As New frmFusion_Quality
            frm.NCDComponent1 = NcdController1
            If Channels.SelectedIndex = 0 Then frm.RelaysSelected = 4 ' 0
            If Channels.SelectedIndex = 1 Then frm.RelaysSelected = 1 ' 1
            If Channels.SelectedIndex = 2 Then frm.RelaysSelected = 2 ' 2
            If Channels.SelectedIndex = 3 Then frm.RelaysSelected = 4 ' 4
            If Channels.SelectedIndex = 4 Then frm.RelaysSelected = 8 ' 8
            If Channels.SelectedIndex = 5 Then frm.RelaysSelected = 16 ' 16
            If Channels.SelectedIndex = 6 Then frm.RelaysSelected = 24 ' 24
            If Channels.SelectedIndex = 7 Then frm.RelaysSelected = 32 ' 32
            If Channels.SelectedIndex = 8 Then frm.RelaysSelected = 48 ' 48
            If Channels.SelectedIndex = 9 Then frm.RelaysSelected = 56 ' 56
            If Channels.SelectedIndex = 10 Then frm.RelaysSelected = 64 ' 64        
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If

        If TestApplication.SelectedItem = "Taralist Series" Then
            Dim frm As New frmTaralist_Quality
            frm.NCDComponent1 = NcdController1
            If Channels.SelectedIndex = 0 Then frm.RelaysSelected = 4 ' 0
            If Channels.SelectedIndex = 1 Then frm.RelaysSelected = 1 ' 1
            If Channels.SelectedIndex = 2 Then frm.RelaysSelected = 2 ' 2
            If Channels.SelectedIndex = 3 Then frm.RelaysSelected = 4 ' 4
            If Channels.SelectedIndex = 4 Then frm.RelaysSelected = 8 ' 8
            If Channels.SelectedIndex = 5 Then frm.RelaysSelected = 16 ' 16
            If Channels.SelectedIndex = 6 Then frm.RelaysSelected = 24 ' 24
            If Channels.SelectedIndex = 7 Then frm.RelaysSelected = 32 ' 32
            If Channels.SelectedIndex = 8 Then frm.RelaysSelected = 48 ' 48
            If Channels.SelectedIndex = 9 Then frm.RelaysSelected = 56 ' 56
            If Channels.SelectedIndex = 10 Then frm.RelaysSelected = 64 ' 64        
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If


        If TestApplication.SelectedItem = "Reactor Series" Then
            Dim frm As New frmReactor_Quality
            frm.NCDComponent1 = NcdController1
            If Channels.SelectedIndex = 0 Then frm.RelaysSelected = 4 ' 0
            If Channels.SelectedIndex = 1 Then frm.RelaysSelected = 1 ' 1
            If Channels.SelectedIndex = 2 Then frm.RelaysSelected = 2 ' 2
            If Channels.SelectedIndex = 3 Then frm.RelaysSelected = 4 ' 4
            If Channels.SelectedIndex = 4 Then frm.RelaysSelected = 8 ' 8
            If Channels.SelectedIndex = 5 Then frm.RelaysSelected = 16 ' 16
            If Channels.SelectedIndex = 6 Then frm.RelaysSelected = 24 ' 24
            If Channels.SelectedIndex = 7 Then frm.RelaysSelected = 32 ' 32
            If Channels.SelectedIndex = 8 Then frm.RelaysSelected = 48 ' 48
            If Channels.SelectedIndex = 9 Then frm.RelaysSelected = 56 ' 56
            If Channels.SelectedIndex = 10 Then frm.RelaysSelected = 64 ' 64        
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If

        If TestApplication.SelectedItem = "4 Or 8-Channel Pro Series" Then
            Dim frm As New frmR8xR4x_Quality_V2
            frm.NCDComponent1 = NcdController1
            If Channels.SelectedIndex = 0 Then frm.RelaysSelected = 4 ' 0
            If Channels.SelectedIndex = 1 Then frm.RelaysSelected = 1 ' 1
            If Channels.SelectedIndex = 2 Then frm.RelaysSelected = 2 ' 2
            If Channels.SelectedIndex = 3 Then frm.RelaysSelected = 4 ' 4
            If Channels.SelectedIndex = 4 Then frm.RelaysSelected = 8 ' 8     
            frm.ShowDialog()
            LaunchTestApplication = frm.TestResult
        End If



    End Function


    ''' <summary>
    ''' Fill form with Admininformation loaded
    ''' </summary>
    Private Sub FillAdminInfo()
        adminInfo.Load()
        txtFirmware.Text = adminInfo.FirmwarePath
        txtProgrammer.Text = adminInfo.ProgrammerPath
        If adminInfo.ComPorts IsNot Nothing Then
            For Each item In adminInfo.ComPorts
                ExcludedUSBPorts.Items.Add(item.PortName, item.Selected)
            Next
        End If
        If adminInfo.AtmelICE IsNot Nothing Then
            For Each item In adminInfo.AtmelICE
                AtmelICESerialNumbers.Items.Add(item)
            Next
        End If
    End Sub
    Private mSerialPortInfos() As NCDEnterprise.SerialDeviceInfo

    Private Sub BusScan_Click(sender As Object, e As EventArgs) Handles BusScan.Click
        '  BusScan.Enabled = False
        '  Dim Result() As Byte
        '  Result = NCDLib.I2CBasic.Scan(NCDComponent1)
        '  If Result IsNot Nothing Then
        '      I2CList.Items.Clear()
        '      For Each Item In Result
        '          I2CList.Items.Add("  &H" + NCDLib.Math.DecToHexString(Item))
        '      Next
        '  End If
        '  BusScan.Enabled = True
    End Sub

    Private Sub ClearList_Click(sender As Object, e As EventArgs) Handles ClearList.Click
        I2CList.Items.Clear()
    End Sub
    Private Sub TestCOM_Click(sender As Object, e As EventArgs) Handles Testing.Click
        BuildCOMList()
    End Sub
    Private Sub TestList_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles TestList.CellClick

        Dim Item As Integer = e.RowIndex

        If e.ColumnIndex = 1 Then
            Debug.Print(Mid(GetCellData(1, e.RowIndex), 1, 3))
            If Mid(GetCellData(1, e.RowIndex), 1, 3) = "COM" Then
                Dim Port As String = GetCellData(1, e.RowIndex)
                ' Dim Item As E.RowIndex
                Dim Result As String
                Result = LaunchTestApplication(Port)
                TestList(0, Item).Selected = False
                If Result <> "" Then
                    TestList(2, Item).Value = Result 'frm.TestResult
                End If
                ' If frm.TestResult = "Pass" Then
                If Result = "Pass" Then
                    ' Debug.Print(frm.TestResult)
                    TestList(0, Item).Value = 0
                End If
                ' check frm return status
                NcdController1.ClosePort()

            End If
        End If
    End Sub

    Dim img As Bitmap


    Private Sub TextEntry_TextChanged(sender As Object, e As EventArgs) Handles TextEntry.TextChanged

    End Sub

    Private Sub PrintDocument1_PrintPage(sender As Object, e As PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim g As Graphics = e.Graphics
        Dim Brush As SolidBrush = New SolidBrush(Color.Black)
        g.DrawImage(img, 0, 0)
    End Sub
    Private Sub Print_Click(sender As Object, e As EventArgs) Handles Print.Click

        img = New Bitmap(900, 600)
        '     img.SetResolution(300, 300)
        img.SetResolution(400, 400)
        Dim g As Graphics = Graphics.FromImage(img)
        g.DrawString(TextEntry.Text, TextEntry.Font, New SolidBrush(Color.Black), New PointF(5, 20))

        Dim pkCustomSize1 As PaperSize = New PaperSize("First custom size", 150, 100)
        PrintDocument1.PrinterSettings.DefaultPageSettings.PaperSize = pkCustomSize1
        PrintDocument1.DefaultPageSettings.PaperSize = pkCustomSize1

        PrintDocument1.DefaultPageSettings.Margins.Left = 0
        PrintDocument1.DefaultPageSettings.Margins.Right = 0
        PrintDocument1.DefaultPageSettings.Margins.Top = 0 'was 20
        PrintDocument1.DefaultPageSettings.Margins.Bottom = 0

        PrintDocument1.Print()

    End Sub
    Private Sub Print2_Click(sender As Object, e As EventArgs) Handles Print2.Click
        img = New Bitmap(900, 600)
        '     img.SetResolution(300, 300)
        img.SetResolution(400, 400)
        Dim g As Graphics = Graphics.FromImage(img)
        g.DrawString(TextEntry2.Text, TextEntry2.Font, New SolidBrush(Color.Black), New PointF(10, 20))

        Dim pkCustomSize1 As PaperSize = New PaperSize("First custom size", 150, 100)
        PrintDocument1.PrinterSettings.DefaultPageSettings.PaperSize = pkCustomSize1
        PrintDocument1.DefaultPageSettings.PaperSize = pkCustomSize1

        PrintDocument1.DefaultPageSettings.Margins.Left = 0
        PrintDocument1.DefaultPageSettings.Margins.Right = 0
        PrintDocument1.DefaultPageSettings.Margins.Top = 0 'was 20
        PrintDocument1.DefaultPageSettings.Margins.Bottom = 0

        PrintDocument1.Print()
    End Sub

    Private Sub Print3_Click(sender As Object, e As EventArgs) Handles Print3.Click
        img = New Bitmap(900, 600)
        '     img.SetResolution(300, 300)
        img.SetResolution(400, 400)
        Dim g As Graphics = Graphics.FromImage(img)
        g.DrawString(TextEntry3.Text, TextEntry3.Font, New SolidBrush(Color.Black), New PointF(60, 20))

        Dim pkCustomSize1 As PaperSize = New PaperSize("First custom size", 150, 100)
        PrintDocument1.PrinterSettings.DefaultPageSettings.PaperSize = pkCustomSize1
        PrintDocument1.DefaultPageSettings.PaperSize = pkCustomSize1

        PrintDocument1.DefaultPageSettings.Margins.Left = 0
        PrintDocument1.DefaultPageSettings.Margins.Right = 0
        PrintDocument1.DefaultPageSettings.Margins.Top = 0 'was 20
        PrintDocument1.DefaultPageSettings.Margins.Bottom = 0

        PrintDocument1.Print()
    End Sub

    Private Sub Print4_Click(sender As Object, e As EventArgs) Handles Print4.Click
        img = New Bitmap(900, 600)
        '     img.SetResolution(300, 300)
        img.SetResolution(400, 400)
        Dim g As Graphics = Graphics.FromImage(img)
        g.DrawString(TextEntry4.Text, TextEntry4.Font, New SolidBrush(Color.Black), New PointF(0, 10))

        Dim pkCustomSize1 As PaperSize = New PaperSize("First custom size", 150, 100)
        PrintDocument1.PrinterSettings.DefaultPageSettings.PaperSize = pkCustomSize1
        PrintDocument1.DefaultPageSettings.PaperSize = pkCustomSize1

        PrintDocument1.DefaultPageSettings.Margins.Left = 0
        PrintDocument1.DefaultPageSettings.Margins.Right = 0
        PrintDocument1.DefaultPageSettings.Margins.Top = 0 'was 20
        PrintDocument1.DefaultPageSettings.Margins.Bottom = 0

        PrintDocument1.Print()
    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click, Button17.Click, Button16.Click, Button11.Click, Button6.Click, Button20.Click, button7.Click, button8.Click, button9.Click, button10.Click, Button19.Click, button12.Click, button13.Click, button14.Click, Button18.Click, button15.Click, Print5.Click

        'txtLabel.Text = ((Button)sender).Text

        If sender.text <> "Print" Then
            txtLabel.Text = sender.Text
        End If

        img = New Bitmap(900, 600)
        '     img.SetResolution(300, 300)
        img.SetResolution(400, 400)
        Dim g As Graphics = Graphics.FromImage(img)
        g.DrawString(txtLabel.Text, txtLabel.Font, New SolidBrush(Color.Black), New PointF(0, 20))

        Dim pkCustomSize1 As PaperSize = New PaperSize("First custom size", 150, 100)
        PrintDocument1.PrinterSettings.DefaultPageSettings.PaperSize = pkCustomSize1
        PrintDocument1.DefaultPageSettings.PaperSize = pkCustomSize1

        PrintDocument1.DefaultPageSettings.Margins.Left = 0
        PrintDocument1.DefaultPageSettings.Margins.Right = 0
        PrintDocument1.DefaultPageSettings.Margins.Top = 0 'was 20
        PrintDocument1.DefaultPageSettings.Margins.Bottom = 0

        PrintDocument1.Print()

    End Sub

    Private Sub Print5_Click(sender As Object, e As EventArgs) Handles Print5.Click

    End Sub

    Private Sub ConfigS3BSensors_Click(sender As Object, e As EventArgs) Handles ConfigS3BSensors.Click

        Dim Port As String = "COM182"

        NcdController1.UsingComPort = True
        NcdController1.PortName = Port
        NcdController1.BaudRate = 9600
        NcdController1.OpenPort()

        Dim ATBytes As New ArrayList
        ATBytes.Add(&HAB)
        ATBytes.Add(&HCD)

        Dim APIBytes(1) As Byte
        APIBytes(0) = &HAB
        APIBytes(1) = &HCD

        Debug.Print("Get DL:")
        'Demo Reads Values from S3B Module Using API Commands (Validated)
        Dim Result As NCDLib.Wireless.S3B_API.Command.APIReturnValue = NCDLib.Wireless.S3B_API.Command.GetAPICommand(NcdController1, "DL")
        If Result IsNot Nothing Then
            If Result.Success = True Then
                If Result.Values IsNot Nothing Then
                    For Each Temp As Integer In Result.Values
                        Debug.Print(Temp.ToString)
                    Next
                End If
            End If
        End If
        '    NcdController1.Sleep(100)
        Debug.Print("Get SH:")
        Debug.Print(NCDLib.Wireless.S3B_API.Command.GotoAPIMode(NcdController1, False).ToString)

        Debug.Print("AT Mode:")
        Debug.Print(NCDLib.Wireless.S3B_API.Command.GotoATMode(NcdController1, False).ToString)

        '//////////////////////////////////////////////////////////////////////////////////////////////
        '//                       AT Commands for S3B Modules - VALIDATED                            //
        '//////////////////////////////////////////////////////////////////////////////////////////////
        ''Demo Sends Command to S3B Module Using AT Commands (Validated)
        'If NCDLib.Wireless.S3B_API.Command.PutATCommand(NcdController1, "DL", ATBytes) = True Then
        '    Debug.Print("Success")
        'Else
        '    Debug.Print("Failed")
        'End If
        ''Demo Reads Values from S3B Module Using AT Commands (Validated)
        'Dim Result As NCDLib.Wireless.S3B_API.Command.ATReturnValue = NCDLib.Wireless.S3B_API.Command.GetATCommand(NcdController1, "DL")
        'If Result IsNot Nothing Then
        '    If Result.Success = True Then
        '        If Result.Values IsNot Nothing Then
        '            For Each Temp As Integer In Result.Values
        '                Debug.Print(Temp.ToString)
        '            Next
        '        End If
        '    End If
        'End If
        '//////////////////////////////////////////////////////////////////////////////////////////////
        '//                      API Commands for S3B Modules - IN DEVELOPMENT                       //
        '//////////////////////////////////////////////////////////////////////////////////////////////
        ''Demo Sends Command to S3B Module Using AT Commands (Validated)
        'If NCDLib.Wireless.S3B_API.Command.PutAPICommand(NcdController1, "DL", APIBytes) = True Then
        '    Debug.Print("Success")
        'Else
        '    Debug.Print("Failed")
        'End If
        'Demo Reads Values from S3B Module Using API Commands (Validated)
        'Dim Result As NCDLib.Wireless.S3B_API.Command.APIReturnValue = NCDLib.Wireless.S3B_API.Command.GetAPICommand(NcdController1, "DL")
        'If Result IsNot Nothing Then
        '    If Result.Success = True Then
        '        If Result.Values IsNot Nothing Then
        '            For Each Temp As Integer In Result.Values
        '                Debug.Print(Temp.ToString)
        '            Next
        '        End If
        '    End If
        'End If





        '    Dim RSSI As Integer = NCDLib.Wireless.S3B_API.Modem.GetRSSI(NCDComponent1)




        ' NCDLib.Wireless.S3B_API.Command.PutATCommand(NcdController1, "PL", &H7A)


        '  Dim Result As Integer = NCDLib.Wireless.S3B_API.Modem.GetPanID(NcdController1)
        '
        '  Dim Result2 As Byte() = NCDLib.Wireless.S3B_API.Modem.GetDestinationLow(NcdController1)
        '
        '  Debug.Print(Result.ToString)
        '
        '  If Result2 IsNot Nothing Then
        '      Debug.Print(Result2(0).ToString)
        '      Debug.Print(Result2(1).ToString)
        '      Debug.Print(Result2(2).ToString)
        '      Debug.Print(Result2(3).ToString)
        '  End If
        '
        '  'NCDLib.Wireless.S3B_API.Modem.SetPanID(NcdController1, SetPanID.Value)
        '  'NCDLib.Wireless.S3B_API.Modem.ApplyCommand(NcdController1)

        NcdController1.ClosePort()

    End Sub
    Private Sub button15_Click(sender As Object, e As EventArgs) Handles button15.Click

    End Sub
End Class
