﻿Public Class frmType53_CO2PMSensor
    Private Sub frmType53_CO2PMSensor_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Text = "Type 53 CO2 Temperature Humidity Particulate Matter Sensor - Address: " + SensorAddress
        Timer1.Interval = 10
        Timer1.Start()
    End Sub
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public SensorAddress As String
    Public Shared DataFrame As New NCDLib.Wireless.S3B_API.SensorData
    Public Shared Type53 As New NCDLib.Wireless.S3B_API.SensorData.TypeData.Type53

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Timer1.Enabled = False  ' disable timer1
        BackgroundWorker1.RunWorkerAsync()
        Return
    End Sub
    Private Sub frmClose(sender As Object, e As EventArgs) Handles MyBase.Closed
        Timer1.Stop()
        BackgroundWorker1.CancelAsync()
        While BackgroundWorker1.IsBusy
            Application.DoEvents()
            Timer1.Stop()
        End While
    End Sub
    Private Sub BackgroundWorker1_DoWork(sender As Object, e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        'Receive Data from Wireless Sensor
        If BackgroundWorker1.CancellationPending = True Then Exit Sub
        Debug.Print("----------------------------------------------------------------------------------------------------------------------------Sensor Type DoWork Loop Start ------------ ")
        DataFrame = NCDLib.Wireless.S3B_API.SensorDataCapture(NCDComponent1, SensorAddress)
        Debug.Print(" ------------ DoWork Loop  Stop")
    End Sub
    Private Sub BackgroundWorker1_RunWorkerCompleted(sender As Object, e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        Debug.Print("----------------------------------------------------------------------------------------------------------------------------Sensor Worker Finished ------------ ")
        'Parse Data
        If (DataFrame.Valid) Then
            Waiting.Visible = False
            BatteryLevel.Value = DataFrame.BatteryInt   'Show Battery Progress Bar
            Battery.Text = DataFrame.Battery            'Show Battery Voltage in Text Box
            NODEID.Text = DataFrame.NodeID              'Show Device Node ID Data
            Address.Text = SensorAddress                'Show Sensor Address
            Counter.Text = DataFrame.Counter.ToString   'Show Transmission Cycle Counter
            SensorType.Text = DataFrame.SensorType.ToString 'Show Sensor Type
            SensorInfo.Text = DataFrame.Description     'Show Sensor Description
            Firmware.Text = DataFrame.Firmware          'Show Firmware Version
            Summary.Text = DataFrame.SensorReadings     'Show a Summary View of All Sensor Data

            CompleteFrame.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompleteFrame)
            CompletePayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompletePayload)
            SensorPayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.SensorPayload)

            CO2.Text = Type53.CO2
            Humidity.Text = Type53.Humidity
            Celsius.Text = Type53.Celsius
            Fahrenheit.Text = Type53.Fahrenheit

            MC_PM1_0.Text = Type53.MassConcentration_PM1_0
            MC_PM2_5.Text = Type53.MassConcentration_PM2_5
            MC_PM4_0.Text = Type53.MassConcentration_PM4_0
            MC_PM10_0.Text = Type53.MassConcentration_PM10_0

            NC_PM0_5.Text = Type53.NumberConcentration_PM0_5
            NC_PM1_0.Text = Type53.NumberConcentration_PM1_0
            NC_PM2_5.Text = Type53.NumberConcentration_PM2_5
            NC_PM4_0.Text = Type53.NumberConcentration_PM4_0
            NC_PM10_0.Text = Type53.NumberConcentration_PM10_0

            TypicalParticleSize.Text = Type53.TypicalParticleSize
        End If
        Timer1.Enabled = True
    End Sub
End Class