﻿Public Class frmType62_Configuration
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public SensorAddress As String
    Public SensorAddressArray(7) As Byte
    Public SensorType As Integer
    Public Shared DataFrame As New NCDLib.Wireless.S3B_API.SensorData
    Public FormLoading As Boolean = True
    Public LastKnownDestinationAddress(7) As Byte

    Public ElementChanged As Boolean = False

    Public SensorNodeID As Byte
    Public EncryptionChanged As Boolean = False
    Public Bypass As Boolean = False
    Private Sub frmType62_Configuration_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        If Bypass = False Then
            Timer1.Interval = 3000
            Timer1.Start()
        Else
            Waiting.Text = "Connected: " + SensorAddress
            Waiting3.Visible = False
            Waiting2.Visible = False
            ConfigSettings.Visible = True
            ReadConfig()
        End If

        SensorAddressArray = NCDLib.Math.ConvertStringAddressToArray(SensorAddress)
        FormLoading = False
    End Sub
    Private Sub frmfrmSensorConfiguration_Load(sender As Object, e As EventArgs) Handles MyBase.Closed

        Timer1.Stop()

    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        'Receive Data from Wireless Sensor

        Debug.Print("Waiting for Sensor Packet.................................")

        DataFrame = NCDLib.Wireless.S3B_API.SensorDataCapture(NCDComponent1, "None")



        'Parse Data
        If (DataFrame.Valid) Then
            Debug.Print("................................. VALID FRAME DETECTED")

            ' Dim TestAddr(7) As Byte
            ' TestAddr = NCDLib.Math.ConvertStringAddressToArray(SensorAddress)

            ' TestAddr(0) = NCDLib.Math.HexStringToDec(Mid(SensorAddress, 1, 2))
            ' TestAddr(1) = NCDLib.Math.HexStringToDec(Mid(SensorAddress, 3, 2))
            ' TestAddr(2) = NCDLib.Math.HexStringToDec(Mid(SensorAddress, 5, 2))
            ' TestAddr(3) = NCDLib.Math.HexStringToDec(Mid(SensorAddress, 7, 2))
            ' TestAddr(4) = NCDLib.Math.HexStringToDec(Mid(SensorAddress, 10, 2))
            ' TestAddr(5) = NCDLib.Math.HexStringToDec(Mid(SensorAddress, 12, 2))
            ' TestAddr(6) = NCDLib.Math.HexStringToDec(Mid(SensorAddress, 14, 2))
            ' TestAddr(7) = NCDLib.Math.HexStringToDec(Mid(SensorAddress, 16, 2))

            For i = 0 To 7
                'Debug.Print(TestAddr(i).ToString + "=" + addr1(i).ToString)
                If SensorAddressArray(i) <> DataFrame.CompleteFrame(i + 4) Then
                    Debug.Print("................................. FRAME DID NOT MATCH CONFIGURATION ADDRESS")
                    DataFrame.Valid = False
                End If
            Next

            If DataFrame.Valid = True Then
                Debug.Print("................................. FRAME CONFIGURATION PASSED")
                Debug.Print(DataFrame.CompleteFrame(22).ToString)
                Debug.Print(DataFrame.CompleteFrame(23).ToString)
                Debug.Print(DataFrame.CompleteFrame(24).ToString)

                If DataFrame.CompleteFrame(22) = 80 Then
                    If DataFrame.CompleteFrame(23) = 71 Then
                        If DataFrame.CompleteFrame(24) = 77 Then
                            Waiting.Text = "Connected: " + SensorAddress
                            Waiting3.Visible = False
                            Waiting2.Visible = False
                            ConfigSettings.Visible = True
                            Timer1.Stop()
                            ReadConfig()
                        End If
                    End If
                End If
            Else
                Waiting.Text = "Incorrect Sensor...Try Again..."
            End If

        End If
    End Sub

    Private Sub ReadConfiguration(sender As Object, e As EventArgs) Handles ReadSensorConfig.Click

        ReadConfig()

    End Sub
    Public Sub ReadConfig()
        ResetNotice.Visible = False
        Errors.Visible = False
        ReadSensorConfig.Enabled = False
        Dim ErrorFlag As Integer = 0
        Dim RetryCounter As Integer = 0
        Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData

SetPanIDValue:
        Try
            If RetryCounter < 5 Then
                'Read PanID from Controller
                If PanID.Visible = False Then
                    Help.Text = "Reading PanID"
                    Response = NCDLib.Wireless.S3B_API.SensorConfiguration.GetPanID(NCDComponent1, SensorAddressArray, 3)
                    If (Response.Valid) Then
                        PanID.Visible = True
                        SetPanID.Value = Response.PanID
                        If SetPanID.Value = 0 Then
                            SetPanID.Value = 1
                        End If
                        Me.Refresh()
                    End If
                End If
            Else
                ErrorFlag = ErrorFlag + 1
                SetPanID.Value = &H7FFF
            End If
        Catch
            RetryCounter = RetryCounter + 1
            GoTo SetPanIDValue
        End Try
        RetryCounter = 0

RetriesValue:
        Try
            If RetryCounter < 5 Then
                'Read Retries from Controller
                If Retries.Visible = False Then
                    Help.Text = "Reading Retries"
                    Response = NCDLib.Wireless.S3B_API.SensorConfiguration.GetRetries(NCDComponent1, SensorAddressArray, 3)
                    If (Response.Valid) Then
                        Retries.Visible = True
                        SetRetries.Value = Response.Retries
                        Me.Refresh()
                    End If
                End If
            Else
                ErrorFlag = ErrorFlag + 2
                SetRetries.Value = 10
            End If
        Catch
            RetryCounter = RetryCounter + 1
            GoTo RetriesValue
        End Try
        RetryCounter = 0

RetryDelayValue:
        Try
            If RetryCounter < 5 Then
                'Read Delay from Controller
                If Delay.Visible = False Then
                    Help.Text = "Reading Delay"
                    Response = NCDLib.Wireless.S3B_API.SensorConfiguration.GetDelay(NCDComponent1, SensorAddressArray, 3)
                    If (Response.Valid) Then
                        Delay.Visible = True
                        SetDelay.Value = Response.Delay
                        SetNodeID.Value = Response.NodeID
                        SensorNodeID = SetNodeID.Value
                        Me.Refresh()
                    End If
                End If
            Else
                ErrorFlag = ErrorFlag + 4
                SetDelay.Value = 600
            End If
        Catch
            RetryCounter = RetryCounter + 1
            GoTo RetryDelayValue
        End Try

        RetryCounter = 0
RetryPowerLevel:
        Try
            If RetryCounter < 5 Then
                'Read PowerLevel from Controller
                If PowerLevel.Visible = False Then
                    Help.Text = "Reading Transmission Power Level"
                    Response = NCDLib.Wireless.S3B_API.SensorConfiguration.GetPowerLevel(NCDComponent1, SensorAddressArray, 3)
                    If (Response.Valid) Then
                        PowerLevel.Visible = True
                        SetPowerLevel.Value = Response.PowerLevel
                        Me.Refresh()
                    End If
                End If
            Else
                ErrorFlag = ErrorFlag + 8
                SetPowerLevel.Value = 4
            End If
        Catch
            RetryCounter = RetryCounter + 1
            GoTo RetryPowerLevel
        End Try
        RetryCounter = 0


        '-------------------------------------------------------------------------------------------------------------------------------
        '---------  ADVANCED CONFIGURATION READ ----------------------------------------------------------------------------------------
        '-------------------------------------------------------------------------------------------------------------------------------
        '       RetryRollValue:
        '               Try
        '                   If RetryCounter < 5 Then
        '                       'Read Roll from Controller
        '                       If TemperatureCompensation.Visible = False Then
        '                           Help.Text = "Reading Roll"
        '                           'TYPE 61 MIGRATION REQUIRED
        '                           Response = NCDLib.Wireless.S3B_API.SensorConfiguration.Type47.GetRoll(NCDComponent1, SensorAddressArray, 3)
        '                           If (Response.Valid) Then
        '                               TemperatureCompensation.Visible = True
        '                               'TYPE 61 MIGRATION REQUIRED RollValue.Value = Response.Roll
        '                               Me.Refresh()
        '                           End If
        '                       End If
        '                   Else
        '                       ErrorFlag = ErrorFlag + 16
        '                       'TYPE 61 MIGRATION REQUIRED RollValue.Value = 10
        '                   End If
        '               Catch
        '                   RetryCounter = RetryCounter + 1
        '                   GoTo RetryRollValue
        '               End Try
        '               RetryCounter = 0
        '       
        '       RetryPitchValue:
        '               Try
        '                   If RetryCounter < 5 Then
        '                       'Read Pitch from Controller
        '                       If Pitch.Visible = False Then
        '                           Help.Text = "Reading Pitch"
        '                           'TYPE 61 MIGRATION REQUIRED
        '                           Response = NCDLib.Wireless.S3B_API.SensorConfiguration.Type47.GetPitch(NCDComponent1, SensorAddressArray, 3)
        '                           If (Response.Valid) Then
        '                               Pitch.Visible = True
        '                               LiquidValue.Value = Response.Pitch
        '                               Me.Refresh()
        '                           End If
        '                       End If
        '                   Else
        '                       ErrorFlag = ErrorFlag + 32
        '                       LiquidValue.Value = 10
        '                   End If
        '               Catch
        '                   RetryCounter = RetryCounter + 1
        '                   GoTo RetryPitchValue
        '               End Try
        '               RetryCounter = 0
        '-------------------------------------------------------------------------------------------------------------------------------
        '---------  ADVANCED CONFIGURATION END -----------------------------------------------------------------------------------------
        '-------------------------------------------------------------------------------------------------------------------------------



        If ErrorFlag <> 0 Then
            Errors.Visible = True
            Errors.Text = ("Some Settings have Changed to Default Due to Read Errors: " + Errors.ToString)
        End If

        'Read Destination Address from Controller
        If Destination.Visible = False Then
            Help.Text = "Reading Destination Address"
            System.Threading.Thread.Sleep(200)
            Response = NCDLib.Wireless.S3B_API.SensorConfiguration.GetDestinationAddress(NCDComponent1, SensorAddressArray, 3)
            If (Response.Valid) Then
                Destination.Visible = True
                AD1.Value = Response.DestinationAddress(0)
                AD2.Value = Response.DestinationAddress(1)
                AD3.Value = Response.DestinationAddress(2)
                AD4.Value = Response.DestinationAddress(3)
                AD5.Value = Response.DestinationAddress(4)
                AD6.Value = Response.DestinationAddress(5)
                AD7.Value = Response.DestinationAddress(6)
                AD8.Value = Response.DestinationAddress(7)

                LastKnownDestinationAddress(0) = Response.DestinationAddress(0)
                LastKnownDestinationAddress(1) = Response.DestinationAddress(1)
                LastKnownDestinationAddress(2) = Response.DestinationAddress(2)
                LastKnownDestinationAddress(3) = Response.DestinationAddress(3)
                LastKnownDestinationAddress(4) = Response.DestinationAddress(4)
                LastKnownDestinationAddress(5) = Response.DestinationAddress(5)
                LastKnownDestinationAddress(6) = Response.DestinationAddress(6)
                LastKnownDestinationAddress(7) = Response.DestinationAddress(7)

                If AD1.Value = 0 Then
                    If AD2.Value = 0 Then
                        If AD3.Value = 255 Then
                            If AD4.Value = 255 Then
                                If AD5.Value = 0 Then
                                    If AD6.Value = 0 Then
                                        If AD7.Value = 0 Then
                                            If AD8.Value = 0 Then
                                                Broadcast.Checked = True
                                                Me.Refresh()
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If

                NodeID.Visible = True
                SetNodeID.Value = SensorNodeID
                WriteConfiguration.Visible = True
                EncryptionGroup.Visible = True
                Help.Text = "Read Successfully Completed"
            End If
        End If

        If PanID.Visible = True Then
            If Delay.Visible = True Then
                If Destination.Visible = True Then
                    If PowerLevel.Visible = True Then
                        If Retries.Visible = True Then
                            Help.Text = "Read Successfully Completed"
                            WriteConfiguration.Visible = True

                        End If
                    End If
                End If
            End If
        End If

        ReadSensorConfig.Enabled = True

    End Sub

    Private Sub Broadcast_CheckedChanged(sender As Object, e As EventArgs) Handles Broadcast.CheckedChanged
        If FormLoading = True Then Exit Sub

        If Broadcast.Checked = True Then
            AD1.Enabled = False : AD1.Value = 0
            AD2.Enabled = False : AD2.Value = 0
            AD3.Enabled = False : AD3.Value = 255
            AD4.Enabled = False : AD4.Value = 255
            AD5.Enabled = False : AD5.Value = 0
            AD6.Enabled = False : AD6.Value = 0
            AD7.Enabled = False : AD7.Value = 0
            AD8.Enabled = False : AD8.Value = 0
        Else
            AD1.Value = 0
            AD2.Value = &H13
            AD3.Value = &HA2
            AD4.Value = 0
            AD5.Value = LastKnownDestinationAddress(4) : AD5.Enabled = True
            AD6.Value = LastKnownDestinationAddress(5) : AD6.Enabled = True
            AD7.Value = LastKnownDestinationAddress(6) : AD7.Enabled = True
            AD8.Value = LastKnownDestinationAddress(7) : AD8.Enabled = True
        End If
    End Sub
    Private Sub EncryptionKey_TextChanged(sender As Object, e As EventArgs) Handles EncryptionKey.TextChanged

        EncryptionChanged = True
        UIRules()

    End Sub
    Public Sub UIRules()

        Dim EntryError As Boolean = False
        Dim Test As Integer

        For I = 1 To EncryptionKey.TextLength
            Test = Asc(Mid(EncryptionKey.Text, I, 1))
            If Test < 48 Then EntryError = True
            If Test > 57 And Test < 65 Then EntryError = True
            If Test > 70 And Test < 97 Then EntryError = True
            If Test > 102 Then EntryError = True
        Next

        If EncryptionKey.TextLength <> 32 And EncryptionKey.TextLength <> 0 Then
            Help.Text = "Store Disabled: Encryption Key Requires 32 HEX Characters."
            EncryptionKey.ForeColor = Color.Red
            EntryError = True
        Else
            '  If EncryptionKey.TextLength < 4 Then
            '  ErrorCode.Text = "Store Disabled: Minimum Length of Encryption Key is 4 HEX Characters."
            '  EncryptionKey.ForeColor = Color.Red
            '  EntryError = True
            '  Else
            If EntryError = True Then
                Help.Text = "Store Disabled: Valid Hex Characters Range from 0-9 and A-F ONLY."
                EncryptionKey.ForeColor = Color.Red
            End If
            ' End If
        End If

        If SetPanID.Value = 31693 Or SetPanID.Value = 0 Then
            If EntryError = False Then
                EntryError = True
                Help.Text = "Invalid PAN ID Selected."
            End If
        End If

        If EntryError = True Then
            WriteConfiguration.Enabled = False
        Else
            EncryptionKey.ForeColor = Color.Blue
            WriteConfiguration.Enabled = True
            Help.Text = ""
        End If

    End Sub
    Private Sub SetPanID_ValueChanged(sender As Object, e As EventArgs) Handles SetPanID.ValueChanged
        UIRules()
    End Sub

    Private Sub WriteConfiguration_Click(sender As Object, e As EventArgs) Handles WriteConfiguration.Click

        Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData

        If PanID.Visible = True Then
            Help.Text = "Writing PanID"
            Response = NCDLib.Wireless.S3B_API.SensorConfiguration.SetPanID(NCDComponent1, SensorAddressArray, 3, SetPanID.Value)
            If (Response.Valid) Then
                PanID.Visible = False
                Me.Refresh()
            End If
        End If

        If Retries.Visible = True Then
            Help.Text = "Writing Retries"
            Response = NCDLib.Wireless.S3B_API.SensorConfiguration.SetRetries(NCDComponent1, SensorAddressArray, 3, SetRetries.Value)
            If (Response.Valid) Then
                Retries.Visible = False
                Me.Refresh()
            End If
        End If

        If Broadcast.Checked = False Then
            If Destination.Visible = True Then
                Help.Text = "Writing Destination Address"
                Dim NewDestinationAddress(7) As Byte
                NewDestinationAddress(0) = AD1.Value
                NewDestinationAddress(1) = AD2.Value
                NewDestinationAddress(2) = AD3.Value
                NewDestinationAddress(3) = AD4.Value
                NewDestinationAddress(4) = AD5.Value
                NewDestinationAddress(5) = AD6.Value
                NewDestinationAddress(6) = AD7.Value
                NewDestinationAddress(7) = AD8.Value
                Response = NCDLib.Wireless.S3B_API.SensorConfiguration.SetDestinationAddress(NCDComponent1, SensorAddressArray, 3, NewDestinationAddress)
                If (Response.Valid) Then
                    Destination.Visible = False
                    Me.Refresh()
                End If
            End If
        Else
            Help.Text = "Set to Broadcast Mode"
            Response = NCDLib.Wireless.S3B_API.SensorConfiguration.SetBroadcastMode(NCDComponent1, SensorAddressArray, 3)
            If (Response.Valid) Then
                Destination.Visible = False
                Me.Refresh()
            End If
        End If

        If Delay.Visible = True Then
            Help.Text = "Writing Delay"
            Response = NCDLib.Wireless.S3B_API.SensorConfiguration.SetDelay(NCDComponent1, SensorAddressArray, 3, SetDelay.Value, SetNodeID.Value)
            If (Response.Valid) Then
                Delay.Visible = False
                NodeID.Visible = False
                Me.Refresh()
            End If
        End If

        If PowerLevel.Visible = True Then
            Help.Text = "Writing Power Level"
            Response = NCDLib.Wireless.S3B_API.SensorConfiguration.SetPowerLevel(NCDComponent1, SensorAddressArray, 3, SetPowerLevel.Value)
            If (Response.Valid) Then
                PowerLevel.Visible = False
                Me.Refresh()
            End If
        End If


        '  '-------------------------------------------------------------------------------------------------------------------------------
        '  '---------  ADVANCED CONFIGURATION WRITE ---------------------------------------------------------------------------------------
        '  '-------------------------------------------------------------------------------------------------------------------------------
        '  'TYPE 61 MIGRATION REQUIRED
        '  If RollValue.Visible = True Then
        '      Help.Text = "Writing Roll Angle"
        '      Response = NCDLib.Wireless.S3B_API.SensorConfiguration.Type47.SetRoll(NCDComponent1, SensorAddressArray, 3, RollValue.Value)
        '      If (Response.Valid) Then
        '          Roll.Visible = False
        '          Me.Refresh()
        '      End If
        '  End If
        '
        '  'TYPE 61 MIGRATION REQUIRED
        '  If PitchValue.Visible = True Then
        '      Help.Text = "Writing Pitch Angle"
        '      Response = NCDLib.Wireless.S3B_API.SensorConfiguration.Type47.SetPitch(NCDComponent1, SensorAddressArray, 3, PitchValue.Value)
        '      If (Response.Valid) Then
        '          Pitch.Visible = False
        '          Me.Refresh()
        '      End If
        '  End If
        '
        '  '-------------------------------------------------------------------------------------------------------------------------------
        '  '---------  ADVANCED CONFIGURATION WRITE END -----------------------------------------------------------------------------------
        '  '-------------------------------------------------------------------------------------------------------------------------------

        If EncryptionChanged = True Then

            Dim NewKey As String
            If EncryptionKey.TextLength > 0 Then

                If (EncryptionKey.TextLength And 1) = 1 Then
                    NewKey = "0" + EncryptionKey.Text
                Else
                    NewKey = EncryptionKey.Text
                End If
                EncryptionKey.Text = NewKey
                Dim Key((EncryptionKey.TextLength / 2) - 1) As Byte
                Dim KeyIndex As Integer = 0
                Dim KeyValue As Integer
                Key(0) = EncryptionKey.TextLength / 2

                For Temp2 As Integer = 1 To EncryptionKey.TextLength Step 2
                    KeyValue = ASCIIHexToHex(Mid(EncryptionKey.Text, Temp2, 2))
                    Key(KeyIndex) = KeyValue
                    KeyIndex = KeyIndex + 1
                Next


                If EncryptionGroup.Visible = True Then
                    Help.Text = "Writing Encryption Key"
                    Response = NCDLib.Wireless.S3B_API.SensorConfiguration.SetEncryptionKey(NCDComponent1, SensorAddressArray, 3, Key)
                    If (Response.Valid) Then
                        Help.Text = "New Encryption Key Stored"
                        EncryptionGroup.Visible = False
                        Me.Refresh()
                    End If
                End If
            End If



            EncryptionGroup.Visible = False


            'Debug.Print("Encryption Debug...Length")
            'Debug.Print(Key.Length.ToString)
            'Debug.Print("Encryption Debug...Data")
            'For Temp = 0 To Key.Length - 1
            '    Debug.Print(Temp.ToString + " " + Key(Temp).ToString)
            'Next
            'Debug.Print("End Encryption Debug...")
        Else
            EncryptionGroup.Visible = False
        End If

        If PanID.Visible = False Then
            If Delay.Visible = False Then
                If Destination.Visible = False Then
                    If PowerLevel.Visible = False Then
                        If Retries.Visible = False Then
                            Help.Text = ""
                            WriteConfiguration.Visible = False
                            ResetNotice.Visible = True
                        End If
                    End If
                End If
            End If
        End If

    End Sub

    Public Function ASCIIHexToHex(ASCII As String)
        'Debug.Print("Converting ASCII Hex Pair to Hex Value: " + ASCII)
        ASCIIHexToHex = 0
        'This function Converts 2 ASCII Characters to a HEX Value
        If ASCII.Length <> 2 Then
            Debug.Print("Conversion Error: ASCII Must be 2 Characters Wide")
            Return 0
        End If

        Dim ASC_MSB As Integer = Asc(Mid(ASCII, 1, 1))
        Dim ASC_LSB As Integer = Asc(Mid(ASCII, 2, 1))

        'Debug.Print("ASC_MSB: " + ASC_MSB.ToString)
        'Debug.Print("ASC_LSB: " + ASC_LSB.ToString)

        Dim MSB As Integer = ASC2Hex(ASC_MSB)
        Dim LSB As Integer = ASC2Hex(ASC_LSB)

        'Debug.Print(MSB.ToString)
        'Debug.Print(LSB.ToString)

        ASCIIHexToHex = (MSB * 16) + LSB

        Return ASCIIHexToHex
    End Function
    Public Function ASC2Hex(Hex As Integer)
        'This Function Converts a Hex value in ASCII format to a Decimal Value
        If Hex > 47 And Hex < 58 Then
            Hex = Hex - 48
            Return Hex
        End If
        If Hex > 64 And Hex < 71 Then
            Hex = Hex - 55
            Return Hex
        End If
        If Hex > 96 And Hex < 103 Then
            Hex = Hex - 87
            Return Hex
        End If
        Return 0
    End Function

    Private Sub ReadForced_Click(sender As Object, e As EventArgs) Handles ReadForced.Click
        PanID.Visible = False
        NodeID.Visible = False
        Destination.Visible = False
        Retries.Visible = False
        PowerLevel.Visible = False
        Delay.Visible = False
        '-------------------------------------------------------------------------------------------------------------------------------
        '---------  ADVANCED CONFIGURATION READ ----------------------------------------------------------------------------------------
        '-------------------------------------------------------------------------------------------------------------------------------
        '   TemperatureCompensation.Visible = False
        '   Pitch.Visible = False
        '-------------------------------------------------------------------------------------------------------------------------------
        '---------  ADVANCED CONFIGURATION READ END ------------------------------------------------------------------------------------
        '-------------------------------------------------------------------------------------------------------------------------------


        ReadConfig()
    End Sub


    Private Sub StoreORPCalibrationValue_Click(sender As Object, e As EventArgs) Handles StoreORPCalibrationValue.Click
        Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
        Help.Text = "Writing ORP Calibration Value"
        Response = NCDLib.Wireless.S3B_API.SensorConfiguration.Type62.SetORPCalibration(NCDComponent1, SensorAddressArray, 3, ORPCalibration.Value)
        If (Response.Valid) Then
            Debug.Print("Response Received: Writing ORP Calibration Value")
            'Roll.Visible = False
            Me.Refresh()
        End If
    End Sub
End Class