﻿Imports System.IO
Public Class frmSubscriberRelay
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public FormLoading As Boolean = True
    Private Sub frmSubscriberRelay_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' Dim DataBlock(32, 32) As Byte
        'Dim Preload = New Byte() {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16}
        Dim DataBlock(63, 15) As Byte   ' {{Preload}, {Preload}}
        For Line As Integer = 0 To 63
            For Column As Integer = 0 To 15
                Dim Value As Integer = (Line * 16) + Column
                DataBlock(Line, Column) = (Value And 255)
                Debug.Print(Value.ToString + "-" + DataBlock(Line, Column).ToString)
            Next
        Next

        For Temp As Integer = 1 To 32
            '  DataTable.Rows.Add()
            '  DataTable2.Rows.Add()
            If Temp < 17 Then
                SubscriberTable.Rows.Add()
                PutSubscriberCell(0, Temp - 1, Temp.ToString)
            End If
            ByteTable.Rows.Add()
        Next Temp

        FillTableB()

        BuildListOfSupportedSensors()

        FormLoading = False

    End Sub

    Public Sub BuildListOfSupportedSensors()
        SupportedSensors.Items.Clear()
        SupportedSensors.Items.Add("Do Not Monitor Any Sensors")
        For SensorType = 1 To 10000
            GetSensorMetaData(SensorType)
            If MetaRecord.Supported = True Then
                SupportedSensors.Items.Add("Type " + SensorType.ToString + " " + MetaRecord.SensorType)
            End If
        Next
    End Sub

    Public Sub PutSubscriberCell(x As Integer, Y As Integer, Dat As String)
        SubscriberTable(x, Y).Value = Dat
    End Sub
    Public Function GetSubscriberCell(x As Integer, Y As Integer) As String
        GetSubscriberCell = SubscriberTable(x, Y).Value
    End Function
    Public Sub PutByteTableCell(x As Integer, Y As Integer, Dat As String)
        ByteTable(x, Y).Value = Dat
    End Sub
    Public Function GetByteTableCell(x As Integer, Y As Integer) As String
        GetByteTableCell = ByteTable(x, Y).Value
    End Function

    Private Sub Upload_Click(sender As Object, e As EventArgs) Handles Upload.Click

    End Sub

    Private Sub Download_Click(sender As Object, e As EventArgs) Handles Download.Click

    End Sub

    Private Sub LoadDataFile_Click(sender As Object, e As EventArgs) Handles LoadDataFile.Click
        Dim OpenFileDialog1 As OpenFileDialog = New OpenFileDialog
        OpenFileDialog1.FileName = "SubscriberData.cfg"
        Dim data As Byte() = Nothing
        If (OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            '         data = LoadFile(OpenFileDialog1.FileName)
            FileProgress.Value = 0
            FileProgress.Visible = True
            Dim Block As Integer
            Dim I(15) As Byte
            Dim saveData As New ArrayList
            Dim id As Integer = 0
            For Block = 1040 To 6800 Step 16
                Array.Copy(data, id, I, 0, 16)
                id = id + 16
                NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, Block, I)
                Debug.Print(Block.ToString)
                FileProgress.Value = Block
            Next Block

            FileProgress.Visible = False
        End If
    End Sub
    Private Sub SaveDataFile_Click(sender As Object, e As EventArgs) Handles SaveDataFile.Click
        FileProgress.Value = 0
        FileProgress.Visible = True

        'Start Address of Data: 1040
        'Ending Address of Data: 6800

        Dim Block As Integer
        Dim I(15) As Byte
        Dim saveData As New ArrayList

        For Block = 1040 To 6800 Step 16
            I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, Block, 16)
            saveData.AddRange(I)
            Debug.Print(Block.ToString)
            FileProgress.Value = Block
        Next Block

        Dim result As Boolean = False
        Dim SaveFileDialog1 As SaveFileDialog = New SaveFileDialog
        SaveFileDialog1.FileName = "SubscriberData.cfg"
        Dim d As Byte = 0
        If (SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            SaveFile(SaveFileDialog1.FileName, saveData.ToArray(d.GetType()))
        End If

        FileProgress.Visible = False
    End Sub
    '' <summary>
    '' Load file from specific path
    '' </summary>
    '' <param name="filename"></param>
    '' <returns>bytes read from file</returns>
    '' <remarks></remarks>
    '' <exception cref="Exception">Corrupt NCD File</exception>
    Public Function LoadFile(ByVal filename As String) As Byte()
        Dim data As Byte() = Nothing
        Try
            Dim sr As BinaryReader = New BinaryReader(File.Open(filename, FileMode.Open))
            Dim version As Integer = sr.ReadInt32()
            Dim length As Integer = sr.ReadInt32()
            data = sr.ReadBytes(length)
            Dim checksum As Integer = sr.ReadInt32()
            If (checksum <> GetCheckSum(data)) Then
                Throw New Exception("Corrupt Data File")
            End If
            sr.Close()
        Catch ex As Exception
            Throw New Exception("Corrupt Data File")
        End Try
        Return data
    End Function

    ''' <summary>
    ''' Save file to specific path
    ''' </summary>
    ''' <param name="filename"></param>
    ''' <param name="data"></param>
    ''' <remarks></remarks>
    Public Sub SaveFile(ByVal filename As String, ByVal data As Byte())
        Try
            Dim sw As BinaryWriter = New BinaryWriter(File.Open(filename, FileMode.Create))
            Dim version As Integer = 1
            Dim length As Integer = data.Length
            Dim i As Integer = 0
            sw.Write(version)
            sw.Write(length)
            sw.Write(data, 0, length)
            Dim chksum As Integer = GetCheckSum(data)
            sw.Write(chksum)
            sw.Flush()
            sw.Close()
        Catch ex As Exception
            Throw New Exception("Write keyfob file failure")
        End Try
    End Sub
    Private Function GetCheckSum(ByVal a As Byte()) As Integer
        Dim i As Integer = 0
        Dim checksum As Integer = 0
        For i = 0 To a.Length - 1
            checksum = checksum + a(i)
        Next
        Return checksum
    End Function

    Private Sub StartAddress2_ValueChanged(sender As Object, e As EventArgs) Handles StartAddress2.ValueChanged
        If FormLoading = False Then
            FillTableB()
        End If
    End Sub

    Public Sub FillTableB()

        Dim I(15) As Byte

        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress2.Value, 16)

        If I IsNot Nothing Then
            For Y As Integer = 0 To 15
                Dim Address As Double = StartAddress2.Value + Y
                Dim Hex_Value As String
                Hex_Value = Hex(Address)
                CellData2(0, Y, Address.ToString + "-" + Hex_Value)
                CellData2(1, Y, Hex(I(Y)).ToString)
                CellData2(2, Y, I(Y).ToString)
                ' CellData2(3, Y, NCDLib.Math.DecToBinaryStringStandard(I(Y)))
                'CellData2(3, Y, NCDLib.Enterprise.ExtendedMemoryMenu(Address))
                CellData2(3, Y, "Edit")
                CellData2(4, Y, NCDLib.ExtendedMemoryMenu.GetDescription(Address))
            Next Y
        End If

        I = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress2.Value + 16, 16)

        If I IsNot Nothing Then
            For Y As Integer = 0 To 15
                Dim Address As Double = StartAddress2.Value + Y
                Dim Hex_Value As String
                Hex_Value = Hex(Address)
                CellData2(0, Y + 16, Address.ToString + "-" + Hex_Value)
                CellData2(1, Y + 16, Hex(I(Y)).ToString)
                CellData2(2, Y + 16, I(Y).ToString)
                CellData2(3, Y + 16, "Edit")
                ' CellData2(3, Y, NCDLib.Math.DecToBinaryStringStandard(I(Y)))
                'CellData2(3, Y, NCDLib.Enterprise.ExtendedMemoryMenu(Address))
                CellData2(4, Y + 16, NCDLib.ExtendedMemoryMenu.GetDescription(Address + 16))
            Next Y
        End If


        GetTXRXData()
    End Sub

    Public Sub CellData2(x As Integer, Y As Integer, Dat As String)
        ByteTable(x, Y).Value = Dat
    End Sub
    Public Function GetCellData2(x As Integer, Y As Integer) As String
        GetCellData2 = ByteTable(x, Y).Value
    End Function

    Public Sub GetTXRXData()
        ' txtTransmitString.Text = NCDLib.GetLastTransmitString
        ' txtRecString.Text = NCDLib.GetLastReceivingString
    End Sub

    Private Sub ByteTable_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles ByteTable.CellContentClick
        If e.ColumnIndex = 3 Then
            If GetCellData2(3, e.RowIndex) = "Edit" Then
                'Pass Data from Main Form to Pop-Up
                Debug.Print("Button clicked")
                Dim frm As New frmBinaryEditor
                frm.GPIO = GetCellData2(2, e.RowIndex)
                If frm.ShowDialog = DialogResult.OK Then
                    'Pass Data from Pop-Up Bank to Main Form
                    CellData2(1, e.RowIndex, Hex(frm.GPIO).ToString)
                    CellData2(2, e.RowIndex, frm.GPIO)
                    'CellData2(3, e.RowIndex, NCDLib.Math.DecToBinaryStringStandard(frm.GPIO))
                    'GetTXRXData()
                End If

                Dim I(15) As Byte
                'Copy Data from Cells into Container Array
                For CellCount As Integer = 0 To 15
                    I(CellCount) = GetCellData2(2, CellCount)
                Next CellCount
                'Store Container Array at the Selected Start Address
                NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress2.Value, I)

                'Copy Data from Cells into Container Array
                For CellCount As Integer = 0 To 15
                    I(CellCount) = GetCellData2(2, CellCount + 16)
                Next CellCount
                'Store Container Array at the Selected Start Address
                NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress2.Value + 16, I)


            End If
        End If

    End Sub

    Private Sub ClearSector_Click(sender As Object, e As EventArgs) Handles ClearSector.Click
        'Setup a Container for Data
        Dim I(15) As Byte
        'Copy Data from Cells into Container Array
        For CellCount As Integer = 0 To 15
            I(CellCount) = 0 'GetCellData(2, CellCount)
        Next CellCount
        I(1) = &H13
        I(2) = &HA2
        'Store Container Array at the Selected Start Address
        NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress2.Value, I)

        'Copy Data from Cells into Container Array
        For CellCount As Integer = 0 To 15
            I(CellCount) = 0 'GetCellData(2, CellCount)
        Next CellCount
        'Store Container Array at the Selected Start Address
        NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress2.Value + 16, I)


        'Refresh Tables
        If FormLoading = False Then
            FillTableB()
        End If


    End Sub

    Private Sub SubscriberTable_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles SubscriberTable.CellContentClick
        If e.ColumnIndex = 0 Then
            Dim Address = ((GetCellData(0, e.RowIndex) - 1) * 32) + 8000
            StartAddress2.Value = Address
        End If

    End Sub

    Public Sub CellData(x As Integer, Y As Integer, Dat As String)
        SubscriberTable(x, Y).Value = Dat
    End Sub
    Public Function GetCellData(x As Integer, Y As Integer) As String
        GetCellData = SubscriberTable(x, Y).Value
    End Function


    Public Class MetaRecord
        Public Shared SensorType As String              'Sensor Type as Identified by the Sensor
        Public Shared Supported As Boolean = False      'Defines if the Sensor Record is Supported, by Default, it is NOT Supported unless a data record is present
        Public Shared SensorData(10) As String            'Defines the type of data the sensor will be reporting, Battery Voltage, Temperature in Degrees, Percentage
        Public Shared SensorDataOffset(10) As String      'Defines the Start Location in the Sensor Data Frame for the Relevant Data
        Public Shared LowerLimitsMinimum(10) As Integer
        Public Shared LowerLimitsMaximum(10) As Integer
        Public Shared UpperLimitsMinimum(10) As Integer
        Public Shared UpperLimitsMaximum(10) As Integer
        Public Shared SensorInterpretor(10) As String
        Public Shared SensorLowerLimit(10) As Integer
        Public Shared SensorUpperLimit(10) As Integer
        Public Shared MaximumParameters As Integer
    End Class

    Public Shared Function GetSensorMetaData(SensorType As Integer) As MetaRecord
        MetaRecord.Supported = False
        Dim rec As New MetaRecord
        Select Case SensorType
            Case 1 'Sensor Type
                MetaRecord.SensorType = "Temperature and Humidity Sensor"
                MetaRecord.Supported = True
                '---------------------------------------------------------------------------
                'Battery Level Configuration Record
                MetaRecord.SensorData(0) = "Battery Level"
                MetaRecord.SensorDataOffset(0) = 10
                MetaRecord.SensorInterpretor(0) = "Battery Voltage"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(0) = 0
                MetaRecord.SensorLowerLimit(0) = 100
                MetaRecord.LowerLimitsMaximum(0) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(0) = 0
                MetaRecord.SensorUpperLimit(0) = 200
                MetaRecord.UpperLimitsMaximum(0) = 255
                '---------------------------------------------------------------------------
                'Temperature Level Configuration Record
                MetaRecord.SensorData(1) = "Temperature"
                MetaRecord.SensorDataOffset(1) = 14
                MetaRecord.SensorInterpretor(1) = "Temperature Degrees"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(1) = 0
                MetaRecord.SensorLowerLimit(1) = 100
                MetaRecord.LowerLimitsMaximum(1) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(1) = 0
                MetaRecord.SensorUpperLimit(1) = 200
                MetaRecord.UpperLimitsMaximum(1) = 255
                '---------------------------------------------------------------------------
                'Humidity Level Configuration Record
                MetaRecord.SensorData(2) = "Humidity"
                MetaRecord.SensorDataOffset(2) = 18
                MetaRecord.SensorInterpretor(2) = "Percentage"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(2) = 0
                MetaRecord.SensorLowerLimit(2) = 100
                MetaRecord.LowerLimitsMaximum(2) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(2) = 0
                MetaRecord.SensorUpperLimit(2) = 200
                MetaRecord.UpperLimitsMaximum(2) = 255
                MetaRecord.MaximumParameters = 2

            Case 10 'Sensor Type
                MetaRecord.SensorType = "Temperature and Humidity Sensor"
                MetaRecord.Supported = True
                '---------------------------------------------------------------------------
                'Battery Level Configuration Record
                MetaRecord.SensorData(0) = "Battery Level"
                MetaRecord.SensorDataOffset(0) = 10
                MetaRecord.SensorInterpretor(0) = "Battery Voltage"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(0) = 0
                MetaRecord.SensorLowerLimit(0) = 100
                MetaRecord.LowerLimitsMaximum(0) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(0) = 0
                MetaRecord.SensorUpperLimit(0) = 200
                MetaRecord.UpperLimitsMaximum(0) = 255
                '---------------------------------------------------------------------------
                'Temperature Level Configuration Record
                MetaRecord.SensorData(1) = "Temperature"
                MetaRecord.SensorDataOffset(1) = 14
                MetaRecord.SensorInterpretor(1) = "Temperature Degrees"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(1) = 0
                MetaRecord.SensorLowerLimit(1) = 100
                MetaRecord.LowerLimitsMaximum(1) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(1) = 0
                MetaRecord.SensorUpperLimit(1) = 200
                MetaRecord.UpperLimitsMaximum(1) = 255
                '---------------------------------------------------------------------------
                'Humidity Level Configuration Record
                MetaRecord.SensorData(2) = "Humidity"
                MetaRecord.SensorDataOffset(2) = 18
                MetaRecord.SensorInterpretor(2) = "Percentage"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(2) = 0
                MetaRecord.SensorLowerLimit(2) = 100
                MetaRecord.LowerLimitsMaximum(2) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(2) = 0
                MetaRecord.SensorUpperLimit(2) = 200
                MetaRecord.UpperLimitsMaximum(2) = 255
                MetaRecord.MaximumParameters = 2

            Case 100 'Sensor Type
                MetaRecord.SensorType = "Temperature and Humidity Sensor"
                MetaRecord.Supported = True
                '---------------------------------------------------------------------------
                'Battery Level Configuration Record
                MetaRecord.SensorData(0) = "Battery Level"
                MetaRecord.SensorDataOffset(0) = 10
                MetaRecord.SensorInterpretor(0) = "Battery Voltage"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(0) = 0
                MetaRecord.SensorLowerLimit(0) = 100
                MetaRecord.LowerLimitsMaximum(0) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(0) = 0
                MetaRecord.SensorUpperLimit(0) = 200
                MetaRecord.UpperLimitsMaximum(0) = 255
                '---------------------------------------------------------------------------
                'Temperature Level Configuration Record
                MetaRecord.SensorData(1) = "Temperature"
                MetaRecord.SensorDataOffset(1) = 14
                MetaRecord.SensorInterpretor(1) = "Temperature Degrees"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(1) = 0
                MetaRecord.SensorLowerLimit(1) = 100
                MetaRecord.LowerLimitsMaximum(1) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(1) = 0
                MetaRecord.SensorUpperLimit(1) = 200
                MetaRecord.UpperLimitsMaximum(1) = 255
                '---------------------------------------------------------------------------
                'Humidity Level Configuration Record
                MetaRecord.SensorData(2) = "Humidity"
                MetaRecord.SensorDataOffset(2) = 18
                MetaRecord.SensorInterpretor(2) = "Percentage"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(2) = 0
                MetaRecord.SensorLowerLimit(2) = 100
                MetaRecord.LowerLimitsMaximum(2) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(2) = 0
                MetaRecord.SensorUpperLimit(2) = 200
                MetaRecord.UpperLimitsMaximum(2) = 255
                MetaRecord.MaximumParameters = 2

            Case 1000 'Sensor Type
                MetaRecord.SensorType = "Temperature and Humidity Sensor"
                MetaRecord.Supported = True
                '---------------------------------------------------------------------------
                'Battery Level Configuration Record
                MetaRecord.SensorData(0) = "Battery Level"
                MetaRecord.SensorDataOffset(0) = 10
                MetaRecord.SensorInterpretor(0) = "Battery Voltage"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(0) = 0
                MetaRecord.SensorLowerLimit(0) = 100
                MetaRecord.LowerLimitsMaximum(0) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(0) = 0
                MetaRecord.SensorUpperLimit(0) = 200
                MetaRecord.UpperLimitsMaximum(0) = 255
                '---------------------------------------------------------------------------
                'Temperature Level Configuration Record
                MetaRecord.SensorData(1) = "Temperature"
                MetaRecord.SensorDataOffset(1) = 14
                MetaRecord.SensorInterpretor(1) = "Temperature Degrees"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(1) = 0
                MetaRecord.SensorLowerLimit(1) = 100
                MetaRecord.LowerLimitsMaximum(1) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(1) = 0
                MetaRecord.SensorUpperLimit(1) = 200
                MetaRecord.UpperLimitsMaximum(1) = 255
                '---------------------------------------------------------------------------
                'Humidity Level Configuration Record
                MetaRecord.SensorData(2) = "Humidity"
                MetaRecord.SensorDataOffset(2) = 18
                MetaRecord.SensorInterpretor(2) = "Percentage"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(2) = 0
                MetaRecord.SensorLowerLimit(2) = 100
                MetaRecord.LowerLimitsMaximum(2) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(2) = 0
                MetaRecord.SensorUpperLimit(2) = 200
                MetaRecord.UpperLimitsMaximum(2) = 255
                MetaRecord.MaximumParameters = 2

            Case 10000 'Sensor Type
                MetaRecord.SensorType = "Temperature and Humidity Sensor"
                MetaRecord.Supported = True
                '---------------------------------------------------------------------------
                'Battery Level Configuration Record
                MetaRecord.SensorData(0) = "Battery Level"
                MetaRecord.SensorDataOffset(0) = 10
                MetaRecord.SensorInterpretor(0) = "Battery Voltage"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(0) = 0
                MetaRecord.SensorLowerLimit(0) = 100
                MetaRecord.LowerLimitsMaximum(0) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(0) = 0
                MetaRecord.SensorUpperLimit(0) = 200
                MetaRecord.UpperLimitsMaximum(0) = 255
                '---------------------------------------------------------------------------
                'Temperature Level Configuration Record
                MetaRecord.SensorData(1) = "Temperature"
                MetaRecord.SensorDataOffset(1) = 14
                MetaRecord.SensorInterpretor(1) = "Temperature Degrees"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(1) = 0
                MetaRecord.SensorLowerLimit(1) = 100
                MetaRecord.LowerLimitsMaximum(1) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(1) = 0
                MetaRecord.SensorUpperLimit(1) = 200
                MetaRecord.UpperLimitsMaximum(1) = 255
                '---------------------------------------------------------------------------
                'Humidity Level Configuration Record
                MetaRecord.SensorData(2) = "Humidity"
                MetaRecord.SensorDataOffset(2) = 18
                MetaRecord.SensorInterpretor(2) = "Percentage"
                'Lower Limits
                MetaRecord.LowerLimitsMinimum(2) = 0
                MetaRecord.SensorLowerLimit(2) = 100
                MetaRecord.LowerLimitsMaximum(2) = 255
                'Upper Limits
                MetaRecord.UpperLimitsMinimum(2) = 0
                MetaRecord.SensorUpperLimit(2) = 200
                MetaRecord.UpperLimitsMaximum(2) = 255
                MetaRecord.MaximumParameters = 2
        End Select
        Return rec
    End Function
    Private Sub SupportedSensors_SelectedIndexChanged(sender As Object, e As EventArgs) Handles SupportedSensors.SelectedIndexChanged
        Debug.Print(SupportedSensors.SelectedItem)
        ' Debug.Print(SupportedSensors.SelectedText)
        Debug.Print("Sensor Type Selected:" + ParseSensorType(SupportedSensors.SelectedItem).ToString)
        'Build a List of Supported Sensor Parameters

        If SupportedSensors.SelectedItem = "Do Not Monitor Any Sensors" Then
            DataSource.Items.Clear()
        Else
            GetSensorMetaData(ParseSensorType(SupportedSensors.SelectedItem))
            If MetaRecord.Supported = True Then
                DataSource.Items.Clear()
                DataSource.Items.Add("No Not Evaluate Anything")
                For Parameters = 0 To MetaRecord.MaximumParameters
                    DataSource.Items.Add(MetaRecord.SensorData(Parameters))
                Next
            End If
        End If

    End Sub
    Public Function ParseSensorType(Input As String) As Integer
        ParseSensorType = 0
        Dim TypeString As String = ""
        If Input <> "" Then
            If Input.Length > 5 Then
                'Debug.Print("Type:" + Mid(Input, 1, 4))
                If Mid(Input, 1, 4) = "Type" Then
                    For Count As Integer = 1 To Input.Length - 1
                        'Debug.Print("AAA>" + Mid(Input, 5 + Count, 1))
                        If Mid(Input, 5 + Count, 1) <> " " Then
                            TypeString = Mid(Input, 6, Count)
                        Else
                            GoTo Finished
                        End If
                        'Debug.Print("BBB>" + Mid(Input, 5, Count))
                    Next
Finished:
                    'Debug.Print("Result>>>>>" + TypeString)
                    ParseSensorType = Int(TypeString)
                End If
            End If
        End If
        Return ParseSensorType
    End Function

    Private Sub AD_ValueChanged(sender As Object, e As EventArgs) Handles AD1.ValueChanged, AD2.ValueChanged, AD3.ValueChanged, AD4.ValueChanged, AD5.ValueChanged, AD6.ValueChanged, AD7.ValueChanged, AD8.ValueChanged
        If FormLoading = True Then Exit Sub
        StoreUI()
    End Sub
    Public Sub StoreUI()

        Dim I1(15) As Byte
        Dim I2(15) As Byte

        I1 = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress2.Value, 16)
        I2 = NCDLib.Enterprise.Setup.EEPROM_Read(NCDComponent1, True, StartAddress2.Value + 16, 16)

        I1(0) = AD1.Value
        I1(1) = AD2.Value
        I1(2) = AD3.Value
        I1(3) = AD4.Value
        I1(4) = AD5.Value
        I1(5) = AD6.Value
        I1(6) = AD7.Value
        I1(7) = AD8.Value
        'I1(8) = SupportedSensors.SelectedIndex

        NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress2.Value, I1)
        NCDLib.Enterprise.Setup.EEPROM_Write(NCDComponent1, True, StartAddress2.Value + 16, I2)

        'Readback and Display changes
        FillTableB()

    End Sub
End Class